#include "adk_tcl_cli.h"

/*1: For all test cases 0: For ipsec encry/descry etc*/
extern test_config_t *testConfShm_p;
int Tcl_AppInit(Tcl_Interp *interp);
extern adk_status_t
adk_pal_dp_stats_print(void);

uint8_t ipv6_mode = 0; /*0:ipv4 1:ipv6*/
bool isIPsec =true;// false; /*0:Plaintext 1:ipsec*/
uint8_t expectedValue = 0;
uint8_t nhIndex = 0;

#define MAX_IP_INTF 20
/************************************************
 * Global Variables
 ***********************************************/
/* ADK Module Handles*/
adk_module_handle_t ethHdl, ipv4Hdl, ipv6Hdl, ipsecHdl;
adk_interface_handle_t bridge_if_handle;
adk_interface_handle_t svif[MAX_IP_INTF];
/* System Handle */
adk_sys_handle_t adkSysHdl;
adk_sys_flow_cache_stats_t sys_flow_cache_stats[ADK_MAX_NUM_CORES];

/* Ethernet global Variables */
adk_interface_handle_t ethIfHdl[MAX_NUM_ETH_IFS], ethVlanIfHdl[MAX_NUM_ETH_VIFS];
adk_flow_handle_t enetIpFlow[MAX_NUM_ETH_IP_FLOWS], ethEncapFlow[MAX_NUM_ETH_ENCAP_FLOWS];
uint32_t numEthIf, ethNumVlanIf, numEthIngFlows, numEthEncapFlows;

/*IPv4 global Variables */
adk_interface_handle_t ipv4IfHdl[MAX_NUM_IPV4_IFS], ipv4VirtIfHdl[MAX_NUM_IPV4_VIRT_IFS], ipv4TunIfHdl[MAX_NUM_IPV4_TUN_IFS];
adk_flow_handle_t ipv4EgFlowHdl[MAX_NUM_IPV4_EG_FLOWS], ipv4EgressFlowIpsec[MAX_NUM_IPV4_EG_IPSEC_FLOWS];
uint32_t numIpv4VRs, numIpv4Routes, numIpv4Ifs, numIpv4VirtIfs, numIPv4EgFlows, numIPv4TunIfs;
//adk_ip_vrd_handle_t ipv4vrdHdl[MAX_NUM_IPV4_VR];

/*IPv6 global Variables */
adk_interface_handle_t ipv6IfHdl[MAX_NUM_IPV6_IFS], ipv6TunIfHdl[MAX_NUM_IPV6_TUN_IFS];
adk_flow_handle_t ipv6EgFlowHdl[MAX_NUM_IPV6_EG_FLOWS], ipv6EgressFlowIpsec[MAX_NUM_IPV6_EG_IPSEC_FLOWS];
adk_flow_handle_t ipv6NhHdl[MAX_NUM_IPV6_IFS];
uint32_t numIpv6Ifs, numIPv6EgFlows, numIPv6TunIfs;

/* IPsec global Variables */
adk_handle_t secPolHdl[MAX_NUM_IPSEC_RULESETS][MAX_NUM_IPSEC_POLICIES], eSAHdl[MAX_NUM_IPSEC_EG_SAS], iSAHdl[MAX_NUM_IPSEC_ING_SAS];
uint32_t  secPolIdx[MAX_NUM_IPSEC_RULESETS];
uint32_t  spdRuleSets, numESAs, numISAs;

/**********PH handle ***********/
	adk_ethernet_mac_addr_t dest_mac = {0x9a, 0xdc, 0x9a, 0xf3, 0x64, 0xe8};
static void *
adk_ph_dev_exception(void *data);
static uint32_t
call_back_fn_eth_ph_dev(
uint8_t            moduleId,
void               *dp_Message,
void               *userParam
);
static uint32_t
call_back_fn_ipsec_ph_dev(
uint8_t            moduleId,
void               *dp_Message,
void               *userParam
);
typedef struct test_config_index_s {
    int             devId;
    int             queueId;
    int             ph_deviceIndex;
    test_config_t  *testConfShm_p;
} test_config_index_t;
test_config_index_t exceptionRock[NUM_PH_THREADS];
int ethNumExceptionsPhDev[ADK_PH_DEV_MAX_NUM_DEVICES];
int adk_ph_app_init(adk_sys_handle_t sysHandle);
adk_status_t map_domain_create(int vlan_id);
adk_status_t map_domain_create_vlan
(
uint16_t vlan_id,
int* bvi_vrd_rule_id
);
adk_status_t direct_traffic(void);
adk_ph_dev_cbfn_handle_t eth_cb_fn_handle;
adk_ph_dev_cbfn_handle_t ipsec_cb_fn_handle;
//void print_ipsec_stats(void);
adk_flow_handle_t enetArpFlow;
int read_num(void);

int read_num(void)
{
    uint32_t c;
    int num = 0;
    int dec;
    int sign = 0;

    while ( (c = getchar()) != '\n') {

        dec = c - '0';
        if ( dec >= 0 && dec <= 9) {
            num *= 10;
            num = (sign == 1 || num < 0) ? num - dec: num + dec;
        } else if (c == '-') {
            sign = 1;
        } else if (c == '+')
            sign = 0;

    }
    return num;
}
adk_status_t direct_traffic(void)
{
	adk_status_t ret = ADK_SUCCESS;
	uint16_t eth_dev = testConfShm_p->ethDev.tnPorts_p[0];
	uint32_t vsi_id = 0;
	uint32_t iPort = ADK_HLP_PORT_NUM_START;
	int portlist[NUM_PORTS];
	uint8_t  i=0;


	ret = adk_sys_eth_dev_vsi_get((uint16_t) eth_dev,
			&vsi_id);
	if (ret != ADK_SUCCESS)
	{
		printf("adk_sys_eth_dev_vsi_get failed\n");
		return ret;
	}

	for(i=0; i < NUM_PORTS; ++i)
	{
		uint32_t aging_timer = 1000 * 60 * ADK_ETH_DEFAULT_MAC_AGING_TIMER; 
		ret = config_mac_aging((iPort+i), aging_timer);
		if (ret != ADK_SUCCESS)
		{
			printf("Failed to set MAC aging timer for port\n");
			return ret;
		}
		portlist[i] = iPort+i;
	}
	/*Creating Flooding domain for broadcast pkts*/
	ret = ies_domain_add_ports_to_floodset(ADK_HLP_SWITCH_ID, BG_ID,
			IES_DOMAIN_FLOODSET_UNICAST,NUM_PORTS, portlist);
	if (ret != IES_OK)
	{
		printf("Adding port 12 & 13 to UNICAST floodset failed\n");
		return ret;
	}

	ret = ies_domain_add_ports_to_floodset(ADK_HLP_SWITCH_ID, BG_ID,
			IES_DOMAIN_FLOODSET_MULTICAST,NUM_PORTS, portlist);
	if (ret != IES_OK)
	{
		printf("Adding port 12 & 13 to MULTICAST floodset failed\n");
		return ret;
	}
	/*Creating Flooding domain for broadcast pkts*/
	ret = ies_domain_add_ports_to_floodset(ADK_HLP_SWITCH_ID, BG_ID,
			IES_DOMAIN_FLOODSET_BROADCAST,NUM_PORTS, portlist);
	if (ret != IES_OK)
	{
		printf("Adding port 12 & 13 to BROADCAST floodset failed\n");
		return ret;
	}
	return ret;
} /* direct traffic */
adk_status_t map_domain_create_vlan ( uint16_t vlan_id, int* bvi_vrd_rule_id)
{
    uint32_t iPort = ADK_HLP_PORT_NUM_START;
    adk_status_t ret = ADK_SUCCESS;
    uint16_t   i;

    if(ADK_SUCCESS != (ret = ies_vlan_create_helper(vlan_id)))
    {
        printf("Failed to create VLAN using IES API\n");
        return ret;
    }

    for(i=0; i < NUM_PORTS; ++i)
    {
        domain_mapper_tbl_rule_attr_t domain_mapper_rule =
        {
            .port = (iPort+i),
            .vlan_id = vlan_id,
            .eth_sw_domain = BG_ID,
            .vrd_id = VRD_ID,
            .enable_mac_learning = true,
            .is_ivl = false
        };

        ret = ies_vlan_port_add_helper(vlan_id, iPort+i);
        if (ret != ADK_SUCCESS)
        {
            printf("Failed to add vlan to port for svif-intf\n");
            return ret;
        }

        ret = domain_mapper_tbl_rule_add(&domain_mapper_rule,
                               &bvi_vrd_rule_id[i]);
        if (ret != ADK_SUCCESS)
        {
            printf("Failed to add BVI VRD HOS rule for sub-intf\n");
            return ret;
        }
    }
 
    for(i=0; i < NUM_PORTS; ++i)
    {
        domain_mapper_tbl_rule_attr_t domain_mapper_rule =
        {
            .port = (iPort+i),
            .vlan_id = 0,
            .eth_sw_domain = BG_ID,
            .vrd_id = VRD_ID,
            .enable_mac_learning = true,
            .is_ivl = false
        };

        ret = domain_mapper_tbl_rule_add(&domain_mapper_rule,
                               &bvi_vrd_rule_id[i]);
        if (ret != ADK_SUCCESS)
        {
            printf("Failed to add BVI VRD HOS rule for sub-intf\n");
            return ret;
        }
    }
    return ret;
}
adk_status_t map_domain_create(int vlan_id)
{
    adk_status_t ret = ADK_SUCCESS;

    if(ADK_SUCCESS != (ret = map_domain_create_vlan(vlan_id, bvi_vrd_rule_id_vlan)))
    {
        printf("map domain create failed for vlan %d", vlan_id);
        return ret;
    }

    return ret;
}
static int listCommands (ClientData clientdata, Tcl_Interp *interp, int __attribute__((unused)) argc, char **argv)
{
    printf("\n Here is the list of currently supported commands - \n");
    /* create commands for Ethernet ADK functionality */
    printf("\n For Ethernet - \n");
    printf("\t\tcreate-eth-bridge-interface \n");
    printf("\t\tcreate-eth-switch-virtual-interface \n");
    printf("\t\tcreate-eth-ingress-flow \n");
    printf("\t\tadd-eth-arp-entry \n");
    printf("\t\tadd-eth-neigh-entry \n");

    /* create commands for IPv4 ADK functionality */
    printf("\n For IPv4 - \n");
    printf("\t\tcreate-ip-interface\n");
    printf("\t\tadd-ip-ingress-classifier-rule\n");
    printf("\t\tadd-ip-ingress-classifier-build\n");
    printf("\t\tadd-ip-route\n");
    /* create commands for IPsec ADK functionality */
    printf("\n For IPsec - \n");
    printf("\t\tadd-ipsec-sp\n");
    printf("\t\tadd-ipsec-sp-in\n");
    printf("\t\tadd-ipsec-sa\n");

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int createEthBridgeInterface(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    int i;
   
    adk_ethernet_mac_subnet_t wc_mac = {{0x9a, 0xdc, 0x9a, 0xf3, 0x64, 0xe8},
                                        48};
	adk_ethernet_bridge_intf_attr_t bridge_intf_attr = 
    {
        1, {0x9a, 0xdc, 0x9a, 0xf3, 0x64, 0xe8},
        BG_ID
    };
	printf("createEthBridgeInterface:All cases\n");
    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: create-eth-bridge-interface <> \n");
        return TCL_OK;
    }
    /*
    * Create Ethernet interfaces on ethernet ports.
    * The loop below will also setup the IP address for the created
    * ethernet interfaces.
    */
    for (i = 0; i < NUM_PORTS; i++)
    {
        host_port_nums[i] = testConfShm_p->ethDev.hostPorts_p[i];
        tn_port_nums[i] = testConfShm_p->ethDev.tnPorts_p[i];
        printf("ADK: host_port_nums[%d] %u tn_port_nums[%d] %u\n",
                i, host_port_nums[i], i, tn_port_nums[i]);

        /* If host ports are not available, pass some valid number, different
         * from TN port number, for configuration to go through */
        if (testConfShm_p->ethDev.numHostPorts == 0)
            host_port_nums[i] = testConfShm_p->ethDev.tnPorts_p[i] + NUM_PORTS;

        /* vETH -> NIC  port mapping */
        retVal = adk_pal_veth_port_to_nic_port_mapping(adkSysHdl,
                                                        host_port_nums[i],
                                                        tn_port_nums[i]);
        if (retVal != ADK_SUCCESS)
        {
            printf("Failed to do NIC to vETH port mapping for PAL\n");
            return (1);
        }
    }


    if(ADK_SUCCESS != direct_traffic())
        return -1;

    bridge_intf_attr.eth_dev_id = tn_port_nums[0];
    retVal = adk_ethernet_bridge_interface_create(ethHdl, &bridge_intf_attr, &bridge_if_handle);
    printf("Created bridge if handle %p\n",bridge_if_handle);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to create interface handle\n");
        return (1);
    }
    retVal = adk_ethernet_bridge_interface_mac_addr_modify(ethHdl, wc_mac.mac, bridge_if_handle);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to modify the MAC for bridge interface\n");
        return (1);
	}
    /*We need vport created on top of ethdev and vdev_id,
      get it from the testConfShm_p*/
    cpk_qos_sl_sched_create(adkSysHdl,
                            testConfShm_p->ethDev.vport_id,
                            testConfShm_p->ethDev.vdev_port_id,
                            bridge_intf_attr.eth_dev_id,
                            bridge_if_handle);

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int createEthSwitchVirtualInterface(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ethernet_switch_virtual_if_data_t svif_data;
    int i = 1, vlanId = 0, index=0;
     
    if (argc < 3)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: create-eth-switch_vritual_interface vlan-id <> \n");
        return TCL_OK;
    }

    if(0 == (strcmp("vlan-id",argv[i++])))
        vlanId = atoi(argv[i++]);

    if(0 == (strcmp("index",argv[i++])))
        index = atoi(argv[i++]);

    printf("vlan-id:%d and index:%d\n",vlanId, index);
    svif_data.bridge_if_handle = bridge_if_handle;
    svif_data.vlan_id = vlanId;
    retVal = adk_ethernet_switch_virtual_if_create(ethHdl,&svif_data, &svif[index]);
    printf("Created eth switch virtual if handle svif:%p->svif[%d]\n",svif[index], index);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createEthSwitchVirtualInterface\n");
        return (1);
    }

    if(ADK_SUCCESS != map_domain_create(vlanId))
    {
        printf("Failed to map domain\n");
        return (-1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int createEthIngressFlow(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    //adk_flow_handle_t enetArpFlow; 
    adk_ethernet_mac_subnet_t wc_mac = {{0x9a, 0xdc, 0x9a, 0xf3, 0x64, 0xe8},
                                        48};
    adk_qos_policing_params_t policing_params_arp = {0};
    adk_qos_policer_handle_t  policing_handle_arp;


    adk_ethernet_ingress_flow_data_t arp_flow_data = {
        ADK_ETHERNET_FLOW_MASK_ETYPE,
        0x806, wc_mac, ADK_ETHERNET_INTERFACE_TYPE_BRIDGE
    };
    adk_ethernet_ingress_flow_action_t arp_flow_action =
    {
        ADK_ETHERNET_ASSOCIATION_RULE_TYPE_SEND_TO_HOST, 0, NULL
    };
    
    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: create-eth-ingress_flow <> \n");
        return TCL_OK;
    }

	policing_params_arp.type = ADK_QOS_POLICE_TYPE_SRTCM;
    policing_params_arp.cir = 10;
    //policing_params_arp.pir = 10;
    policing_params_arp.ebs = 10;
    policing_params_arp.cbs = 10;
    retVal = adk_qos_policing_flow_create(adkSysHdl, &policing_params_arp, &policing_handle_arp);
    if (retVal != ADK_SUCCESS)
    {
		printf("Failed to create Policing flow \n");
        return (1);
    }
    else
    {
		printf("Created Policing flow - \n");
        printf("Policing type :%d \n", policing_params_arp.type);
        printf("CIR(bps)    :%lu \n", policing_params_arp.cir);
        //printf("PIR(bps)    :%lu \n", policing_params_arp.pir);
        printf("CBS(bytes)  :%u \n", policing_params_arp.cbs);
        printf("PBS(bytes)  :%u \n", policing_params_arp.ebs);
        printf("Created Policing flow handle - %"ADKPRIh"\n", policing_handle_arp);
    }

    printf("Adding bridge ethenret interface flow with policing\n");
    arp_flow_action.enablePolicing = 1;
    arp_flow_action.policingHandle = policing_handle_arp;

    arp_flow_data.mask = ADK_ETHERNET_FLOW_MASK_ETYPE | ADK_ETHERNET_FLOW_MASK_DMAC;
    retVal = adk_ethernet_ingress_flow_create(ethHdl,
                                               &arp_flow_data,
                                               &arp_flow_action,
                                               &enetArpFlow);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createEthIngressFlow\n");
        return (1);
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int addEthNeighEntry(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ethernet_ipv6_addr_t ip_addr;
	adk_ethernet_mac_addr_t macAddr = {0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0};
	int i = 1, j = 0; 
    
    if (argc < 5)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-eth-arp_entry next-hop <> mac-address <> \n");
        return TCL_OK;
    }

    if(0 == (strcmp("next-hop",argv[i++])))
    {
        inet_pton(AF_INET6, (char*)argv[i++], &ip_addr);
        ip_addr.addr[0] = ntohl(ip_addr.addr[0]);
        ip_addr.addr[1] = ntohl(ip_addr.addr[1]);
        ip_addr.addr[2] = ntohl(ip_addr.addr[2]);
        ip_addr.addr[3] = ntohl(ip_addr.addr[3]);
		printf("addEthArpEntry:ip_addr %x %x %x %x\n", ip_addr.addr[0],ip_addr.addr[1],ip_addr.addr[2],ip_addr.addr[3]);
    }
    if(0 == (strcmp("mac-address",argv[i++])))
    {
        for ( j = 0; j < 6; j++)
        {
            long b = strtol((const char*)argv[i] + (3 * j), (char **) NULL, 16);
             macAddr[j] = (char)b;
        }

        if ( macAddr[0] == 0 && macAddr[1] == 0 &&
                 macAddr[2] == 0 &&  macAddr[3] == 0 &&
                 macAddr[4] == 0 &&  macAddr[5] == 0)
        {
            printf("Incorrect MAC Address 0x00\n");
            exit(0);

        }
        else if (macAddr[0] == 0xff && macAddr[1] == 0xff &&
                macAddr[2] == 0xff && macAddr[3] == 0xff &&
                macAddr[4] == 0xff && macAddr[5] == 0xff)
        {
            printf("Incorrect MAC Address 0xff\n");
            exit(0);
        }
        i++;
		printf("addEthNeighEntry: macAddr %x \n", macAddr[0]);
    }
    retVal = adk_ethernet_neighbor_entry_add(ethHdl, ip_addr,
						macAddr,
						ADK_ETHERNET_NEIGHBOR_REACHABLE);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to addEthArpEntry\n");
        return (1);
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int addEthArpEntry(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ethernet_ipv4_addr_t ip_addr;
	adk_ethernet_mac_addr_t macAddr = {0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0};
	int i = 1, j = 0; 
    
    if (argc < 5)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-eth-arp_entry next-hop <> mac-address <> \n");
        return TCL_OK;
    }

    if(0 == (strcmp("next-hop",argv[i++])))
    {
        inet_pton(AF_INET, (char*)argv[i++], &ip_addr);
        ip_addr = ntohl(ip_addr);
		printf("addEthArpEntry:ip_addr %x \n", ip_addr);
    }
    if(0 == (strcmp("mac-address",argv[i++])))
    {
        for ( j = 0; j < 6; j++)
        {
            long b = strtol((const char*)argv[i] + (3 * j), (char **) NULL, 16);
             macAddr[j] = (char)b;
        }

        if ( macAddr[0] == 0 && macAddr[1] == 0 &&
                 macAddr[2] == 0 &&  macAddr[3] == 0 &&
                 macAddr[4] == 0 &&  macAddr[5] == 0)
        {
            printf("Incorrect MAC Address 0x00\n");
            exit(0);

        }
        else if (macAddr[0] == 0xff && macAddr[1] == 0xff &&
                macAddr[2] == 0xff && macAddr[3] == 0xff &&
                macAddr[4] == 0xff && macAddr[5] == 0xff)
        {
            printf("Incorrect MAC Address 0xff\n");
            exit(0);
        }
        i++;
		printf("addEthArpEntry: macAddr %x \n", macAddr[0]);
    }
    retVal = adk_ethernet_arp_entry_add(ethHdl, ip_addr,
						macAddr,
						ADK_ETHERNET_NEIGHBOR_REACHABLE);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to addEthArpEntry\n");
        return (1);
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int addIpv6NextHopAdd(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ipv6_next_hop_attr_t nextHopAttr;
    int i = 1;

    if (argc < 3)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipv6-next-hop-add addr <> index <> \n");
        return TCL_OK;
    }

    memset(&nextHopAttr, 0x00, sizeof(nextHopAttr));
    if(0 == (strcmp("addr",argv[i++])))
    {
        inet_pton(AF_INET6, (char*)argv[i++], &nextHopAttr.ipv6Addr_p.addr);
        nextHopAttr.ipv6Addr_p.addr[0] = ntohl(nextHopAttr.ipv6Addr_p.addr[0]);
        nextHopAttr.ipv6Addr_p.addr[1] = ntohl(nextHopAttr.ipv6Addr_p.addr[1]);
        nextHopAttr.ipv6Addr_p.addr[2] = ntohl(nextHopAttr.ipv6Addr_p.addr[2]);
        nextHopAttr.ipv6Addr_p.addr[3] = ntohl(nextHopAttr.ipv6Addr_p.addr[3]);
    }
    if(0 == (strcmp("index",argv[i++])))
        nextHopAttr.interfaceHandle = ipv6IfHdl[atoi(argv[i++])];

    printf("Addded NextHop IPv6 addr - %x %x %x %x\n", nextHopAttr.ipv6Addr_p.addr[0], nextHopAttr.ipv6Addr_p.addr[1],
                     nextHopAttr.ipv6Addr_p.addr[2], nextHopAttr.ipv6Addr_p.addr[3]);

    retVal = adk_ipv6_next_hop_add(ipv6Hdl, &nextHopAttr, &ipv6NhHdl[nhIndex]);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to addIpv6NextHopAdd\n");
        return (1);
    }
    nhIndex++;
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpv6VirtualAddr(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ipv6_addr_t Ipv6Addr;
    int i = 1;

    if (argc < 2)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipv6-virtual-addr addr <> \n");
        return TCL_OK;
    }

    memset(&Ipv6Addr, 0x00, sizeof(Ipv6Addr));
    if(0 == (strcmp("addr",argv[i++])))
    {
        inet_pton(AF_INET6, (char*)argv[i++], &Ipv6Addr.addr);

        Ipv6Addr.addr[0] = ntohl(Ipv6Addr.addr[0]);
        Ipv6Addr.addr[1] = ntohl(Ipv6Addr.addr[1]);
        Ipv6Addr.addr[2] = ntohl(Ipv6Addr.addr[2]);
        Ipv6Addr.addr[3] = ntohl(Ipv6Addr.addr[3]);
    }
    printf("Addded virtual IPv6 addr - %x %x %x %x\n", Ipv6Addr.addr[0], Ipv6Addr.addr[1], Ipv6Addr.addr[2], Ipv6Addr.addr[3]);
    retVal = adk_ipv6_virtual_ip_addr_add(ipv6Hdl, &Ipv6Addr);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

/*IPv6*/
static int createIpv6Interface(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ipv6_interface_t ipv6IfConfig;
    int i = 1, index = 0;
 
    if (argc < 8)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: create-ipv6-if addr <> prefix-width <> mtu <> handle <> \n");
        return TCL_OK;
    }

    memset(&ipv6IfConfig, 0x00, sizeof(ipv6IfConfig));
    if(0 == (strcmp("addr",argv[i++])))
    {
        inet_pton(AF_INET6, (char*)argv[i++], &ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr);

        ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[0] = ntohl(ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[0]);
        ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[1] = ntohl(ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[1]);
        ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[2] = ntohl(ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[2]);
        ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[3] = ntohl(ipv6IfConfig.ipv6AddrPrefix.Ipv6Addr.addr[3]);
    }
    if(0 == (strcmp("prefix-width",argv[i++])))
    {
        ipv6IfConfig.ipv6AddrPrefix.prefixLength = atoi(argv[i++]);
    }
    if(0 == (strcmp("mtu",argv[i++])))
    {
        ipv6IfConfig.mtu = atoi(argv[i++]);
    }
    if(0 == (strcmp("handle",argv[i++]))) 
    {
		if(0 == (strcmp("bridge",argv[i])))
		{
			printf("assigning layer2InterfaceHandle as bridge if handle %p\n",bridge_if_handle);
			ipv6IfConfig.layer2InterfaceHandle = bridge_if_handle;
		}
		else if(0 == (strcmp("svif",argv[i])))
		{
            i++;
            if(0 == (strcmp("index",argv[i++])))
                index = atoi(argv[i++]);
            else printf ("\nIndex in SVIF handle array is required for mapping between Eth intf and IP intf\n");
            printf("assigning layer2InterfaceHandle as svif[%d]= %p",index,&svif[index]);
			ipv6IfConfig.layer2InterfaceHandle = svif[index];
		}
    }
    printf("layer2InterfaceHandle valud is %p\n",ipv6IfConfig.layer2InterfaceHandle);
    ipv6IfConfig.mask = /*ADK_IPV6_INTERFACE_QOS_ENABLE | */
            ADK_IPV6_INTERFACE_FORWARDING_ENABLE;
    retVal = adk_ipv6_interface_create(ipv6Hdl, &ipv6IfConfig, &ipv6IfHdl[numIpv6Ifs]);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }
    printf("Created IPv6 interface-%d, handle - %"ADKPRIh"\n", numIpv6Ifs, ipv6IfHdl[numIpv6Ifs]);
	numIpv6Ifs++;
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int addIpv6IngressClassifierRule(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ipv6_ingress_classifier_rule_t rule = {0};
    adk_ipv6_ingress_classifier_action_t action = {0};
    adk_ipv6_addr_prefix_t srcIp;
   	int i = 1;
 
    if (argc < 11)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipv6_ingress_classifier_rule addr <> prefix-width <> action <>  em-recv-q-id<> rule-mask <>\n");
        return TCL_OK;
    }
	
    if(0 == (strcmp("src-addr",argv[i++])))
    {
        inet_pton(AF_INET6, (char*)argv[i++], &srcIp.Ipv6Addr.addr);
        srcIp.Ipv6Addr.addr[0] = ntohl(srcIp.Ipv6Addr.addr[0]);
        srcIp.Ipv6Addr.addr[1] = ntohl(srcIp.Ipv6Addr.addr[1]);
        srcIp.Ipv6Addr.addr[2] = ntohl(srcIp.Ipv6Addr.addr[2]);
        srcIp.Ipv6Addr.addr[3] = ntohl(srcIp.Ipv6Addr.addr[3]);
    }
    if(0 == (strcmp("prefix-width",argv[i++])))
	{
        rule.srcAddr.prefixLength = atoi(argv[i++]);
	}
    if(0 == (strcmp("action",argv[i++])))
	{
        action.action = atoi(argv[i++]);/*ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO*/
	}
    if(0 == (strcmp("em-recv-q-id",argv[i++])))
	{
        action.eventMachineQueueId = atoi(argv[i++]);/*EM_RECV_QUEUE_ID*/
	}
    if(0 == (strcmp("rule-mask",argv[i++])))
	{
    	rule.ruleMask  = atoi(argv[i++]);/*ADK_IP_ING_CLASSIFIER_SRC_ADDR_MASK*/
	}
    rule.ruleMask = 0;
    memcpy(rule.srcAddr.Ipv6Addr.addr, srcIp.Ipv6Addr.addr, 16);
    retVal = adk_ipv6_ingress_classifier_rule_add(ipv6Hdl, &rule, &action, 0); 
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to  adk_ipv6_ingress_classifier_rule_add \n");
        return (1);
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpv6IngressClassifierBuild(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    
    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ip_ingress_classifier_build <> \n");
        return TCL_OK;
    }

    retVal = adk_ipv6_ingress_classifier_build(ipv6Hdl); 
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpv6ConfSupportProto(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	uint8_t protocol = 17;
	int i = 1;
    if (argc < 3)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipv6-proto-support proto <>\n");
        return TCL_OK;
    }
    if(0 == (strcmp("proto",argv[i++])))
	{
        protocol = atoi(argv[i++]);/*ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO*/
		printf("Protocol %d\n", protocol);
	}
    retVal = adk_ipv6_configure_supported_protocol(ipv6Hdl, protocol);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to addIpv6ConfSupportProto\n");
        return (1);
    }else {
		 printf("adk_ipv6_configure_supported_protocol called successfully \n");
	}
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpv6ReassemblyTimeout(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    int i = 1;
	uint32_t timeval=0;

    if (argc < 3)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipv6-reassembly-timeout timeoutInMilliSec <> \n");
        return TCL_OK;
    }
    if(0 == (strcmp("timeoutInMilliSec",argv[i++])))
    {
		timeval = atoi(argv[i++]);
        printf ("\nTimtout in MiliSec is : 0x%x \n", timeval);
    }
	retVal = adk_ipv6_reassembly_timeout_config (
					ipv6Hdl,timeval, 10, 500) ;
			if (retVal != ADK_SUCCESS)
			{
					printf("Failed to configure reassembly timeout \n");
					return (1);
			}
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

/*IPv4*/
static int createIpInterface(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ip_interface_t ipv4IfConfig;
    int i = 1, index = 0;
    
    if (argc < 8)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: create-ipv4-if addr <> prefix-width <> mtu <> handle <> \n");
        return TCL_OK;
    }

    memset(&ipv4IfConfig, 0x00, sizeof(ipv4IfConfig));
    if(0 == (strcmp("addr",argv[i++])))
    {
        inet_pton(AF_INET, (char*)argv[i++], &ipv4IfConfig.ipAddrPrefix.addr);
        ipv4IfConfig.ipAddrPrefix.addr = ntohl(ipv4IfConfig.ipAddrPrefix.addr);
    }
    if(0 == (strcmp("prefix-width",argv[i++])))
    {
        ipv4IfConfig.ipAddrPrefix.prefixWidth = atoi(argv[i++]);
    }
    if(0 == (strcmp("mtu",argv[i++])))
    {
        ipv4IfConfig.mtu = atoi(argv[i++]);
    }
    if(0 == (strcmp("handle",argv[i++]))) 
    {
		if(0 == (strcmp("bridge",argv[i])))
		{
			printf("assigning layer2InterfaceHandle as bridge if handle %p\n",bridge_if_handle);
			ipv4IfConfig.layer2InterfaceHandle = bridge_if_handle;
		}
		else if(0 == (strcmp("svif",argv[i++])))
		{
				if(0 == (strcmp("index",argv[i++])))
					index = atoi(argv[i]);
				else printf ("\nIndex in SVIF handle array is required for mapping between Eth intf and IP intf\n");
			printf("Assigning layer2InterfaceHandle as svif:%p->svif[%d]",svif[index],index);
			ipv4IfConfig.layer2InterfaceHandle = svif[index];
		}
    }
    printf("layer2InterfaceHandle valud is %p\n",ipv4IfConfig.layer2InterfaceHandle);
    ipv4IfConfig.ipIntfAttr |= ADK_IP_INTERFACE_MASK_QOS_ENABLE ;
    retVal = adk_ip_interface_create(ipv4Hdl, &ipv4IfConfig, &ipv4IfHdl[numIpv4Ifs]);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }

	//if( index == 0) {
    parent_tm_node_info_p = get_sl_node_info_from_enet_if(bridge_if_handle);

    if ((NULL != parent_tm_node_info_p) && (parent_tm_node_info_p->node_id)) {
	if(fl_created == 0) {
		/*Create FL topology for the IP interface created*/
		cpk_qos_fl_sched_create(adkSysHdl,
					testConfShm_p->ethDev.vport_id,
					testConfShm_p->ethDev.vdev_port_id,
                    parent_tm_node_info_p->node_id,
                    tn_port_nums[0],
					bridge_if_handle,
                    ipv4IfHdl[numIpv4Ifs]);
		fl_created = 1;
		qos_queue = g_fl_map[0].tx_queues[0];
	}
    }
	//}
    printf("Created IP interface-%d, handle - %"ADKPRIh"\n", numIpv4Ifs, ipv4IfHdl[numIpv4Ifs]);
	numIpv4Ifs++;
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpIngressClassifierRule(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ip_ingress_classifier_rule_t rule = {0};
    adk_ip_ingress_classifier_action_t action = {0};
    adk_ip_addr_prefix_t srcIp;
   	int i = 1;
 
    if (argc < 11)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ip_ingress_classifier_rule addr <> prefix-width <> action <>  em-recv-q-id<> rule-mask <>\n");
        return TCL_OK;
    }
	
    if(0 == (strcmp("src-addr",argv[i++])))
    {
        inet_pton(AF_INET, (char*)argv[i++], &srcIp.addr);
        srcIp.addr = ntohl(srcIp.addr);
    }
    if(0 == (strcmp("prefix-width",argv[i++])))
	{
        srcIp.prefixWidth= atoi(argv[i++]);
	}
    if(0 == (strcmp("action",argv[i++])))
	{
        action.action = atoi(argv[i++]);/*ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO*/
	}
    if(0 == (strcmp("em-recv-q-id",argv[i++])))
	{
        action.actionAttr_u.eventMachineQueueId = atoi(argv[i++]);/*EM_RECV_QUEUE_ID*/
	}
    if(0 == (strcmp("rule-mask",argv[i++])))
	{
    	rule.ruleMask  = atoi(argv[i++]);/*ADK_IP_ING_CLASSIFIER_SRC_ADDR_MASK*/
	}
    rule.ruleMask = rule.ruleMask;
    rule.srcAddr = srcIp;
    retVal = adk_ip_ingress_classifier_rule_add(ipv4Hdl, &rule, &action, 0); 
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpIngressClassifierBuild(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    
    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ip_ingress_classifier_build <> \n");
        return TCL_OK;
    }

    retVal = adk_ip_ingress_classifier_build(ipv4Hdl); 
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpConfSupportProto(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	uint8_t protocol = 17;
	int i = 1;
    if (argc < 3)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ip-proto-support proto <>\n");
        return TCL_OK;
    }
    if(0 == (strcmp("proto",argv[i++])))
	{
        protocol = atoi(argv[i++]);/*ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO*/
		printf("Protocol %d\n", protocol);
	}
    retVal = adk_ip_configure_supported_protocol(ipv4Hdl, protocol);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to addIpConfSupportProto\n");
        return (1);
    }else {
		 printf("adk_ip_configure_supported_protocol called successfully \n");
	}
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int ipv6Logging(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    int level=ADK_LOG_LEVEL_DEBUG;
    int i=1;

    if (argc < 2)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: ipv6-logging level (31,15) 31=ADK_SEV_LEVEL_DEBUG, 15 = ADK_SEV_LEVEL_INFO, and so on \n");
        return TCL_OK;
    }
    if(0 == (strcmp("level",argv[i++])))
	{
        level = atoi(argv[i++]);
	}
    retVal =  adk_ipv6_log_level_set(ipv6Hdl, level);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to configure adk_ipv6_log_level_set API() \n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
} /*ipv6Logging*/

static int ipBypassIPsec(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	bool bypass=true;
	int i=1;

    if (argc < 2)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: ip-bypass-ipsec bypass (1,0) 1=bypass ipsec, 0 = ipsec enabled \n");
        return TCL_OK;
    }
    if(0 == (strcmp("bypass",argv[i++])))
	{
        bypass = atoi(argv[i++]);
	}
    retVal =  adk_sys_ipsec_bypass_config(adkSysHdl, bypass);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to configure adk_ip_ipsec_bypass API() \n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
} /* ipBypassIPsec */
/*PBR*/
static int adkIpPbrConfDefRouteTable(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;

    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: adk-ip-pbr-conf-def-route-table \n");
        return TCL_OK;
    }

	retVal = adk_ip_pbr_configure_default_route_table(ipv4Hdl, 2);
    if (retVal != ADK_SUCCESS)
    {
		printf("Failed to configure default route table\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int adkIpv6PbrConfDefRouteTable(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    int i=1;
    uint8_t def_table_id =0;

    if (argc < 2)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: adk-ip-pbr-conf-def-route-table \n");
        return TCL_OK;
    }

    if(0 == (strcmp("def-table-id",argv[i++])))
    {
        def_table_id = atoi(argv[i]);
    }
    printf("Setting Ipv6 default table : %u\n", def_table_id);
	retVal = adk_ipv6_pbr_configure_default_route_table(ipv6Hdl, def_table_id);
    if (retVal != ADK_SUCCESS)
    {
		printf("Failed to configure default route table\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int adkIpv6PbrAdd(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ipv6_pbr_info_t pbrInfo;
	int i = 1;

    if (argc < 7)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: adk-ipv6-pbr-add src-addr <> src-prefix-width <> \
				 route-table-id <>\n");
        return TCL_OK;
    }
    memset(&pbrInfo, 0x0, sizeof(adk_ipv6_pbr_info_t));
    if(0 == (strcmp("src-addr",argv[i++])))
    {
        inet_pton(AF_INET6, (char*)argv[i++], &pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr);
        pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[0] = ntohl(pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[0]);
        pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[1] = ntohl(pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[1]);
        pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[2] = ntohl(pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[2]);
        pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[3] = ntohl(pbrInfo.pbrRule.srcAddrInfo.Ipv6Addr.addr[3]);
    }
    if(0 == (strcmp("src-prefix-width",argv[i++])))
    {
	    pbrInfo.pbrRule.srcAddrInfo.prefixLength = atoi(argv[i++]);
    }
    if(0 == (strcmp("route-table-id",argv[i++])))
    {
		pbrInfo.pbrAction.routeTableId = atoi(argv[i++]);
    }

    pbrInfo.pbrRule.PBR_RuleMask = ADK_IPV6_PBR_SRC_ADDR_MASK;

    retVal = adk_ipv6_pbr_add_policy (ipv6Hdl, 0, &pbrInfo);
    if (retVal != ADK_SUCCESS)
    {
		printf("adk_ipv6_pbr_add_policy failed\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int adkIpv6PbrCommit(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;

    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: adk-ipv6-pbr-commit\n");
        return TCL_OK;
    }
	retVal = adk_ipv6_pbr_commit(ipv6Hdl);
    if (retVal != ADK_SUCCESS)
    {
		printf("adk_ip_pbr_commit failed\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int adkIpPbrAddPolicy(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	adk_ip_pbr_info_t pbrInfo;
    adk_ip_addr_prefix_t srcIp;
	int i = 1;

    if (argc < 7)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: adk-ip-pbr-conf-def-route-table src-addr <> src-prefix-width <> \
				 route-table-id <>\n");
        return TCL_OK;
    }
    if(0 == (strcmp("src-addr",argv[i++])))
    {
        inet_pton(AF_INET, (char*)argv[i++], &srcIp.addr);
        srcIp.addr = ntohl(srcIp.addr);
		pbrInfo.pbrRule.srcAddrInfo.addr = srcIp.addr;
    }
    if(0 == (strcmp("src-prefix-width",argv[i++])))
    {
		pbrInfo.pbrRule.srcAddrInfo.prefixWidth = atoi(argv[i++]);
    }
    if(0 == (strcmp("route-table-id",argv[i++])))
    {
		pbrInfo.pbrAction.routeTableId = atoi(argv[i++]);
    }

    pbrInfo.pbrRule.pbrRuleMask = ADK_IP_PBR_SRC_ADDR_MASK;
    //pbrInfo.pbrRule.srcAddrInfo.addr = if_addr_list[0];
    //pbrInfo.pbrRule.srcAddrInfo.prefixWidth = 16;
    //pbrInfo.pbrAction.routeTableId = 10;

    retVal = adk_ip_pbr_add_policy (ipv4Hdl, 0, &pbrInfo);
    if (retVal != ADK_SUCCESS)
    {
		printf("adk_ip_pbr_add_policy failed\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int adkIpPbrCommit(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;

    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: adk-ip-pbr-commit\n");
        return TCL_OK;
    }
	retVal = adk_ip_pbr_commit(ipv4Hdl);
    if (retVal != ADK_SUCCESS)
    {
		printf("adk_ip_pbr_commit failed\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int macLearning(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	struct ies_addr_req_entry entry;
	//adk_ethernet_mac_addr_t macAddr = {0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0};
	int i = 1;
    if (argc < 9)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: mac-learning vlan <> mac-address <> port <> l2d <>\n");
        return TCL_OK;
    }
	memset(&entry, 0x0, sizeof(entry));
    if(0 == (strcmp("vlan",argv[i++])))
	{
        entry.mac_addr_entry.vlan = atoi(argv[i++]);/*ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO*/
	}
#if 0
    if(0 == (strcmp("mac-address",argv[i++])))
    {
        for ( j = 0; j < 6; j++)
        {
            long b = strtol((const char*)argv[i] + (3 * j), (char **) NULL, 16);
             macAddr[j] = (char)b;
        }

        if ( macAddr[0] == 0 && macAddr[1] == 0 &&
                 macAddr[2] == 0 &&  macAddr[3] == 0 &&
                 macAddr[4] == 0 &&  macAddr[5] == 0)
        {
            printf("Incorrect MAC Address 0x00\n");
            exit(0);

        }
        else if (macAddr[0] == 0xff && macAddr[1] == 0xff &&
                macAddr[2] == 0xff && macAddr[3] == 0xff &&
                macAddr[4] == 0xff && macAddr[5] == 0xff)
        {
            printf("Incorrect MAC Address 0xff\n");
            exit(0);
        }
        i++;
		//printf("addEthArpEntry: macAddr %x \n", macAddr[0]);
    }
#endif
    if(0 == (strcmp("mac-address",argv[i++])))
	{
         entry.mac_addr_entry.mac_addr = atoi(argv[i++]);
	}
    if(0 == (strcmp("port",argv[i++])))
	{
        entry.mac_addr_entry.port = atoi(argv[i++]);
	}
    if(0 == (strcmp("l2d",argv[i++])))
	{
        entry.mac_addr_entry.l2_domain = atoi(argv[i++]);
        //entry.mac_addr_entry.l2_domain = 20;
	}
    //entry.mac_addr_entry.mac_addr = macAddr ;
    //entry.mac_addr_entry.mac_addr = 0x1000501; //FIXME:Mallesh
	//entry.mac_addr_entry.mac_addr =	0x9adc9af364e8;
    //entry.mac_addr_entry.vlan = vlan;
    //entry.mac_addr_entry.l2_domain = l2d;
    entry.mac_addr_entry.type = IES_ADDR_STATIC;
    //entry.mac_addr_entry.port = lport;
    retVal = ies_addr_add(E_IPT_SWITCH_ID, 1, &entry, 0);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to mac_learning\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int addIpv6RouteAdd(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ipv6_route_info_t ipv6RouteInfo;
    int i = 1;
    uint8_t table_id = 0, index = 0;

    if (argc < 11)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipv6-route-add route-table-id <> dest-ip <> prefix-width <> route-mtu <> onlink <> \
                            onlink-handle ip-handle index <>\n");
        return TCL_OK;
    }
    memset(&ipv6RouteInfo, 0x00, sizeof(ipv6RouteInfo));
    if(0 == (strcmp("route-table-id",argv[i++])))
    {
		table_id = atoi(argv[i++]);
        printf ("\nRoute added with route table id : 0x%x \n", table_id);
    }
    if(0 == (strcmp("dest-ip",argv[i++])))
    {
        inet_pton(AF_INET6, (char*)argv[i++], &ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr);
        ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[0] = ntohl(ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[0]);
        ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[1] = ntohl(ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[1]);
        ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[2] = ntohl(ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[2]);
        ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[3] = ntohl(ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[3]);

        printf ("\nRoute added for destination : %x %x %x %x\n",
                   ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[0], ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[1],
                   ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[2], ipv6RouteInfo.ipv6RouteRules.dstIpv6Addr.addr[3]);
    }
    if(0 == (strcmp("prefix-width",argv[i++])))
        ipv6RouteInfo.ipv6RouteRules.prefixLength = atoi(argv[i++]);

    if(0 == (strcmp("route-mtu",argv[i++])))
        ipv6RouteInfo.ipv6RouteAttr.routeMTU = atoi(argv[i++]);

    if(0 == (strcmp("onlink",argv[i++])))
    {
        ipv6RouteInfo.ipv6RouteAttr.onLink = atoi(argv[i++]);
    }

    if(0 == (strcmp("onlink-handle",argv[i++])))
    {
        if(0 == (strcmp("nh-handle",argv[i])))
        {
            i++;
            if(0 == (strcmp("index",argv[i++])))
                index = atoi(argv[i]);
            printf("assigning nexthop handle as onlink hdl %p\n",ipv6NhHdl[index]);
            ipv6RouteInfo.ipv6RouteAttr.u_hdl.nextHopHandle = ipv6NhHdl[index];
        }
        else if(0 == (strcmp("ip-handle",argv[i])))
        {
            i++;
            if(0 == (strcmp("index",argv[i++])))
                index = atoi(argv[i]);
            printf("assigning ip-handle as onlink hdl= %p",ipv6IfHdl[index]);
            ipv6RouteInfo.ipv6RouteAttr.u_hdl.interfaceHandle = ipv6IfHdl[index];
        }
    }

    retVal = adk_ipv6_route_add(ipv6Hdl, &ipv6RouteInfo, table_id);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }
    printf("\n Added route # %d \n", numIpv4Routes);
    numIpv4Routes++;
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int addIpRoute(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ip_route_info_t ipv4_routeInfo;
    int i = 1;
    uint16_t index=0;
    
    if (argc < 16)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ip-route route-table-id <> dest-ip <> prefix-width <> connected-route <> l2-handle <> index <> next-hop <> route-mtu <>\n");
        return TCL_OK;
    }
    memset(&ipv4_routeInfo, 0x00, sizeof(ipv4_routeInfo));
    if(0 == (strcmp("route-table-id",argv[i++])))
    {
		ipv4_routeInfo.routeTableId = atoi(argv[i++]);
        printf ("\nRoute added with route table id : 0x%x \n", ipv4_routeInfo.routeTableId);
    }
    if(0 == (strcmp("dest-ip",argv[i++])))
    {
        inet_pton(AF_INET, (char*)argv[i++], &ipv4_routeInfo.destAddr.addr);
        ipv4_routeInfo.destAddr.addr = ntohl(ipv4_routeInfo.destAddr.addr);
        printf ("\nRoute added for destination : 0x%x \n", ipv4_routeInfo.destAddr.addr);
    }
    if(0 == (strcmp("prefix-width",argv[i++])))
    {
        ipv4_routeInfo.destAddr.prefixWidth = atoi(argv[i++]);
        printf ("\nRoute added with prefix width %d\n", ipv4_routeInfo.destAddr.prefixWidth);
    }
    if(0 == (strcmp("connected-route",argv[i++])))
    {
            ipv4_routeInfo.connectedRoute = atoi(argv[i++]);
        printf ("\nRoute added with connectedRoute %d\n", ipv4_routeInfo.connectedRoute);
    }
    if(0 == (strcmp("l2-handle",argv[i++])))
    {
        printf ("\nRoute added with l2-handle\n");
        if(0 == (strcmp("bridge",argv[i])))
        {
            i++;
            printf("assigning layer2InterfaceHandle as bridge if handle %p\n",bridge_if_handle);
            ipv4_routeInfo.l2IfHd = bridge_if_handle;
        }
        else if(0 == (strcmp("svif",argv[i++])))
        {
            if(0 == (strcmp("index",argv[i++])))
            {
                index = atoi(argv[i++]);
                printf("Assigning layer2InterfaceHandle as svif:%p->svif[%d]",svif[index],index);
                ipv4_routeInfo.l2IfHd = svif[index];
            }
            else
            {
                printf("svif interface index needed\n");
            }
        }
    }
    if(0 == (strcmp("next-hop",argv[i++])))
    {
        inet_pton(AF_INET, (char*)argv[i++], &ipv4_routeInfo.nextHop);
        ipv4_routeInfo.nextHop = ntohl(ipv4_routeInfo.nextHop);
        printf ("\nRoute added with next-hop 0x%x\n", ipv4_routeInfo.nextHop);
    }
    if(0 == (strcmp("route-mtu",argv[i++])))
    {
        ipv4_routeInfo.routeMTU = atoi(argv[i++]);
        printf ("\nRoute added with mtu %d\n", ipv4_routeInfo.routeMTU);
    }
    retVal = adk_ip_route_add(ipv4Hdl, &ipv4_routeInfo);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }
    printf("\n Added route # %d \n", numIpv4Routes);
    numIpv4Routes++;
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpReassemblyTimeout(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    int i = 1;
	uint32_t timeval=0;

    if (argc < 3)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ip-reassembly-timeout timeoutInMilliSec <> \n");
        return TCL_OK;
    }
    if(0 == (strcmp("timeoutInMilliSec",argv[i++])))
    {
		timeval = atoi(argv[i++]);
        printf ("\nTimtout in MiliSec is : 0x%x \n", timeval);
    }
	retVal = adk_ip_reassembly_timeout_config (
					ipv4Hdl,timeval, 10, 500) ;
			if (retVal != ADK_SUCCESS)
			{
					printf("Failed to configure reassembly timeout \n");
					return (1);
			}
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpsecSp(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	adk_ipsec_sec_pol_t secPolOut;
	int i = 1, ip_version = 4;

    if (argc < 36)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipsec-sp \
			src-addr-begin <> src-addr-end <> dst-addr-begin <> dst-addr-end <> \n\
			src-port-begin <> src-port-end <> dst-port-begin <> dst-port-end <> \n\
			protocol <> dscp-val <> action <> tunnel-mode <> \
			pre-frag <> config-df <> esp-proto <> mtu <> ip-version <> \
			single-sa-in-pre-frag <>  no argument needed for this\n");
        return TCL_OK;
    }
    memset(&secPolOut, 0, sizeof(secPolOut));
    ip_version = atoi(argv[34]); //It is expected that ip-version is always the 34th argument in the tcl command
    printf("ip_version: %d\n", ip_version);

    if(0 == (strcmp("src-addr-begin",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrBegin);
            secPolOut.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrBegin =
                ntohl(secPolOut.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrBegin);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[0] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[0]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[1] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[1]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[2] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[2]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[3] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[3]);
        }
    }
    if(0 == (strcmp("src-addr-end",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrEnd);
            secPolOut.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrEnd =
                ntohl(secPolOut.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrEnd);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[0] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[0]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[1] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[1]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[2] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[2]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[3] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[3]);
        }
    }
    if(0 == (strcmp("dst-addr-begin",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrBegin);
            secPolOut.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrBegin =
                ntohl(secPolOut.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrBegin);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[0] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[0]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[1] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[1]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[2] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[2]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[3] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[3]);
        }
    }
    if(0 == (strcmp("dst-addr-end",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrEnd);
            secPolOut.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrEnd =
                ntohl(secPolOut.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrEnd);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[0] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[0]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[1] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[1]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[2] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[2]);
            secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[3] =
                ntohl(secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[3]);
        }
	}
	if(0 == (strcmp("src-port-begin",argv[i++])))
	{
    	secPolOut.secPolSel.l4Info.portInfo.srcPort.portBegin = (uint16_t)atoi(argv[i++]);
	}
    if(0 == (strcmp("src-port-end",argv[i++])))
	{
    	secPolOut.secPolSel.l4Info.portInfo.srcPort.portEnd = (uint16_t)atoi(argv[i++]);
	}
    if(0 == (strcmp("dst-port-begin",argv[i++])))
	{
    	secPolOut.secPolSel.l4Info.portInfo.dstPort.portBegin = (uint16_t)atoi(argv[i++]);
	}
    if(0 == (strcmp("dst-port-end",argv[i++])))
	{
    	secPolOut.secPolSel.l4Info.portInfo.dstPort.portEnd = (uint16_t)atoi(argv[i++]);
	}
    if(0 == (strcmp("protocol",argv[i++])))
	{
		secPolOut.secPolSel.protocol = atoi(argv[i++]);
	}
    if(0 == (strcmp("dscp-val",argv[i++])))
	{
		secPolOut.secPolSel.dscpVal = atoi(argv[i++]);
	}
    if(0 == (strcmp("action",argv[i++])))
	{
		secPolOut.secPolAttr.action = atoi(argv[i++]);//ADK_IPSEC_SP_ACTION_IPSEC
	}
    if(0 == (strcmp("tunnel-mode",argv[i++])))
	{
		secPolOut.secPolAttr.tunnelMode = atoi(argv[i++]);
	}
    if(0 == (strcmp("pre-frag",argv[i++])))
	{
		 secPolOut.secPolAttr.preFragEnable = atoi(argv[i++]);
	}
    if(0 == (strcmp("config-df",argv[i++])))
	{
    	secPolOut.secPolAttr.configDF = atoi(argv[i++]);
	}
    if(0 == (strcmp("esp-proto",argv[i++])))
	{
    	secPolOut.secPolAttr.espProto = atoi(argv[i++]);
	}
    if(0 == (strcmp("mtu",argv[i++])))
	{
    	secPolOut.secPolAttr.pathMTU = atoi(argv[i++]);
	}
    if(0 == (strcmp("ip-version",argv[i++])))
	{
		secPolOut.secPolSel.ipVersion = atoi(argv[i++]);
		printf("IPversion in add sp is %d\n",secPolOut.secPolSel.ipVersion);
	}
    if(0 == (strcmp("single-sa-in-pre-frag",argv[i++])))
	{
		secPolOut.secPolAttr.useSingleSAInPrefrag =  atoi(argv[i++]);
	}
	//secPolOut.secPolSel.rangeSelFlag = 1;
    if(4 == ip_version)
    {
        secPolOut.secPolSel.ipAddr.ipv4Addr.srcAddr.rangeSelFlag = 1;
        secPolOut.secPolSel.ipAddr.ipv4Addr.dstAddr.rangeSelFlag = 1;
    }
    else
    {
        secPolOut.secPolSel.ipAddr.ipv6Addr.srcAddr.rangeSelFlag = 1;
        secPolOut.secPolSel.ipAddr.ipv6Addr.dstAddr.rangeSelFlag = 1;
    }
    retVal = adk_ipsec_add_sp(ipsecHdl,
                &secPolOut,
                0,
                TRUE,
                TRUE,
                0,
                0);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to configure adk_ipsec_add_sp \n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int addIpsecSpIn(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ipsec_sec_pol_in_t secPol;
	int i = 1;
	int ip_version = 4;

    if (argc < 23)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: add-ipsec-sp-in addr <> addr-begin <> addr-end <> \
				prefix-width <> action <> ip-version <> rang-sel-flag <> \
				protocol <> no argument needed for this\n");
        return TCL_OK;
    }
    ip_version = atoi(argv[12]); //It is expected that ip-version is always the 12th argument in the tcl command

    printf("ip_version: %d\n", ip_version);
	memset(&secPol, 0, sizeof(secPol));
    if(0 == (strcmp("src-addr-begin",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrBegin);
            secPol.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrBegin =
                ntohl(secPol.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrBegin);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[0] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[0]);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[1] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[1]);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[2] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[2]);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[3] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrBegin[3]);
        }
    }
    if(0 == (strcmp("src-addr-end",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrEnd);
            secPol.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrEnd =
                ntohl(secPol.secPolSel.ipAddr.ipv4Addr.srcAddr.addr.addr_range_t.addrEnd);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[0] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[0]);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[1] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[1]);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[2] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[2]);
            secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[3] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.addr.addr_range_t.addrEnd[3]);
        }

    }
    if(0 == (strcmp("dst-addr-begin",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrBegin);
            secPol.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrBegin =
                ntohl(secPol.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrBegin);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[0] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[0]);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[1] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[1]);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[2] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[2]);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[3] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrBegin[3]);
        }

    }
    if(0 == (strcmp("dst-addr-end",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrEnd);
            secPol.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrEnd =
                ntohl(secPol.secPolSel.ipAddr.ipv4Addr.dstAddr.addr.addr_range_t.addrEnd);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++],
                    &secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[0] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[0]);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[1] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[1]);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[2] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[2]);
            secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[3] =
                ntohl(secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.addr.addr_range_t.addrEnd[3]);
        }

	}
    if(0 == (strcmp("action",argv[i++])))
	{
    	secPol.secPolAttr.action = atoi(argv[i++]); //ADK_IPSEC_SP_ACTION_BYPASS;
	}
    if(0 == (strcmp("ip-version",argv[i++])))
	{
		secPol.secPolSel.ipVersion = atoi(argv[i++]);
	}
	if(0 == (strcmp("protocol",argv[i++])))
	{
		secPol.secPolSel.protocol = atoi(argv[i++]);
	}
    if(0 == (strcmp("src-port-begin",argv[i++])))
	{
    	secPol.secPolSel.l4Info.portInfo.srcPort.portBegin = (uint16_t)atoi(argv[i++]);
	}
    if(0 == (strcmp("src-port-end",argv[i++])))
	{
    	secPol.secPolSel.l4Info.portInfo.srcPort.portEnd = (uint16_t)atoi(argv[i++]);
	}
    if(0 == (strcmp("dst-port-begin",argv[i++])))
	{
    	secPol.secPolSel.l4Info.portInfo.dstPort.portBegin = (uint16_t)atoi(argv[i++]);
	}
    if(0 == (strcmp("dst-port-end",argv[i++])))
	{
    	secPol.secPolSel.l4Info.portInfo.dstPort.portEnd = (uint16_t)atoi(argv[i++]);
	}
    if(4 == ip_version)
    {
        secPol.secPolSel.ipAddr.ipv4Addr.srcAddr.rangeSelFlag = 1;
        secPol.secPolSel.ipAddr.ipv4Addr.dstAddr.rangeSelFlag = 1;
    }
    else
    {
        secPol.secPolSel.ipAddr.ipv6Addr.srcAddr.rangeSelFlag = 1;
        secPol.secPolSel.ipAddr.ipv6Addr.dstAddr.rangeSelFlag = 1;
    }

	//secPol.secPolSel.rangeSelFlag = 1
    retVal = adk_ipsec_add_sp_in(
            ipsecHdl,
            &secPol,
            0,
            TRUE,
            TRUE);

    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to configure adk_ipsec_add_sp_in \n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
} 
static int addIpsecSa(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	adk_ipsec_sa_t secAsc;
	uint32_t authKey[20], encrKey[16], len;
	adk_handle_t eg_sa_handle;
    int i = 1;
	uint16_t startPolIndex = 0;
    int ip_version = 4;

    if (argc < 37)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage:add-ipsec-sa mode <> life-time <> protocol <> \
				anti-replay <> anti-replay-window-sz <> auth <> encr <> \
				soft-byte-life <> hard-byte-life <> ip-version <> spi <> \
				ttl <> tunnel-srp-ip <> tunnel-dsp-ip <> direction <> \
				auth-key-str <> encr-key-str <> startPolIndex <>\n");
        return TCL_OK;
    }
    ip_version = atoi(argv[20]); //It is expected that ip-version is always the 20th argument in the tcl command
    printf("ip_version: %d\n", ip_version);
	memset(&secAsc, 0, sizeof(secAsc));

	if(0 == (strcmp("mode",argv[i++])))
    {
		secAsc.SASPPContext.mode = atoi(argv[i++]);
	}
	if(0 == (strcmp("life-time",argv[i++])))
	{
		secAsc.SASPPContext.lifetimesEnabled = atoi(argv[i++]);
	}
	if(0 == (strcmp("protocol",argv[i++])))
	{
		secAsc.SASPPContext.protocol = atoi(argv[i++]);
	}
	if(0 == (strcmp("anti-replay",argv[i++])))
	{
		secAsc.SASPPContext.sn.antiReplayEnable = atoi(argv[i++]);
	}
	if(0 == (strcmp("anti-replay-window-sz",argv[i++])))
	{
		secAsc.SASPPContext.antiReplayWindowSize = atoi(argv[i++]);
	}
	if(0 == (strcmp("auth",argv[i++])))
	{
		secAsc.SASPPContext.auth = atoi(argv[i++]);
	}
	if(0 == (strcmp("encr",argv[i++])))
	{
		secAsc.SASPPContext.encr = atoi(argv[i++]);
	}
	if(0 == (strcmp("soft-byte-life",argv[i++])))
	{
		secAsc.SASPPContext.softByteLifetime =  atoi(argv[i++]);
	}
	if(0 == (strcmp("hard-byte-life",argv[i++])))
	{
		secAsc.SASPPContext.hardByteLifetime =  atoi(argv[i++]);
	}
	if(0 == (strcmp("ip-version",argv[i++])))
	{
		secAsc.ipVersion = atoi(argv[i++]);//ADK_IPSEC_IPV4;
	}
	if(0 == (strcmp("spi",argv[i++])))
	{
		secAsc.SASPPContext.spi = atoi(argv[i++]);//4003;
		printf("Add SPI value %d\n", secAsc.SASPPContext.spi);
	}
	if(0 == (strcmp("ttl",argv[i++])))
	{
		secAsc.eSaTttlHopLimit.ttl = atoi(argv[i++]);//64;
	}
    if(0 == (strcmp("tunnel-srp-ip",argv[i++])))
    {
        if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++], &secAsc.tunAddr.ipv4TunAddr.tunnelSrcIP);
            secAsc.tunAddr.ipv4TunAddr.tunnelSrcIP= ntohl(secAsc.tunAddr.ipv4TunAddr.tunnelSrcIP);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++], &secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP);
            secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[0]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[0]);
            secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[1]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[1]);
            secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[2]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[2]);
            secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[3]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelSrcIP[3]);
        }
    }
	if(0 == (strcmp("tunnel-dsp-ip",argv[i++])))
	{
	    if(4 == ip_version)
        {
            inet_pton(AF_INET, (char*)argv[i++], &secAsc.tunAddr.ipv4TunAddr.tunnelDstIP);
            secAsc.tunAddr.ipv4TunAddr.tunnelDstIP= ntohl(secAsc.tunAddr.ipv4TunAddr.tunnelDstIP);
        }
        else
        {
            inet_pton(AF_INET6, (char*)argv[i++], &secAsc.tunAddr.ipv6TunAddr.tunnelDstIP);
            secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[0]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[0]);
            secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[1]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[1]);
            secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[2]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[2]);
            secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[3]= ntohl(secAsc.tunAddr.ipv6TunAddr.tunnelDstIP[3]);
        }
	}
	if(0 == (strcmp("direction",argv[i++])))
	{
		secAsc.SASPPContext.direction = atoi(argv[i++]);
	}
	if(0 == (strcmp("auth-key-str",argv[i++])))
	{
		char *strPtr = argv[i++];
		len = strlen(strPtr);
		memcpy(&authKey[0],strPtr, len);
		secAsc.SASPPContext.authKey.len = len;
		secAsc.SASPPContext.authKey.buf =
			calloc((sizeof(unsigned char)*(secAsc.SASPPContext.authKey.len)),1);
		memcpy(secAsc.SASPPContext.authKey.buf,
            &authKey[0],
			(sizeof(unsigned char)*secAsc.SASPPContext.authKey.len));
	} 
	if(0 == (strcmp("encr-key-str",argv[i++])))
	{
		char *strPtr = argv[i++];
		len = strlen(strPtr);
		memcpy(&encrKey[0],strPtr, len);
		secAsc.SASPPContext.encrKey.len = len;
		secAsc.SASPPContext.encrKey.buf =
        calloc((sizeof(unsigned char)*(secAsc.SASPPContext.encrKey.len)),1);
		memcpy(secAsc.SASPPContext.encrKey.buf,
            &encrKey[0],
            (sizeof(unsigned char)*secAsc.SASPPContext.encrKey.len));
	}
    if(0 == (strcmp("startPolIndex",argv[i++])))
    {
        startPolIndex = atoi(argv[i++]);
		printf("startPolIndex %d\n",startPolIndex);
    }
    retVal = adk_ipsec_add_sa(ipsecHdl,
            &secAsc,
            0xff,
            1,
            startPolIndex,
           &eg_sa_handle);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to createIpInterface\n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int PrintAllStats(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    int ret_val, i = 1, ret;
	int opt;
	adk_status_t        retValue = ADK_SUCCESS;
	struct rte_eth_stats ethdev_stats;
	static adk_ipsec_stat_t prevIpsecStats;
	adk_ipsec_stat_t ipsecStats = {0};
    uint8_t num_cores = 0;
    uint8_t loop_cnt = 0;

    if (argc < 1)
    {
        printf("Invalid no. of arguments\n");
        printf("Usage: stats\n");
		return -1;
    }

    do {
       printf("\nPress \n"
               "a - display ADK stats\n"
               "e - display eth dev stats\n"
               "p - display pal stats\n"
               "t - display traffic management stats\n"
               "i - display ipv4 stats\n"
               "j - display ipv4 utility stats\n"
               "k - display ipsec global stats\n"
               "u - display IPsec utility counters\n"
               "v - display Ethernet  utility counters\n"
               "m - display mac-dump stats\n"
               "f - display flow cache stats\n"
               "q - to quit\n"
               "x - terminate immediately\n");
       opt = getchar();
       if (opt == 'a')
       {
           prevIpsecStats = ipsecStats;
#ifdef ADK_DEBUG
		printf("Printing Bridge interface statistics:\n");
		adk_ethernet_bridge_interface_statistics_print(ethHdl, bridge_if_handle);
		printf("Printing SVIF interface statistics:\n");
		adk_ethernet_vlan_interface_statistics_print(ethHdl, svif[0]); //FIXME:Mallesh
		for (i = 0;i < NUM_PORTS; i++) {
			printf("Printing port statistics for port %d\n", ADK_HLP_PORT_NUM_START+i);
			adk_ethernet_port_stats_print(ethHdl, ADK_HLP_PORT_NUM_START+i);
			printf("\n");
		}
		printf("Printing CPK port statistics\n");
		adk_ethernet_port_stats_print(ethHdl, ADK_HOS_CPK_PORT);
#endif
       if (!ipv6_mode)
       {
#ifdef ADK_DEBUG
           printf("Printing ingress flow statistics\n");
           adk_ethernet_ingress_flow_statistics_print(ethHdl, enetArpFlow);
#endif
           adk_ip_global_stats_t ip_global_stats;
           retValue = adk_ip_global_stats_get(ipv4Hdl, &ip_global_stats);
           if (retValue != ADK_SUCCESS)
           {
               printf("Failed to get IP statistics\n");
               return retValue;
           }
           else
               print_ip_global_stats(&ip_global_stats);

           adk_ip_interface_stats_t ipIfaceStats;
           ret_val = adk_ip_interface_stats_get(ipv4Hdl, ipv4IfHdl[0], &ipIfaceStats);
           if(ADK_SUCCESS == ret_val)
           {
               printf("Interface Stats for IP (br) interface::\n");
               print_ip_interface_stats(&ipIfaceStats);
           }
           for (i = 0; i < ADK_QOS_MAX_PHB_CLASS_IDX ; i++) {
               NON_ZERO_STATS(ipIfaceStats.ifRxQoSstats[i].rxPkts, "\n Rx QoS Pkts [PHB:%u]:%lu", i, ipIfaceStats.ifRxQoSstats[i].rxPkts);
               NON_ZERO_STATS(ipIfaceStats.ifRxQoSstats[i].rxBytes,"\n Rx QoS Bytes [PHB:%u]:%lu\n", i, ipIfaceStats.ifRxQoSstats[i].rxBytes);
           }

           ret_val = adk_ip_interface_stats_get(ipv4Hdl, ipv4IfHdl[1], &ipIfaceStats);
           if(ADK_SUCCESS == ret_val)
           {
               printf("Interface Stats for IP (svif) interface::\n");
               print_ip_interface_stats(&ipIfaceStats);
           }
           for (i = 0; i < ADK_QOS_MAX_PHB_CLASS_IDX ; i++) {
               NON_ZERO_STATS(ipIfaceStats.ifRxQoSstats[i].rxPkts, "\n Rx QoS Pkts [PHB:%u]:%lu", i, ipIfaceStats.ifRxQoSstats[i].rxPkts);
               NON_ZERO_STATS(ipIfaceStats.ifRxQoSstats[i].rxBytes,"\n Rx QoS Bytes [PHB:%u]:%lu\n", i, ipIfaceStats.ifRxQoSstats[i].rxBytes);
           }
		#if 0 /*FIXME:Mallesh*/
           adk_ip_address_stats_t ipAddrStats;
           ret_val = adk_ip_address_stats_get(ipv4Hdl, if_addr_list[0], &ipAddrStats);
           if(ADK_SUCCESS == ret_val)
           {
               printf("stats for ip-addr=0x%x::\n", if_addr_list[0]);
               print_ip_addr_stats(&ipAddrStats);
           }
		#endif

           adk_qos_phb_stats_read(adkSysHdl,ipv4IfHdl[0]);
           adk_qos_phb_stats_read(adkSysHdl,ipv4IfHdl[1]);
       }
#ifdef APP_ETH_DEBUG
        printf("Dump Mac table\n");
        if(IES_OK != ies_addr_show_table(0))
        {
            printf("Mac table dump error\n");
        }

        printf("Mac table dump successful\n");
#endif
        printf("Press Enter to display stats, q to quit or x to"
                " terminate immediately\n");
        opt = getchar();
        if (opt == 'x')
        {
            adk_sys_detach(adkSysHdl);
            return 0;
        }


#ifdef ADK_DEBUG
        adk_ethernet_global_stats_print(ethHdl);
#endif
       }

       if (opt == 'x')
       {
           adk_sys_detach(adkSysHdl);
           return 0;
       }
       if (opt == 'e') {
           rte_eth_stats_get(testConfShm_p->ethDev.tnPorts_p[0], &ethdev_stats);

           printf("\nEthdev stats :\n");
           NON_ZERO_STATS(ethdev_stats.ipackets, "\n Rx packets :%lu\n", ethdev_stats.ipackets);
           NON_ZERO_STATS(ethdev_stats.opackets, "\n Tx packets :%lu\n", ethdev_stats.opackets);
           NON_ZERO_STATS(ethdev_stats.ibytes, "\n Rx bytes :%lu\n",   ethdev_stats.ibytes);
           NON_ZERO_STATS(ethdev_stats.obytes, "\n Tx bytes :%lu\n",   ethdev_stats.obytes);
           NON_ZERO_STATS(ethdev_stats.imissed, "\n Missed Packets :%lu\n", ethdev_stats.imissed);
           NON_ZERO_STATS(ethdev_stats.ierrors, "\n Rx Errors :%lu\n", ethdev_stats.ierrors);
           NON_ZERO_STATS(ethdev_stats.oerrors, "\n Tx Errors :%lu\n", ethdev_stats.oerrors);
           NON_ZERO_STATS(ethdev_stats.rx_nombuf, "\n Mbuf allocation failures :%lu\n", ethdev_stats.rx_nombuf);

           for (i= 0 ; i < RTE_ETHDEV_QUEUE_STAT_CNTRS; i++) {
               NON_ZERO_STATS(ethdev_stats.q_ipackets[i], "\nQueue[%d] Rx packets = %lu\n", i, ethdev_stats.q_ipackets[i]);
               NON_ZERO_STATS(ethdev_stats.q_ibytes[i], "\nQueue[%d] Rx bytes = %lu\n", i, ethdev_stats.q_ibytes[i]);
               NON_ZERO_STATS(ethdev_stats.q_opackets[i], "\nQueue[%d] Tx packets = %lu\n", i, ethdev_stats.q_opackets[i]);
               NON_ZERO_STATS(ethdev_stats.q_obytes[i], "\nQueue[%d] Tx bytes = %lu\n", i, ethdev_stats.q_obytes[i]);
               NON_ZERO_STATS(ethdev_stats.q_errors[i],"\nQueue[%d] Rx Errors = %lu\n", i, ethdev_stats.q_errors[i]);
           }
#ifdef ADK_DEBUG
		int j;
		printf("Printing Bridge interface statistics:\n");
		adk_ethernet_bridge_interface_statistics_print(ethHdl, bridge_if_handle);
		printf("Printing SVIF interface statistics:\n");
		adk_ethernet_vlan_interface_statistics_print(ethHdl, svif[0]);//FIXME:Mallesh
		printf("Printing ingress flow statistics\n");
		adk_ethernet_ingress_flow_statistics_print(ethHdl, enetArpFlow);
		for(j = 0; j < NUM_PORTS; j ++)
		{
			printf("Printing port statistics for port %d\n", ADK_HLP_PORT_NUM_START+j);
			adk_ethernet_port_stats_print(ethHdl, ADK_HLP_PORT_NUM_START + j);
			printf("\n");
		}
		printf("Printing CPK port statistics\n");
		adk_ethernet_port_stats_print(ethHdl, ADK_HOS_CPK_PORT);
		printf("Printing ingress flow statistics\n");
		adk_ethernet_ingress_flow_statistics_print(ethHdl, enetArpFlow);
		adk_ethernet_global_stats_print(ethHdl);
#else
	    printf("\nERROR: Debug Print (ADK_DEBUG) flag not enabled in ADK compilation:\n");
#endif
       }
       if (opt == 't')
       {
           /********************QoS statistics********************************/
           cpk_qos_sl_stats_read(testConfShm_p->ethDev.vdev_port_id,
                   bridge_if_handle);

           if(!ipv6_mode) {
               cpk_qos_fl_stats_read(testConfShm_p->ethDev.vdev_port_id,
                       ipv4IfHdl[0]);

               cpk_qos_fl_stats_read(testConfShm_p->ethDev.vdev_port_id,
                       ipv4IfHdl[1]);
           }
       }
	   if (opt == 'p')
	   {
			printf("Printing Pal Stats\n");
			ret = adk_pal_dp_stats_print();
			if (ret != ADK_SUCCESS) {
				printf("Error: Failed to dump PAL global stats!\n");
				return TCL_OK;
			}
		}
		if (opt == 'i')
		{
			adk_ip_global_stats_t ip_global_stats;
			ret = adk_ip_global_stats_get(ipv4Hdl, &ip_global_stats);
			if (ret != ADK_SUCCESS)
			{
				printf("Failed to get IP statistics\n");
				return ret;
			}
			print_ip_global_stats(&ip_global_stats);
		}
		if (opt == 'j')
		{
		    print_ip_utility_stats(ipv4Hdl);
		}
		if(opt == 'k')
		{
		    printf("IPSec global stats for IPv4::\n");
		    print_ipsec_global_stats(ipsecHdl, 0);
		    printf("IPSec global stats for IPv6::\n");
		    print_ipsec_global_stats(ipsecHdl, 1);
		}
		if (opt == 'm')
		{
			printf("Dump Mac table\n");
			if(IES_OK != ies_addr_show_table(0))
			{
				printf("Mac table dump error\n");
			}
			printf("Mac table dump successful\n");
		}
		if(opt == 'u')
		{
			printf("\n=====================================IPsec Utility Counters=================================\n");
			retValue = adk_ipsec_print_utility_counters(ipsecHdl, (ipv6_mode?ADK_IPSEC_IPV6:ADK_IPSEC_IPV4));
			printf("\n=====================================IPsec SA Utility Counters=================================\n");
			retValue = adk_ipsec_print_sa_utility_counters(ipsecHdl);
		}
		if(opt == 'v')
		{
			printf("\n=====================================Ethernet Utility Counters=================================\n");
			retValue = adk_eth_print_utility_counters(ethHdl);
		}
        if (opt == 'f') {
           adk_sys_flow_cache_stats_t *flow_cache_p = sys_flow_cache_stats;
           adk_sys_config_worker_lcore_info_t *worker_core_info_p;
           
           adk_sys_flow_cache_stats_get(adkSysHdl, &flow_cache_p, &num_cores);
           adk_sys_config_worker_lcore_info_get(&worker_core_info_p);

           printf("\nFlow cache stats :\n");
           for ( loop_cnt =0 ; loop_cnt < worker_core_info_p->numLcores; loop_cnt++) {
               printf("\nFlow cache stats core - %u\n", worker_core_info_p->lcore[loop_cnt].index);
               NON_ZERO_STATS(sys_flow_cache_stats[loop_cnt].hit, "\n hit count:%lu", sys_flow_cache_stats[loop_cnt].hit);
               NON_ZERO_STATS(sys_flow_cache_stats[loop_cnt].miss, "\n miss count:%lu", sys_flow_cache_stats[loop_cnt].miss);
               NON_ZERO_STATS(sys_flow_cache_stats[loop_cnt].alloc, "\n alloc count:%lu", sys_flow_cache_stats[loop_cnt].alloc);
               NON_ZERO_STATS(sys_flow_cache_stats[loop_cnt].freed, "\n freed count:%lu", sys_flow_cache_stats[loop_cnt].freed);
               NON_ZERO_STATS(sys_flow_cache_stats[loop_cnt].flows_active, "\n flows active count:%u", sys_flow_cache_stats[loop_cnt].flows_active);
               NON_ZERO_STATS(sys_flow_cache_stats[loop_cnt].flows_stale, "\n flows stale count:%u\n", sys_flow_cache_stats[loop_cnt].flows_stale);
           }
           adk_sys_flow_cache_entries_print(adkSysHdl);
       }
    } while (opt != 'q');

    if (clientdata == 0)
    {
		ret = TCL_OK;
    }
    if (interp == NULL)
    {
		ret = TCL_OK;
    }
    if (argv == NULL)
    {
		ret = TCL_OK;
    }

#if 0
	if(0 == (strcmp("pal",argv[i])))
	{ 
    	printf("Printing Pal Stats\n");
	    ret = adk_pal_dp_stats_print();
    	if (ret != ADK_SUCCESS) {
        	printf("Error: Failed to dump PAL global stats!\n");
    		return TCL_OK;
    	}
	}
	if(0 == (strcmp("eth",argv[i])))
	{
#ifdef ADK_DEBUG
		int j;
	    printf("Printing Bridge interface statistics:\n");
    	adk_ethernet_interface_statistics_print(ethHdl, bridge_if_handle);
	    printf("Printing SVIF interface statistics:\n");
    	adk_ethernet_interface_statistics_print(ethHdl, svif);

	    printf("Printing ingress flow statistics\n");
    	adk_ethernet_ingress_flow_statistics_print(ethHdl, enetArpFlow);

	    for(j = 0; j < NUM_PORTS; j ++)
    	{
			printf("Printing port statistics for port %d\n", ADK_HLP_PORT_NUM_START+j);
			adk_ethernet_port_stats_print(ethHdl, ADK_HLP_PORT_NUM_START + j);
    	    printf("\n");
    	}
    	printf("Printing CPK port statistics\n");
	    adk_ethernet_port_stats_print(ethHdl, ADK_HOS_CPK_PORT);
    	printf("Printing ingress flow statistics\n");
	    adk_ethernet_ingress_flow_statistics_print(ethHdl, enetArpFlow);
    	adk_ethernet_global_stats_print(ethHdl);
#else
	    printf("\nERROR: Debug Print (ADK_DEBUG) flag not enabled in ADK compilation:\n");
#endif
	}
	if(0 == (strcmp("mac-dump",argv[i])))
	{
        printf("Dump Mac table\n");
        if(IES_OK != ies_addr_show_table(0))
        {
            printf("Mac table dump error\n");
        }
        printf("Mac table dump successful\n");
	}
    //adk_ip_global_stats_print(ipv4Hdl); //FIXME:Mallesh1706
    //adk_ip_interface_stats_print(ipv4Hdl, ipv4IfHdl[0]);//FIXME:Mallesh1706
    //adk_ip_interface_stats_print(ipv4Hdl, ipv4IfHdl[1]);
	if(0 == (strcmp("ipv4",argv[i])))
	{
	    adk_ip_global_stats_t ip_global_stats;
    	ret = adk_ip_global_stats_get(ipv4Hdl, &ip_global_stats);
	    if (ret != ADK_SUCCESS)
    	{
        	 printf("Failed to get IP statistics\n");
         	return ret;
    	}
		print_ip_global_stats(&ip_global_stats);
	}
	if(0 == (strcmp("ipsec",argv[i])))
	{
		print_ipsec_stats();
	}
    printf("Press Enter to display stats, q to quit or x to"
             " terminate immediately\n");
#endif
    return TCL_OK;
}
static int setPortAttr(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	uint32_t iPort = ADK_HLP_PORT_NUM_START;
	int i= 0;

    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: set-port-attr \n");
        return TCL_OK;
    }

	for(i = 0; i < NUM_PORTS; i ++){
		bool replace_vlan = false;

	   /* Use packet VLAN */
        printf("ies_port_set_attr Disable VLAN replacement for HLP"
                            " port %d\n", (iPort+i));
        retVal = ies_port_set_attr(ADK_HLP_SWITCH_ID, (iPort+i),
                                    IES_PA_REPLACE_VLAN_FIELDS,
                                    (void *) &replace_vlan);
        if (retVal != IES_OK)
        {
            printf("IES Error: Failed to disable VLAN overide behavior"
                          " for HLP port%d\n", (iPort+i));
            return -1;
        }
	}
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int udpCheckSumValidation(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	bool validate=true;
	int i=1;

    if (argc < 2)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: udp-checksum-validation validate(1,0) 1=udp check validation is done, 0 = udp check validation is not done \n");
        return TCL_OK;
    }
    if(0 == (strcmp("validate",argv[i++])))
	{
        validate = atoi(argv[i++]);
	}
	printf("\nConfiguring udp checksum validation to validate = %d\n", validate);
    retVal =  adk_sys_udp_cksum_validate(adkSysHdl, validate);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to configure udpCheckSumValidation API() \n");
        return (1);
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
/*QOS*/
static int adkQosPolocingFlowCreate(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	//int i= 0;
    adk_qos_policing_params_t policing_params = {0};
    adk_qos_policer_handle_t  policing_handle;
    //adk_qos_policing_params_t policing_params = {0};
    //adk_qos_policer_handle_t  policing_handle;
    adk_ethernet_ingress_flow_action_t arp_flow_action =
    {
        ADK_ETHERNET_ASSOCIATION_RULE_TYPE_SEND_TO_HOST, 0, NULL
    };
    if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: adk-qos-polocing-flow-create \n");
        return TCL_OK;
    }
    policing_params.type = ADK_QOS_POLICE_TYPE_SRTCM;
    policing_params.cir = 10;
    //policing_params.pir = 10;
    policing_params.ebs = 10;
    policing_params.cbs = 10;
    retVal = adk_qos_policing_flow_create(adkSysHdl, &policing_params, &policing_handle);
    if (retVal != ADK_SUCCESS)
    {
		printf("Failed to create Policing flow \n");
		return (1);
    }
    else
	{
		printf("Created Policing flow - \n");
		printf("Policing type :%d \n", policing_params.type);
		printf("CIR(bps)    :%lu \n", policing_params.cir);
		//printf("PIR(bps)    :%lu \n", policing_params.pir);
		printf("CBS(bytes)  :%u \n", policing_params.cbs);
		printf("PBS(bytes)  :%u \n", policing_params.ebs);
		printf("Created Policing flow handle - %"ADKPRIh"\n", policing_handle);
    }
    printf("Adding bridge ethenret interface flow with policing\n");
    arp_flow_action.enablePolicing = 1;
    arp_flow_action.policingHandle = policing_handle;



    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int adkEthTypeBbasedQosPolicySet(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	//int i= 0;

	if (argc < 1)
    {
		printf("Invalid no. of arguments, received = %d \n", argc);
		printf("Usage: adk-eth-type-based-qos-policy-set\n");
        return TCL_OK;
    }
    /*configure second level schedule queue-0 for ARP*/
    retVal = adk_ethernet_ethertype_based_qos_policy_set(ethHdl, bridge_if_handle,
                    0x806, g_sl_map[0].tx_queues[0]);
    if (retVal != ADK_SUCCESS)
    {
		printf("Failed to add qos policy for host originated ARP \n");
		return (1);
    }
    else
    {
        printf("Successfully added qos policy for host originated ARP\n");
    }

    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int configureIpv6QosClassifier(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	uint32_t i= 0;

	if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage:  configure-ipv6-qos-classifier\n");
        return TCL_OK;
    }
	for (i = 0; i < numIpv6Ifs; i++)
	{
		retVal = configure_ip_qos_classifier(ipv6Hdl, ipv6IfHdl[i], 1);
		if (retVal != ADK_SUCCESS)
		{
			printf("Failed to add qos policy for host originated ARP \n");
			return (1);
		}
		else
		{
			printf("Successfully added qos policy for host originated ARP\n");
		}
	}
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}

static int configureIpQosClassifier(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
	uint32_t i= 0;

	if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage:  configure-ip-qos-classifier\n");
        return TCL_OK;
    }
	for (i = 0; i < numIpv4Ifs; i ++)
	{
		retVal = configure_ip_qos_classifier(ipv4Hdl, ipv4IfHdl[i], 0);
		if (retVal != ADK_SUCCESS)
		{
			printf("Failed to add qos policy for host originated ARP \n");
			return (1);
		}
		else
		{
			printf("Successfully added qos policy for host originated ARP\n");
		}
	}
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int adkIpQosPolicyAdd(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
    adk_status_t retVal = ADK_SUCCESS;
    adk_ip_qos_info_t qosInfoIpv4 = {0};
    adk_ip_addr_prefix_t srcIp;

    uint32_t i = 1;

    if (argc < 5)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage:  adk-ip-qos-policy-add src-addr <> prefix-width <>\n");
        return TCL_OK;
    }
    qosInfoIpv4.qosRule.ruleMask = ADK_QOS_CLASSIFIER_SRC_ADDR_MASK;
    if(0 == (strcmp("src-addr",argv[i++])))
    {
        inet_pton(AF_INET, (char*)argv[i++], &srcIp.addr);
        srcIp.addr = ntohl(srcIp.addr);
     	qosInfoIpv4.qosRule.srcAddr.addr_u.v4Addr.addr = srcIp.addr;
    }
    if(0 == (strcmp("prefix-width",argv[i++])))
    {
        qosInfoIpv4.qosRule.srcAddr.addr_u.v4Addr.prefixWidth = atoi(argv[i++]);
    }
    /*qosInfoIpv4.qosRule.ruleMask = ADK_QOS_CLASSIFIER_PROTOCOL_TYPE_MASK;
    qosInfoIpv4.qosRule.protocol = 0x11;*/
    qosInfoIpv4.qosRule.srcAddr.type = ADK_IPV4_ADDRESS;
    qosInfoIpv4.qosRule.ruleMask = ADK_QOS_CLASSIFIER_SRC_ADDR_MASK;
    qosInfoIpv4.qosAction.queueId = qos_queue;
    qosInfoIpv4.qosAction.pktColor =  RTE_TM_GREEN;
    printf("adk_ip_qos_policy_add ipv4 Inteface number:%d, handler:%p \n", numIpv4Ifs - 1,ipv4IfHdl[numIpv4Ifs - 1]);
    if(numIpv4Ifs <= 0){
	printf("numIpv4Ifs should be greater than 0 :%d\n",numIpv4Ifs);
	return -1;
    }
    retVal = adk_ip_qos_policy_add(ipv4Hdl, ipv4IfHdl[numIpv4Ifs - 1], 0 , &qosInfoIpv4);
    if (retVal) {
        printf("\nFailed to add QoS classifier rule\n");
        return -1;
    }
    retVal = adk_ip_qos_policy_build(ipv4Hdl, ipv4IfHdl[numIpv4Ifs - 1]);
    if (retVal) {
    	printf("\nFailed to build QoS classifier rule\n");
        return -1;
    }
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
static int LoadConf(ClientData clientdata, Tcl_Interp *interp, int argc, char **argv)
{
	int opt;

	if (argc < 1)
    {
        printf("Invalid no. of arguments, received = %d \n", argc);
        printf("Usage: load-conf\n");
        return TCL_OK;
    }
    do {
		printf("\nPress \n"
               "1 - Load unifiedX-DUT.tcl conf\n"
               "2 - Load unifiedX-TG.tcl conf\n"
               "3 - Load unifiedIpv6.tcl conf\n"
               "4 - Load unifiedIpv6X_DUT.tcl conf\n"
               "O or q - to quit\n");
		opt = read_num();
		switch(opt){
			case 1:
				Tcl_EvalFile(interp, "./conf_files/tcl/unifiedX-DUT.tcl");
				printf("\nLoaded unifiedX-DUT.tcl successfully\n");
				printf("\nLoad BH stream:./conf_files/streams/unifiedX-DUT_BH_streams_mutli_flow_multi_cores_ss_traffic_mix.str\n");
				printf("\nLoad BP stream:./conf_files/streams/unifiedX-DUT_BP_streams_mutli_flow_multi_cores_ss_traffic_mix.str\n");
				
				adk_sys_detach(adkSysHdl);
				return 0;
			case 2:
				Tcl_EvalFile(interp, "./conf_files/tcl/unifiedX-TG.tcl");
				printf("\nLoaded unifiedX-TG.tcl successfully\n");
				adk_sys_detach(adkSysHdl);
				return 0;
			case 3:
				Tcl_EvalFile(interp, "./conf_files/tcl/unifiedIpv6.tcl");
				printf("\nLoaded unified.tcl successfully\n");
				adk_sys_detach(adkSysHdl);
				return 0;
            case 4:
				Tcl_EvalFile(interp, "./conf_files/tcl/unifiedIpv6X_DUT.tcl");
				printf("\nLoaded unifiedIpv6X_DUT.tcl successfully\n");
				adk_sys_detach(adkSysHdl);
				return 0;
			case 0:
			case 'x':
			case 'q':
				adk_sys_detach(adkSysHdl);
				return 0;
			default:
				printf("load conf failed\n");
				break;
		}
	} while(opt != 'q');
    if (clientdata == 0)
    {
        return TCL_OK;
    }
    if (interp == NULL)
    {
        return TCL_OK;
    }
    if (argv == NULL)
    {
        return TCL_OK;
    }
    return TCL_OK;
}
int Tcl_AppInit(Tcl_Interp *interp)
{
    if (Tcl_Init(interp) == TCL_ERROR)
    {
        return TCL_ERROR;
    }
    Tcl_CreateCommand(interp, "list-commands", (Tcl_CmdProc *) listCommands, NULL, NULL);
    /* create commands for Ethernet ADK functionality */
    Tcl_CreateCommand(interp, "create-eth-bridge-interface", (Tcl_CmdProc *) createEthBridgeInterface, NULL, NULL);
    Tcl_CreateCommand(interp, "create-eth-switch-virtual-interface", (Tcl_CmdProc *) createEthSwitchVirtualInterface, NULL, NULL);
    Tcl_CreateCommand(interp, "create-eth-ingress-flow", (Tcl_CmdProc *) createEthIngressFlow, NULL, NULL);
    Tcl_CreateCommand(interp, "add-eth-arp-entry", (Tcl_CmdProc *) addEthArpEntry, NULL, NULL);
    Tcl_CreateCommand(interp, "add-eth-neigh-entry", (Tcl_CmdProc *) addEthNeighEntry, NULL, NULL);
    Tcl_CreateCommand(interp, "set-port-attr", (Tcl_CmdProc *) setPortAttr, NULL, NULL);
    Tcl_CreateCommand(interp, "udp-checksum-validation", (Tcl_CmdProc *) udpCheckSumValidation, NULL, NULL);
 
    /* create commands for IPv6 ADK functionality */
    Tcl_CreateCommand(interp, "create-ipv6-interface", (Tcl_CmdProc *) createIpv6Interface, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ipv6-ingress-classifier-rule", (Tcl_CmdProc *)addIpv6IngressClassifierRule, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ipv6-ingress-classifier-build", (Tcl_CmdProc *)addIpv6IngressClassifierBuild, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ipv6-proto-support", (Tcl_CmdProc *) addIpv6ConfSupportProto, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ipv6-reassembly-timeout", (Tcl_CmdProc *) addIpv6ReassemblyTimeout, NULL, NULL);
    Tcl_CreateCommand(interp, "ipv6-logging", (Tcl_CmdProc *) ipv6Logging, NULL, NULL);

    Tcl_CreateCommand(interp, "add-ipv6-virtual-addr", (Tcl_CmdProc *) addIpv6VirtualAddr, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ipv6-next-hop-add", (Tcl_CmdProc *) addIpv6NextHopAdd, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-ipv6-route-add", (Tcl_CmdProc *) addIpv6RouteAdd, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-ipv6-pbr-add", (Tcl_CmdProc *) adkIpv6PbrAdd, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-ipv6-pbr-commit", (Tcl_CmdProc *) adkIpv6PbrCommit, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-ipv6-pbr-conf-def-route-table", (Tcl_CmdProc *) adkIpv6PbrConfDefRouteTable, NULL, NULL);
    Tcl_CreateCommand(interp, "configure-ipv6-qos-classifier", (Tcl_CmdProc *) configureIpv6QosClassifier, NULL, NULL);

    Tcl_CreateCommand(interp, "mac-learning", (Tcl_CmdProc *) macLearning, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ip-route", (Tcl_CmdProc *) addIpRoute, NULL, NULL);
    Tcl_CreateCommand(interp, "ip-bypass-ipsec", (Tcl_CmdProc *) ipBypassIPsec, NULL, NULL);

    /* create commands for IPv4 ADK functionality */
    Tcl_CreateCommand(interp, "create-ip-interface", (Tcl_CmdProc *) createIpInterface, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ip-ingress-classifier-rule", (Tcl_CmdProc *) addIpIngressClassifierRule, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ip-ingress-classifier-build", (Tcl_CmdProc *) addIpIngressClassifierBuild, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ip-proto-support", (Tcl_CmdProc *) addIpConfSupportProto, NULL, NULL);
    Tcl_CreateCommand(interp, "mac-learning", (Tcl_CmdProc *) macLearning, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ip-route", (Tcl_CmdProc *) addIpRoute, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ip-reassembly-timeout", (Tcl_CmdProc *) addIpReassemblyTimeout, NULL, NULL);
    Tcl_CreateCommand(interp, "ip-bypass-ipsec", (Tcl_CmdProc *) ipBypassIPsec, NULL, NULL);
	/*PBR*/
    Tcl_CreateCommand(interp, "adk-ip-pbr-conf-def-route-table", (Tcl_CmdProc *) adkIpPbrConfDefRouteTable, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-ip-pbr-add-policy", (Tcl_CmdProc *) adkIpPbrAddPolicy, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-ip-pbr-commit", (Tcl_CmdProc *) adkIpPbrCommit, NULL, NULL);

    /* create commands for ipsec ADK functionality */
    Tcl_CreateCommand(interp, "add-ipsec-sp", (Tcl_CmdProc *) addIpsecSp, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ipsec-sp-in", (Tcl_CmdProc *) addIpsecSpIn, NULL, NULL);
    Tcl_CreateCommand(interp, "add-ipsec-sa", (Tcl_CmdProc *) addIpsecSa, NULL, NULL);
	/* QOS function*/
    Tcl_CreateCommand(interp, "adk-qos-policing-flow-create", (Tcl_CmdProc *) adkQosPolocingFlowCreate, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-eth-type-based-qos-policy-set", (Tcl_CmdProc *) adkEthTypeBbasedQosPolicySet, NULL, NULL);
    Tcl_CreateCommand(interp, "configure-ip-qos-classifier", (Tcl_CmdProc *) configureIpQosClassifier, NULL, NULL);
    Tcl_CreateCommand(interp, "adk-ip-qos-policy-add", (Tcl_CmdProc *) adkIpQosPolicyAdd, NULL, NULL);

	/*Load test case configuration automatically*/
	Tcl_CreateCommand(interp, "load-conf", (Tcl_CmdProc *) LoadConf, NULL, NULL);

    /* create commands for statistics for all ADK modules */
	Tcl_CreateCommand(interp, "stats", (Tcl_CmdProc *) PrintAllStats, NULL, NULL);

	printf("\nLoad TCL configuration by Selection proper value\n");
    Tcl_Eval(interp, "load-conf");
    return TCL_OK;
}

/*************PH Init-start**********/
int adk_ph_app_init(adk_sys_handle_t sysHandle)
{
    adk_status_t                    retValue = ADK_SUCCESS;
    adk_ph_dev_device_config_t      devConf;
    uint16_t                        devId;
    adk_sample_thread_id_t          threadId ;
    char                            threadName[26];
    uint16_t                        numCbFns = NUM_EXCEPCTION_CBFN;
    adk_ph_dev_rx_queue_config_t    rxQueueConf;
    uint8_t                         queueId;
    RTE_SET_USED(sysHandle);

    if (adk_ph_dev_dp_instance_init())
    {
	    printf("Failed to initialize ADK DP PH Dev System!\n");
	    return 1;
    }
    printf("ADK PH Dev Init Success\n");

    memset(&devConf, 0, sizeof(adk_ph_dev_device_config_t));

    devConf.numRxQueues = NUM_PH_RX_QUEUES;
    devConf.type = ADK_PH_DEV_TYPE_EVENTDEV;
    devConf.u.evd.portId = testConfShm_p->phDev[PH_DEVICE_INDEX].portId;

    /*if there are multiple segments of task buf in exception has to be combined
      then below flag can be set to true*/
    devConf.coalesceEnabled = false;

    adk_ph_dev_device_configure(&devConf, &devId);

    testConfShm_p->phDev[PH_DEVICE_INDEX].devId = devId;
    testConfShm_p->phDev[PH_DEVICE_INDEX].numRxQueues = devConf.numRxQueues;
    testConfShm_p->phDev[PH_DEVICE_INDEX].numCallbackFns = numCbFns;

    printf("  {%s}: ADK PH dev_Id: %d, rxQueueId[0]: %d \n",
            __func__,
            testConfShm_p->phDev[PH_DEVICE_INDEX].devId,
            testConfShm_p->phDev[PH_DEVICE_INDEX].rxQueueId[PH_QUEUE_INDEX]);

    for (queueId = PH_QUEUE_INDEX; queueId < devConf.numRxQueues; queueId++)
    {
        rxQueueConf.u.evd.queueId = testConfShm_p->phDev[PH_DEVICE_INDEX].rxQueueId[queueId];

        retValue = adk_ph_dev_rx_queue_setup(devId, queueId, &rxQueueConf);
        if (retValue != ADK_SUCCESS)
        {
            printf("  {%s} queue setup failed:  (%d)", __func__,
                    retValue);
            return 1;
        }
    }

    adk_ph_dev_device_start(devId);


    exceptionRock[PH_DEVICE_INDEX].devId = devId;
    exceptionRock[PH_DEVICE_INDEX].queueId = PH_QUEUE_INDEX;
    exceptionRock[PH_DEVICE_INDEX].ph_deviceIndex = PH_DEVICE_INDEX;
    exceptionRock[PH_DEVICE_INDEX].testConfShm_p = testConfShm_p;

    /* Create the thread to process the PDUs */
    if (pthread_create (&(threadId), NULL,
                adk_ph_dev_exception,
                &(exceptionRock[PH_DEVICE_INDEX])) != 0)
    {
        printf("Failed to create the thread, FAILED\n");
        retValue = -1;
        adk_ph_dev_device_stop(devId);
        goto init_ph_thread_return;
    }
    retValue = testConfShm_p->retValue;
    if (retValue != ADK_SUCCESS)
    {
        printf ("  {%s} failed\n", __func__);
        retValue = -1;
        adk_ph_dev_device_stop(devId);
        goto init_ph_thread_return;
    }

    snprintf(threadName, 25, "ph-instance-%d", PH_DEVICE_INDEX);
    if (pthread_setname_np(threadId, threadName))
    {
        printf("ph thread name set failed: %d\n", PH_DEVICE_INDEX);
        retValue = -1;
        adk_ph_dev_device_stop(devId);
        goto init_ph_thread_return;
    }

    sleep(1);
init_ph_thread_return:
    return retValue;
}

static void *
adk_ph_dev_exception(void *data)
{
#define MAX_RX_PACKETS  10
    adk_status_t        retValue = ADK_SUCCESS;
    int                 devId;
    int                 queueId;
    int                 i;
    int                 ph_devIndex;
    uint16_t            numPktsRecv = 0;
    test_conf_ph_dev_t *phDev_p;
    struct rte_mbuf    *recvBuffer_p[MAX_RX_PACKETS];
    test_config_index_t    *configData_p;

    printf("PH Thread %s\n",__func__);
    if (0 != adk_ph_dev_dp_instance_init())
    {
        printf("failed to init PH DP\n");
        return(NULL);
    }
    configData_p = (test_config_index_t *)data;
    devId = configData_p->devId;

    queueId = configData_p->queueId;

    ph_devIndex = configData_p->ph_deviceIndex;
    phDev_p = &(testConfShm_p->phDev[ph_devIndex]);

    while(TRUE)
    {
        if (queueId >= (phDev_p->numRxQueues - 1))
        {
            queueId = 0;
        }

        numPktsRecv = adk_ph_dev_rx_burst(phDev_p->devId, queueId,
                &(recvBuffer_p[0]), 10);
        if (numPktsRecv > MAX_RX_PACKETS)
        {
            rte_panic(" devId[%d]: {%s} recived too many (%d) packets",
                    devId, __func__, numPktsRecv);
        }

        if (0 == numPktsRecv)
        {
            sleep(0);
            continue;
        }
        for (i = 0; i < numPktsRecv; i++)
        {

            retValue = adk_ph_dev_buffer_free(phDev_p->devId,
                    recvBuffer_p[i]);
            if (ADK_SUCCESS != retValue)
            {
                printf("  devId[%d]:  {%s} mbuf free failed (%x)\n",
                        devId, __func__,
                        retValue);
            }
        }
    }
    testConfShm_p->retValue = retValue;

    return(data);
}

static uint32_t
call_back_fn_eth_ph_dev(
        uint8_t            moduleId,
        void               *dp_Message,
        void               *userParam)
{

    adk_ethernet_recv_exception_param_t *ethernet_cpu_params = NULL;
    adk_ethernet_arp_exception_data_t arp_exception_data;
    adk_ethernet_ipv6_neighbor_exception_data_t ipv6_neigh_exception_data;
    adk_status_t                retValue = ADK_SUCCESS;
    adk_ethernet_ipv4_addr_t ip_addr;

    RTE_SET_USED(moduleId);
    RTE_SET_USED(userParam);

    if(NULL != dp_Message)
    {
        ethernet_cpu_params = (adk_ethernet_recv_exception_param_t *) dp_Message;
        switch (ethernet_cpu_params->exception_type)
        {
            case ADK_ETHERNET_EXCEPTION_TYPE_UNRESOLVED_ARP:
                memcpy(&arp_exception_data,&ethernet_cpu_params->exception_data.arp_exception_data,
                        sizeof(adk_ethernet_arp_exception_data_t));
                printf("___________ETHERNET PH decoded info_________________\n");
                printf(" exception_type     %d \n",    ethernet_cpu_params->exception_type );
                printf(" interface handle          %"ADKPRIh" \n",    arp_exception_data.ifHandle);
                printf(" next_hop_address   %x \n",    arp_exception_data.next_hop_address);
                printf("________________________________________________\n");

                printf("Configure the arp entry for the next hop to which exception received\n");
                ip_addr = arp_exception_data.next_hop_address;
                retValue = adk_ethernet_arp_entry_add(ethHdl, ip_addr, dest_mac,ADK_ETHERNET_NEIGHBOR_REACHABLE);
                if(ADK_SUCCESS != retValue)
                {
                    printf("Failed to add arp entry\n");
                    return retValue;
                }
                break;
            case ADK_ETHERNET_EXCEPTION_TYPE_UNRESOLVED_IPV6_NEIGHBOR:
               memcpy(&ipv6_neigh_exception_data,&ethernet_cpu_params->exception_data.v6_neighbor_exception_data,
                        sizeof(adk_ethernet_ipv6_neighbor_exception_data_t));
                printf("___________ETHERNET PH decoded info_________________\n");
                printf(" exception_type     %d \n",    ethernet_cpu_params->exception_type );
                printf(" interface handle          %"ADKPRIh" \n",    ipv6_neigh_exception_data.ifHandle);
                printf(" next hop ipv6 address   %x:%x:%x:%x \n",   ipv6_neigh_exception_data.v6_next_hop_address.addr[0],
                                     ipv6_neigh_exception_data.v6_next_hop_address.addr[1],
                                     ipv6_neigh_exception_data.v6_next_hop_address.addr[2],
                                     ipv6_neigh_exception_data.v6_next_hop_address.addr[3]);
                printf("________________________________________________\n");
                printf("Configure the ipv6 neighbor entry for the next hop to which exception received\n");
                retValue = adk_ethernet_neighbor_entry_add(ethHdl,  ipv6_neigh_exception_data.v6_next_hop_address, dest_mac, ADK_ETHERNET_NEIGHBOR_REACHABLE);
                if(ADK_SUCCESS != retValue)
                {
                    printf("Failed to add neigh entry\n");

                    return retValue;
                }
                break;
            default:
                printf("Invalid exception type is received \n");
                return 0;
        }
    }

    return retValue;
}

static uint32_t
call_back_fn_ipsec_ph_dev(
        uint8_t            moduleId,
        void               *dp_Message,
        void               *userParam)
{
    RTE_SET_USED(moduleId);
    RTE_SET_USED(userParam);
    adk_ipsec_recv_exception_param_t *ipsec_cpu_params;
    adk_ipsec_sa_aquire_excep_data_t sa_aquire_data;
    adk_ipsec_sa_expiry_excep_data_t sa_expiry_data;

    printf("\n Received IPsec exception \n");

    if(NULL != dp_Message)
    {
        ipsec_cpu_params = (adk_ipsec_recv_exception_param_t *) dp_Message;
        switch (ipsec_cpu_params->exceptionType)
        {
            case ADK_IPSEC_EXCEPTION_SA_ACQUIRE:
                {
                    memcpy(&sa_aquire_data,&ipsec_cpu_params->exceptionData.saAquireData,
                            sizeof(adk_ipsec_sa_aquire_excep_data_t));
                    printf("Received ipsec SA AQUIRE exception data\n");
                    printf("polIndex:%x\n",sa_aquire_data.polIndex); 
                    printf("ipVersion:%x\n",sa_aquire_data.saMsg.ipVersion);
                    printf("srcAddr:%x\n",sa_aquire_data.saMsg.ipAddr.ipv4Addr.srcAddr.addr); 
                    printf("dstAddr:%x\n",sa_aquire_data.saMsg.ipAddr.ipv4Addr.dstAddr.addr);
                    printf("srcPort:%x\n",sa_aquire_data.saMsg.l4Info.portInfo.srcPort.port);
                    printf("dstPort:%x\n",sa_aquire_data.saMsg.l4Info.portInfo.dstPort.port);
                    printf("protocol:%x\n",sa_aquire_data.saMsg.protocol);
                }
                break;
            case ADK_IPSEC_EXCEPTION_SA_EXPIRE:
                {
                    memcpy(&sa_expiry_data,&ipsec_cpu_params->exceptionData.saExpiryData,
                            sizeof(adk_ipsec_sa_expiry_excep_data_t));
                    printf("Received ipsec SA EXPIRY exception data\n");
                    printf("direction :%x\n",sa_expiry_data.direction);
                    printf("ipVersion:%x\n",sa_expiry_data.ipVersion);
                    printf("saExpiryType:%s\n",(ADK_HARD_LIFE_EXPIRY == sa_expiry_data.whichExpiry)?"ADK_HARD_LIFE_EXPIRY":"ADK_SOFT_LIFE_EXPIRY" );
                    printf("dstAddr:%x\n",sa_expiry_data.ipAddrInfo.ipv4dstAddr.addr); 
                    printf("protocol:%x\n",sa_expiry_data.protocol);
                    printf("spi:%x\n",sa_expiry_data.spi);

                }
                break;
            default:
                printf("Invalid exception type is received \n");
                return 0;
        }
    }
    return 0;
}
/*************PH Init-End**********/
void ip_demo_copied_ies_event_handler_func_adk(const struct ies_event *ies_event);
void ip_demo_copied_ies_event_handler_func_adk(const struct ies_event *ies_event)
{
    char ies_event_name[IES_EVENT_MAX_NAME_SIZE];

    if (ies_event != NULL)
    {
        ies_trace("ies_event_get_name()\n");
        if (ies_event_get_name(ies_event->type, ies_event_name,
                               IES_EVENT_MAX_NAME_SIZE) == IES_OK)
            printf("IES_EVENT : %s\n", ies_event_name);
        else
            printf("IES_EVENT : Unknown\n");
        /**
        * Now handle the event itself...
        * Place holder for now with just print statements
        */
        switch (ies_event->type)
        {
        case IES_EVENT_PORT_STATE:
            printf("Port %d is %s\n", ies_event->info.port_state.port,
                   (ies_event->info.port_state.status ==
                    IES_PORT_STATUS_LINK_UP)? "UP" : "DOWN");
            break;
        case IES_EVENT_SWITCH_STATE:
            printf("Switch State is %s\n",
                   (ies_event->info.switch_state.status ==
                    IES_SWITCH_STATE_UP)? "UP" : "DOWN or HOLD");
            break;
        default:
            break;
        }
        fflush(stdout);
    }
}

int main(int argc, char **argv)
{
    int rteRetVal = 0;
    adk_status_t retVal=0;

    if(setup_hlp(ip_demo_copied_ies_event_handler_func_adk))
    {
        rte_panic("%s, setup_hlp failed\n",__func__);
        return -1;
    }
	rteRetVal = rte_eal_init(argc, argv);
    if (rteRetVal < 0)
    {
        rte_panic("%s, rte_eal_init failed\n",__func__);
        return -1;
    }

    /* rte_bridge_cppi_init() is called in CP, so that memzone for
     * RTE_CPPI_MEMZONE_NAME is available during adk_ph_dev_device_configure().
     */
    rteRetVal = rte_bridge_cppi_init();
    if (rteRetVal < 0)
    {
        printf("Failed to bridge cppi init \n");
        return -1;
    }
    /* Getting all the Module handles */
    retVal = adk_syshandle_get(TRUE, 1, &adkSysHdl);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to syshandle get \n");
        return -1;
    }
    /*Initialize PH CP memory */
    if(adk_ph_dev_instance_get(adkSysHdl))
    {
        printf("Failed to initialize ADK PH Dev System!\n");
        return -1;
    }
    retVal = adk_module_handle_get(adkSysHdl, ADK_ETHERNET_MODULE_ID, adk_ethernet_service_function_update, &ethHdl);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to Eth Module handle \n");
        return -1;
    }
    retVal = adk_module_handle_get(adkSysHdl, ADK_IP_MODULE_ID, adk_ip_service_function_update, &ipv4Hdl);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to IPv4 module handle \n");
        return -1;
    }
    retVal = adk_module_handle_get(adkSysHdl, ADK_IPV6_MODULE_ID, adk_ipv6_service_function_update, &ipv6Hdl);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to IPv6 module handle \n");
        return -1;
    }

    retVal = adk_module_handle_get(adkSysHdl, ADK_IPSEC_MODULE_ID, adk_ipsec_service_function_update, &ipsecHdl);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to IPsec module handle \n");
        return -1;
    }
    /* Lookup the memory pool for test shared data */
    retVal = test_shm_lookup(TEST_CONFIG_MEMORY_POOL,
                               (test_shm_handle_t **)&testConfShm_p);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to get TEST_CONFIG_MEMORY_POOL \n");
        return -1;
    }
	retVal = adk_ph_app_init(adkSysHdl);
    if (retVal != ADK_SUCCESS)
    {
        printf("Failed to PH APP init \n");
        return -1;
    }
#if 0
  	if(ADK_SUCCESS != eth_ph_exception_parser_register())
        return 1;
#endif
    /*Register the ethernet callback function to PH*/
    retVal = adk_ph_dev_callback_fn_add((void*)call_back_fn_eth_ph_dev,
                                       NULL,
                                       &eth_cb_fn_handle);
    if (retVal != ADK_SUCCESS)
    {
        printf ("Failed to register callback fn for ethernet ,returnval = 0x%x\n",
                 retVal);
        return -1;
    }

    /*Register the ipsec callback function to PH*/
    retVal = adk_ph_dev_callback_fn_add((void*)call_back_fn_ipsec_ph_dev,
                                       NULL,
                                       &ipsec_cb_fn_handle);
    if (retVal != ADK_SUCCESS)
    {
        printf ("Failed to register callback fn for ethernet ,returnval = 0x%x\n",
                 retVal);
        return 1;
    }

    Tcl_Main(1, argv, Tcl_AppInit);
    exit(EXIT_SUCCESS);
}

