# Create Eth Intf
#source conf_files/tcl/ipsect_encryption_UL_path.tcl
create-eth-bridge-interface
create-eth-switch-virtual-interface vlan-id 200
create-eth-ingress-flow
#enable ipsec
ip-bypass-ipsec bypass 0
udp-checksum-validation validate 0
#QOS
adk-qos-policing-flow-create
adk-eth-type-based-qos-policy-set
configure-ip-qos-classifier
# IP configuration
create-ip-interface addr 100.100.100.1 prefix-width 24 mtu 9000 handle bridge
create-ip-interface addr 101.101.101.1 prefix-width 24 mtu 9000 handle svif
#add-eth-arp-entry next-hop 100.100.100.2 mac-address 00:00:01:00:05:01
#add-eth-arp-entry next-hop 101.101.101.2 mac-address 00:00:01:00:05:01

add-eth-arp-entry next-hop 100.100.100.2 mac-address 9A:DC:9A:F3:64:E8
add-eth-arp-entry next-hop 101.101.101.2 mac-address 9A:DC:9A:F3:64:E8
#   ADK_IP_ING_CLASSIFIER_ACTION_DROP = 1,
#    /*! Forward to a program running on host processor */
#    ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_HOST = 2,
#    /*! Forward to a EVENT OBJECT running in EVENT MACHINE */
#    ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO = 3,
#    /*! IP protocol type mask */
#    ADK_IP_ING_CLASSIFIER_PROTO_MASK     = 0x01,
#    /*! Destination address mask */
#    ADK_IP_ING_CLASSIFIER_DEST_ADDR_MASK = 0x02,
#    /*! Source address mask */
#    ADK_IP_ING_CLASSIFIER_SRC_ADDR_MASK  = 0x04,
#    /*! Interface Handle mask */
#    ADK_IP_ING_CLASSIFIER_INTF_HANDLE_MASK = 0x08,
#    /*! Source Port mask */
#    ADK_IP_ING_CLASSIFIER_SRC_PORT_MASK = 0x10,
#    /*! Destination Port */
#    ADK_IP_ING_CLASSIFIER_DEST_PORT_MASK  = 0x20,
#    /*! ICMP Type MASK */
#    ADK_IP_ING_CLASSIFIER_ICMP_TYPE_MASK  = 0x40,
#    /*! ICMP Code MASK */
#    ADK_IP_ING_CLASSIFIER_ICMP_CODE_MASK  = 0x80,
add-ip-proto-support proto 1
add-ip-proto-support proto 2
add-ip-proto-support proto 6
add-ip-proto-support proto 17
add-ip-proto-support proto 50
add-ip-proto-support proto 132
add-ip-proto-support proto 136
add-ip-ingress-classifier-rule src-addr 200.200.200.1 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 4
add-ip-ingress-classifier-rule src-addr 201.201.201.1 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 4
#PBR
adk-ip-pbr-conf-def-route-table
adk-ip-pbr-add-policy src-addr 100.100.100.1 src-prefix-width 16 route-table-id 10
adk-ip-pbr-add-policy src-addr 100.101.101.1 src-prefix-width 16 route-table-id 20
adk-ip-pbr-commit
add-ip-route route-table-id 10 dest-ip 200.200.200.1 prefix-width 24 next-hop 100.100.100.2 route-mtu 9000
add-ip-route route-table-id 20 dest-ip 201.201.201.1 prefix-width 24 next-hop 101.101.101.2 route-mtu 9000
#        ADK_IPSEC_SP_ACTION_IPSEC = 1,
#        /*! security policy action as drop  */
#        ADK_IPSEC_SP_ACTION_DROP,
#        /*! security policy action as bypass  */
#        ADK_IPSEC_SP_ACTION_BYPASS,
#        ADK_IPSEC_SP_ACTION_MAX
# IPSEC IN
add-ipsec-sp-in src-addr-begin 200.200.200.1 src-addr-end 200.200.200.2 \
	dst-addr-begin 100.100.100.1  dst-addr-end 100.100.100.1  \
	action 3 ip-version 4 protocol 17 src-port-begin 101 src-port-end 101 dst-port-begin 2152 dst-port-end 2152
	
add-ip-ingress-classifier-rule src-addr 200.200.200.1 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 0
add-ip-ingress-classifier-rule src-addr 201.201.201.1 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 0

add-ip-ingress-classifier-build

#add-ipsec-sp src-addr-begin 100.100.100.1 src-addr-end 100.100.100.1 dst-addr-begin 200.200.200.1 dst-addr-end 200.200.200.1 src-port-begin 63 \
	src-port-end 63 dst-port-begin 63 dst-port-end 63 protocol 17 dscp-val 255 action 1 tunnel-mode 1 \
	pre-frag 1 config-df 0 esp-proto 1 mtu 500 ip-version 4 single-sa-in-pre-frag 0
	
#add-ipsec-sp src-addr-begin 0.0.0.1 src-addr-end 255.255.255.255 dst-addr-begin 0.0.0.1 dst-addr-end 255.255.255.255 src-port-begin 0 
add-ipsec-sp src-addr-begin  100.100.100.1 src-addr-end 100.100.100.1 dst-addr-begin 200.200.200.1 dst-addr-end  200.200.200.1 src-port-begin 0 \
	src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 17 dscp-val 255 action 1 tunnel-mode 1 \
	pre-frag 0 config-df 0 esp-proto 1 mtu 500 ip-version 4 single-sa-in-pre-frag 0

add-ipsec-sa mode 0 life-time 0 protocol 1 \
                anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
                soft-byte-life 4000000 hard-byte-life 8000000 ip-version 4 spi 4003 \
                ttl 64 tunnel-srp-ip 100.100.100.1 tunnel-dsp-ip 200.200.200.1 direction 0 \
                auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa param 0
				
#add-ipsec-sa mode 0 life-time 0 protocol 1 \
                anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
                soft-byte-life 4000000 hard-byte-life 8000000 ip-version 4 spi 4003 \
                ttl 64 tunnel-srp-ip 100.100.100.1 tunnel-dsp-ip 200.200.200.1 direction 0 \
                auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa param 0		


# protocol: 
#	IPPROTO_UDP = 17 
#action:
#		 ADK_IPSEC_SP_ACTION_IPSEC;
#		 ADK_IPSEC_SP_ACTION_IPSEC = 1,
#        /*! security policy action as drop  */
#        ADK_IPSEC_SP_ACTION_DROP,
#        /*! security policy action as bypass  */
#        ADK_IPSEC_SP_ACTION_BYPASS,
#        ADK_IPSEC_SP_ACTION_MAX
#
#    ADK_IPSEC_AH,
#    ADK_IPSEC_ESP


# ip-version:
#		 ADK_IPSEC_IPV4 = 4,
#        /*! signifies value to be ued for IPv6 support */
#        ADK_IPSEC_IPV6 = 6
#anti-replay-window-sz:	
#    ADK_IPSEC_ARW_MIN  = 64,
#    ADK_IPSEC_ARW_64   = 64,
#    ADK_IPSEC_ARW_128  = 128,
#    ADK_IPSEC_ARW_256  = 256,
#    ADK_IPSEC_ARW_512  = 512,
#    ADK_IPSEC_ARW_1024 = 1024,
#    ADK_IPSEC_ARW_4096 = 4096,
#    ADK_IPSEC_ARW_MAX  = 4096

#auth:
#    ADK_IPSEC_AUTH_NULL          = 0,
#    ADK_IPSEC_AUTH_HMAC_MD5      = 1,
#    ADK_IPSEC_AUTH_HMAC_SHA1     = 2,
#    ADK_IPSEC_AUTH_AES_CMAC      = 8,
#    ADK_IPSEC_AUTH_AES_XCBC_MAC  = 9, /* As per RFC 3566 */
#    ADK_IPSEC_AUTH_HMAC_SHA_256  = 12,
#    ADK_IPSEC_AUTH_HMAC_SHA_384  = 13,
#    ADK_IPSEC_AUTH_HMAC_SHA_512  = 14,
#    /* As per RFC 4543, AES-GMAC in ESP is identified by an encryption
#     * transform identifier - that is used to reference
#     * ADK_IPSEC_ENCR_NULL_GMAC. Hence assigning temporary values to
#     * AUTH_AES_128_GMAC and AUTH_AES_256_GMAC.
#     */
#    ADK_IPSEC_AUTH_AES_128_GMAC  = 15,
#    ADK_IPSEC_AUTH_AES_256_GMAC  = 16,
#    ADK_IPSEC_AUTH_MAX

#encr:
#    ADK_IPSEC_ENCR_DES_CBC       = 2,   /* 64-bit key */
#    ADK_IPSEC_ENCR_3DES_CBC      = 3,
#    ADK_IPSEC_ENCR_NULL          = 11,
#    ADK_IPSEC_ENCR_AES_CBC       = 12,
#    ADK_IPSEC_ENCR_AES_CTR       = 13,
#    ADK_IPSEC_ENCR_AES_CCM_ICV8  = 14,
#    ADK_IPSEC_ENCR_AES_CCM_ICV12 = 15,
#    ADK_IPSEC_ENCR_AES_CCM_ICV16 = 16,
#    ADK_IPSEC_ENCR_AES_GCM_ICV8  = 18,
#    ADK_IPSEC_ENCR_AES_GCM_ICV12 = 19,
#    ADK_IPSEC_ENCR_AES_GCM_ICV16 = 20,
#    ADK_IPSEC_ENCR_NULL_GMAC     = 21,
#    ADK_IPSEC_ENCR_MAX

#direction:
#(gdb) p /x ADK_IPSEC_INBOUND
#$17 = 0x1
#(gdb) p /x ADK_IPSEC_OUTBOUND
#$18 = 0x0
				
