# Create Eth Intf
create-eth-bridge-interface
create-eth-switch-virtual-interface vlan-id 200 index 0
create-eth-ingress-flow

#enable/disable ipsec bypass ipsec
ip-bypass-ipsec bypass 0

# UDP Checksum validation cfg
udp-checksum-validation validate 1

#QoS cfg
adk-qos-policing-flow-create
#adk-eth-type-based-qos-policy-set //needed only for IPv4(ARP)
configure-ipv6-qos-classifier

# IPv6 configuration
# IPv6 bridge interface created based on Destination IP address
create-ipv6-interface addr 2004:0000:1234:5678:1122:3344:5566:7701 prefix-width 112 mtu 9000 handle bridge
# IPv6 svif interface created based on next Destination IP address
create-ipv6-interface addr 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 prefix-width 112 mtu 9000 handle svif index 0

#Add static eth neigh entry
add-eth-neigh-entry next-hop 2004:0000:1234:5678:1122:3344:5566:7702 mac-address 00:00:01:00:05:01
add-eth-neigh-entry next-hop 2003:0000:ABCD:EF98:AABB:CC11:0000:0002 mac-address 00:00:01:00:05:01

#Support All protocols
add-ipv6-proto-support proto 58
add-ipv6-proto-support proto 2
add-ipv6-proto-support proto 6
add-ipv6-proto-support proto 17
add-ipv6-proto-support proto 50
add-ipv6-proto-support proto 132
add-ipv6-proto-support proto 136

#Reassembly timeout cfg : 5s
add-ipv6-reassembly-timeout timeoutInMilliSec 5000

#Add ipv6 ingress classifer rule with source ip address, action as ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO
add-ipv6-ingress-classifier-rule src-addr 2004:0000:1234:5678:1122:3344:5566:7701 prefix-width 112 action 3 em-recv-q-id 3277057 rule-mask 4
#Add ipv6 ingress classifer rule with source ip+1 address, action as ADK_IP_ING_CLASSIFIER_ACTION_SEND_TO_EO
add-ipv6-ingress-classifier-rule src-addr 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 prefix-width 112 action 3 em-recv-q-id 3277057 rule-mask 4
#Build ipv6 ingress classifier
add-ipv6-ingress-classifier-build


#IPSec SPD/SPD-IN/SA cfg over plain intf
add-ipsec-sp-in src-addr-begin 2004:0000:1234:5678:1122:3344:5566:7702 src-addr-end 2004:0000:1234:5678:1122:3344:5566:7702 \
    dst-addr-begin 2004:0000:1234:5678:1122:3344:5566:7701 dst-addr-end 2004:0000:1234:5678:1122:3344:5566:7701  \
    action 3 ip-version 6 protocol 0 src-port-begin 2152 src-port-end 2152 dst-port-begin 101 dst-port-end 101
    
add-ipsec-sp src-addr-begin 2004:0000:1234:5678:1122:3344:5566:7701 src-addr-end 2004:0000:1234:5678:1122:3344:5566:7701 \
    dst-addr-begin 2004:0000:1234:5678:1122:3344:5566:7702 dst-addr-end  2004:0000:1234:5678:1122:3344:5566:7702 src-port-begin 0 \
    src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 0 dscp-val 255 action 1 tunnel-mode 1 \
    pre-frag 1 config-df 1 esp-proto 1 mtu 1300 ip-version 6 single-sa-in-pre-frag 1
    
add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 1 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip 2004:0000:1234:5678:1122:3344:5566:7701 tunnel-dsp-ip 2004:0000:1234:5678:1122:3344:5566:7702 direction 0 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0

add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip 2004:0000:1234:5678:1122:3344:5566:7702 tunnel-dsp-ip 2004:0000:1234:5678:1122:3344:5566:7701 direction 1 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0

   ## Below SA is to support prefrag when useSingleSa is False
add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4004 \
    ttl 64 tunnel-srp-ip 2004:0000:1234:5678:1122:3344:5566:7702 tunnel-dsp-ip 2004:0000:1234:5678:1122:3344:5566:7701 direction 1 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0

#IPSec SPD/SPD-IN/SA cfg over VLAN intf
add-ipsec-sp-in src-addr-begin 2003:0000:ABCD:EF98:AABB:CC11:0000:0002 src-addr-end 2003:0000:ABCD:EF98:AABB:CC11:0000:0002 \
    dst-addr-begin 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 dst-addr-end 2003:0000:ABCD:EF98:AABB:CC11:0000:0001  \
    action 3 ip-version 6 protocol 0 src-port-begin 2152 src-port-end 2152 dst-port-begin 101 dst-port-end 101
    
add-ipsec-sp src-addr-begin 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 src-addr-end 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 \
    dst-addr-begin 2003:0000:ABCD:EF98:AABB:CC11:0000:0002 dst-addr-end  2003:0000:ABCD:EF98:AABB:CC11:0000:0002 src-port-begin 0 \
    src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 0 dscp-val 255 action 1 tunnel-mode 1 \
    pre-frag 1 config-df 1 esp-proto 1 mtu 1300 ip-version 6 single-sa-in-pre-frag 0
    
add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 tunnel-dsp-ip 2003:0000:ABCD:EF98:AABB:CC11:0000:0002 direction 0 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0

add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip 2003:0000:ABCD:EF98:AABB:CC11:0000:0002 tunnel-dsp-ip 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 direction 1 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0

add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4004 \
    ttl 64 tunnel-srp-ip 2003:0000:ABCD:EF98:AABB:CC11:0000:0002 tunnel-dsp-ip 2003:0000:ABCD:EF98:AABB:CC11:0000:0001 direction 1 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0

#IPv6 Route and PBR cfg

adk-ipv6-pbr-conf-def-route-table def-table-id 200
adk-ipv6-route-add route-table-id 200 dest-ip 2004:0000:1234:5678:1122:3344:5566:7702 prefix-width 128 route-mtu 9000 \
                      onlink 1 onlink-handle ip-handle index 0
adk-ipv6-pbr-add src-addr 2004:0000:1234:5678:1122:3344:5566:7701 src-prefix-width 128 route-table-id 200
adk-ipv6-pbr-commit

#IPv6 Logging
ipv6-logging level 15
#    ADK_SEV_LEVEL_DEBUG = 31,
#    ADK_SEV_LEVEL_INFO = 15,
#    ADK_SEV_LEVEL_WARNING = 7,
#    ADK_SEV_LEVEL_ERROR = 3,
#    ADK_SEV_LEVEL_FATAL = 1,
#    ADK_SEV_LEVEL_DISABLE = 0
