# Create Eth Intf
#source conf_files/tcl/ipsect_encryption_UL_path.tcl
#Declare all script varialbes
#set base values for all params

#vid starts from 10 upto 19.
set vid_base 9
#Set UL path SIP as ip_src and DIP as ip_dst:DUT config
#SIP varies from 9.1.1.1, 10.1.1.1,......19.1.1.1
#DIP vaire from 49.1.1.100, 50.1.1.100,51.1.1.100.....59.1.1.100
set ip_src_base 2004
set ip_dst_base 3004
#Route table id 9, 10....19
set route_tbl_id_base 9
#spi starts from 49, 50,....54
set spi_count_base 49
set start_spd_index_base 0

#Configure BD intf separately first
set vid $vid_base
set ip_src $ip_src_base
set ip_dst $ip_dst_base
set route_tbl_id $route_tbl_id_base
set spi_count $spi_count_base
set start_spd_index $start_spd_index_base
#Create ethernet bridge interface
create-eth-bridge-interface
create-eth-ingress-flow
#enable ipsec
ip-bypass-ipsec bypass 0
udp-checksum-validation validate 1
#QOS
adk-qos-policing-flow-create
adk-eth-type-based-qos-policy-set
#Support all ip protocol
add-ipv6-proto-support proto 58
add-ipv6-proto-support proto 2
add-ipv6-proto-support proto 6
add-ipv6-proto-support proto 17
add-ipv6-proto-support proto 50
add-ipv6-proto-support proto 132
add-ipv6-proto-support proto 136
#default PBR and route
adk-ipv6-pbr-conf-def-route-table def-table-id 44
#Configure BRIDGE related IP intf, route, pbr etc. separately
create-ipv6-interface addr $ip_src:0000:1234:5678:1122:3344:5566:7701 prefix-width 112 mtu 9000 handle bridge
adk-ipv6-pbr-add src-addr $ip_src:0000:1234:5678:1122:3344:5566:7701 src-prefix-width 128 route-table-id $route_tbl_id
add-ipv6-next-hop-add addr $ip_src:0000:1234:5678:1122:3344:5566:7702 index 0
adk-ipv6-route-add route-table-id $route_tbl_id dest-ip $ip_dst:0000:1234:5678:1122:3344:5566:7703 prefix-width 128 route-mtu 9000 \
                      onlink 0 onlink-handle nh-handle index 0
add-eth-neigh-entry next-hop $ip_src:0000:1234:5678:1122:3344:5566:7702 mac-address 00:00:01:00:05:01


#IPSec SPD/SPD-IN/SA cfg over plain intf
add-ipsec-sp-in src-addr-begin $ip_dst:0000:1234:5678:1122:3344:5566:7703 src-addr-end $ip_dst:0000:1234:5678:1122:3344:5566:7703 \
    dst-addr-begin $ip_src:0000:1234:5678:1122:3344:5566:7701 dst-addr-end $ip_src:0000:1234:5678:1122:3344:5566:7701  \
    action 3 ip-version 6 protocol 0 src-port-begin 2152 src-port-end 2152 dst-port-begin 101 dst-port-end 101

add-ipsec-sp src-addr-begin $ip_src:0000:1234:5678:1122:3344:5566:7701 src-addr-end $ip_src:0000:1234:5678:1122:3344:5566:7701 \
    dst-addr-begin $ip_dst:0000:1234:5678:1122:3344:5566:7703 dst-addr-end $ip_dst:0000:1234:5678:1122:3344:5566:7703  \
    src-port-begin 0 src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 0 dscp-val 255 action 1 tunnel-mode 1 \
    pre-frag 1 config-df 1 esp-proto 1 mtu 1300 ip-version 6 single-sa-in-pre-frag 1


add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 1 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip $ip_src:0000:1234:5678:1122:3344:5566:7701 tunnel-dsp-ip $ip_dst:0000:1234:5678:1122:3344:5566:7703 direction 0 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0

add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip $ip_dst:0000:1234:5678:1122:3344:5566:7703 tunnel-dsp-ip $ip_src:0000:1234:5678:1122:3344:5566:7701 direction 1 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex 0


set count 1
while {$count < 7 } {
	set vid [expr $count + $vid_base]
	set ip_src [expr $count + $ip_src_base]
	set ip_dst [expr $count + $ip_dst_base]
	set route_tbl_id [expr $count + $route_tbl_id_base]
	set spi_count [expr $count + $spi_count_base]
	set start_spd_index [expr $count]

	create-eth-switch-virtual-interface vlan-id $vid index $count
	puts "\n\n**********vif interface vid:$vid and index:$count\n"
	create-ipv6-interface addr $ip_src:0000:1234:5678:1122:3344:5566:7701 prefix-width 112 mtu 9000 handle svif index $count
	puts "\n\n**********ip interface:$ip_src:0000:1234:5678:1122:3344:5566:7701 and index:$count\n"
	#Add ethernet arp entry for next hop using bridge mac address.
	add-eth-neigh-entry next-hop $ip_src:0000:1234:5678:1122:3344:5566:7702 mac-address 9A:DC:9A:F3:64:E8
	#FIXME:Mallesh - take SIP as rule mask. Fix in tcl.c as well as other tcl files. Overwriting as ANY for now
    add-ipv6-ingress-classifier-rule src-addr $ip_src:0000:1234:5678:1122:3344:5566:7701 prefix-width 128 action 3 em-recv-q-id 3277057 rule-mask 4
    adk-ipv6-pbr-conf-def-route-table def-table-id 44
    add-ipv6-next-hop-add addr $ip_src:0000:1234:5678:1122:3344:5566:7702 index $count
    adk-ipv6-route-add route-table-id $route_tbl_id dest-ip $ip_dst:0000:1234:5678:1122:3344:5566:7703 prefix-width 128 route-mtu 9000 \
                      onlink 0 onlink-handle nh-handle index $count
    adk-ipv6-pbr-add src-addr $ip_src:0000:1234:5678:1122:3344:5566:7701 src-prefix-width 128 route-table-id $route_tbl_id

	#IPSEC
    add-ipsec-sp-in src-addr-begin $ip_dst:0000:1234:5678:1122:3344:5566:7703 src-addr-end $ip_dst:0000:1234:5678:1122:3344:5566:7703 \
    dst-addr-begin $ip_src:0000:1234:5678:1122:3344:5566:7701 dst-addr-end $ip_src:0000:1234:5678:1122:3344:5566:7701  \
    action 3 ip-version 6 protocol 0 src-port-begin 2152 src-port-end 2152 dst-port-begin 101 dst-port-end 101

    add-ipsec-sp src-addr-begin $ip_src:0000:1234:5678:1122:3344:5566:7701 src-addr-end $ip_src:0000:1234:5678:1122:3344:5566:7701 \
    dst-addr-begin $ip_dst:0000:1234:5678:1122:3344:5566:7703 dst-addr-end $ip_dst:0000:1234:5678:1122:3344:5566:7703  \
    src-port-begin 0 src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 0 dscp-val 255 action 1 tunnel-mode 1 \
    pre-frag 1 config-df 1 esp-proto 1 mtu 1300 ip-version 6 single-sa-in-pre-frag 1


#direction:
#(gdb) p /x ADK_IPSEC_INBOUND
#$17 = 0x1
#(gdb) p /x ADK_IPSEC_OUTBOUND
#$18 = 0x0
	#FIXME: 
	#Adding policy and SA at index 0 only. For different index, add_sp needs to be enhanced to take index param
	#Also, enhance add SA to store sa handles for each SA as per index
	set start_spd_index 0
    
	#Egress side-Direction:0

    add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 1 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip $ip_src:0000:1234:5678:1122:3344:5566:7701 tunnel-dsp-ip $ip_dst:0000:1234:5678:1122:3344:5566:7703 direction 0 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex $start_spd_index

	#Ingress side-Direction:1
    add-ipsec-sa mode 0 life-time 0 protocol 1 \
    anti-replay 0 anti-replay-window-sz 64 auth 2 encr 12 \
    soft-byte-life 4000000 hard-byte-life 8000000 ip-version 6 spi 4003 \
    ttl 64 tunnel-srp-ip $ip_dst:0000:1234:5678:1122:3344:5566:7703 tunnel-dsp-ip $ip_src:0000:1234:5678:1122:3344:5566:7701 direction 1 \
    auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex $start_spd_index
	
	#puts "\n\n**********Configuring QoS Classifier for all intf - begin \n"
	#configure-ip-qos-classifier
	#puts "\n\n**********Configuring QoS Classifier for all intf - end \n"
	puts "In While ADK config for count = $count"
	incr count
}
#puts "\n\n**********Configuring QoS Classifier for all intface - begin \n"
#configure-ipv6-qos-classifier
#puts "\n\n**********Configuring QoS Classifier for all intface - end \n"
adk-ipv6-pbr-commit
add-ipv6-ingress-classifier-build
