# Create Eth Intf
#source conf_files/tcl/ipsect_encryption_UL_path.tcl
#Declare all script varialbes
#set base values for all params

#vid starts from 10 upto 19.
set vid_base 9
#Set UL path SIP as ip_src and DIP as ip_dst:DUT config
#SIP varies from 9.1.1.1, 10.1.1.1,......19.1.1.1
#DIP vaire from 49.1.1.100, 50.1.1.100,51.1.1.100.....59.1.1.100
set ip_src_base 9
set ip_dst_base 49
#Route table id 9, 10....19
set route_tbl_id_base 9
#spi starts from 49, 50,....54
set spi_count_base 49
set start_spd_index_base 0

#Configure BD intf separately first
set vid $vid_base
set ip_src $ip_src_base
set ip_dst $ip_dst_base
set route_tbl_id $route_tbl_id_base
set spi_count $spi_count_base
set start_spd_index $start_spd_index_base
#Create ethernet bridge interface
create-eth-bridge-interface
create-eth-ingress-flow
#enable ipsec
ip-bypass-ipsec bypass 0
udp-checksum-validation validate 1
#QOS
adk-qos-policing-flow-create
adk-eth-type-based-qos-policy-set
#Support all ip protocol
add-ip-proto-support proto 1
add-ip-proto-support proto 2
add-ip-proto-support proto 6
add-ip-proto-support proto 17
add-ip-proto-support proto 50
add-ip-proto-support proto 132
add-ip-proto-support proto 136
#default PBR and route
adk-ip-pbr-conf-def-route-table
#Configure BRIDGE related IP intf, route, pbr etc. separately
create-ip-interface addr $ip_src.1.1.1 prefix-width 24 mtu 9000 handle bridge
adk-ip-qos-policy-add src-add $ip_src.1.1.1 prefix-width 24
adk-ip-pbr-add-policy src-addr $ip_src.1.1.1 src-prefix-width 16 route-table-id $route_tbl_id
add-eth-arp-entry next-hop $ip_src.1.1.2 mac-address 00:00:01:00:05:01
add-ip-route route-table-id $route_tbl_id dest-ip $ip_src.1.1.100 prefix-width 16 connected-route 1 l2-handle bridge index 0 next-hop $ip_src.1.1.2 route-mtu 9000
add-ip-route route-table-id $route_tbl_id dest-ip $ip_dst.1.1.100 prefix-width 16 connected-route 0 l2-handle bridge index 0 next-hop $ip_src.1.1.2 route-mtu 9000
#not adding classifier for bridge as it is currently configured for ANY 
#add-ip-ingress-classifier-rule src-addr $ip_dst.1.1.100 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 4
#add-ip-ingress-classifier-rule src-addr $ip_dst.1.1.100 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 0
#IPSEC
add-ipsec-sp-in src-addr-begin $ip_dst.1.1.0 src-addr-end $ip_dst.1.1.255 \
		dst-addr-begin $ip_src.1.1.1 dst-addr-end $ip_src.1.1.1 \
		action 3 ip-version 4 protocol 17 src-port-begin 101 src-port-end 101 dst-port-begin 2152 dst-port-end 2152
add-ipsec-sp src-addr-begin $ip_src.1.1.1 src-addr-end $ip_src.1.1.1 dst-addr-begin $ip_dst.1.1.0 dst-addr-end $ip_dst.1.1.255 \
		src-port-begin 0 src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 17 dscp-val 255 \
		action 1 tunnel-mode 1 pre-frag 1 config-df 0 esp-proto 1 mtu 1500 ip-version 4 single-sa-in-pre-frag 1

add-ipsec-sa mode 0 life-time 0 protocol 1 \
		anti-replay 1 anti-replay-window-sz 64 auth 2 encr 12 \
		soft-byte-life 4000000 hard-byte-life 8000000 ip-version 4 spi $spi_count \
		ttl 64 tunnel-srp-ip $ip_src.1.1.1 tunnel-dsp-ip $ip_dst.1.1.1 direction 0 \
		auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex start_spd_index

#Ingress side-Direction:1
add-ipsec-sa mode 0 life-time 0 protocol 1 \
		anti-replay 1 anti-replay-window-sz 64 auth 2 encr 12 \
		soft-byte-life 4000000 hard-byte-life 8000000 ip-version 4 spi $spi_count \
		ttl 64 tunnel-srp-ip $ip_dst.1.1.1 tunnel-dsp-ip $ip_src.1.1.1 direction 1 \
		auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex start_spd_index
set count 1
#for { set count 1} {$count < 8} {incr count} {
while {$count < 11 } {
	set vid [expr $count + $vid_base]
	set ip_src [expr $count + $ip_src_base]
	set ip_dst [expr $count + $ip_dst_base]
	set route_tbl_id [expr $count + $route_tbl_id_base]
	set spi_count [expr $count + $spi_count_base]
	set start_spd_index [expr $count]

	#Create SVIF interface with vlan-id start with 10 and index 0
	create-eth-switch-virtual-interface vlan-id $vid index $count
	puts "\n\n**********vif interface vid:$vid and index:$count\n"
	#Create IP interface with ip start with 10.1.1.1, prefix width 24, mtu 9000 svif index 0
	create-ip-interface addr $ip_src.1.1.1 prefix-width 24 mtu 9000 handle svif index $count
	puts "\n\n**********ip interface:$ip_src.1.1.1 and index:$count\n"
	adk-ip-qos-policy-add src-add $ip_src.1.1.1 prefix-width 24
	#Add ethernet arp entry for next hop using bridge mac address.
	add-eth-arp-entry next-hop $ip_src.1.1.2 mac-address 00:00:01:00:05:01
	#FIXME:Mallesh - take SIP as rule mask. Fix in tcl.c as well as other tcl files. Overwriting as ANY for now
	add-ip-ingress-classifier-rule src-addr $ip_dst.1.1.100 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 4
	add-ip-ingress-classifier-rule src-addr $ip_dst.1.1.100 prefix-width 16 action 3 em-recv-q-id 3276801 rule-mask 0
	adk-ip-pbr-add-policy src-addr $ip_src.1.1.1 src-prefix-width 16 route-table-id $route_tbl_id
add-ip-route route-table-id $route_tbl_id dest-ip $ip_src.1.1.100 prefix-width 16 connected-route 1 l2-handle svif index $count next-hop $ip_src.1.1.2 route-mtu 9000

add-ip-route route-table-id $route_tbl_id dest-ip $ip_dst.1.1.100 prefix-width 16 connected-route 0 l2-handle svif index $count next-hop $ip_src.1.1.2 route-mtu 9000
add-ip-route route-table-id $route_tbl_id dest-ip $ip_dst.1.1.100 prefix-width 16 connected-route 0 l2-handle svif index $count next-hop $ip_src.1.1.2 route-mtu 9000

	adk-ip-pbr-commit
	add-ip-ingress-classifier-build
	#IPSEC
	add-ipsec-sp-in src-addr-begin $ip_dst.1.1.0 src-addr-end $ip_dst.1.1.255 \
		dst-addr-begin $ip_src.1.1.1 dst-addr-end $ip_src.1.1.1 \
		action 3 ip-version 4 protocol 17 src-port-begin 101 src-port-end 101 dst-port-begin 2152 dst-port-end 2152
	
	add-ipsec-sp src-addr-begin $ip_src.1.1.1 src-addr-end $ip_src.1.1.1 dst-addr-begin $ip_dst.1.1.0 dst-addr-end $ip_dst.1.1.255 src-port-begin 0 \
	src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 17 dscp-val 255 action 1 tunnel-mode 1 \
	pre-frag 1 config-df 0 esp-proto 1 mtu 1500 ip-version 4 single-sa-in-pre-frag 1

#direction:
#(gdb) p /x ADK_IPSEC_INBOUND
#$17 = 0x1
#(gdb) p /x ADK_IPSEC_OUTBOUND
#$18 = 0x0
	#FIXME: 
	#Adding policy and SA at index 0 only. For different index, add_sp needs to be enhanced to take index param
	#Also, enhance add SA to store sa handles for each SA as per index
	set start_spd_index 0
	#Egress side-Direction:0	
	add-ipsec-sa mode 0 life-time 0 protocol 1 \
                anti-replay 1 anti-replay-window-sz 64 auth 2 encr 12 \
                soft-byte-life 4000000 hard-byte-life 8000000 ip-version 4 spi $spi_count \
                ttl 64 tunnel-srp-ip $ip_src.1.1.1 tunnel-dsp-ip $ip_dst.1.1.1 direction 0 \
                auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex $start_spd_index
	
	#Ingress side-Direction:1
	add-ipsec-sa mode 0 life-time 0 protocol 1 \
                anti-replay 1 anti-replay-window-sz 64 auth 2 encr 12 \
                soft-byte-life 4000000 hard-byte-life 8000000 ip-version 4 spi $spi_count \
                ttl 64 tunnel-srp-ip $ip_dst.1.1.1 tunnel-dsp-ip $ip_src.1.1.1 direction 1 \
                auth-key-str aaaaaaaaaaaaaaaaaaaa encr-key-str aaaaaaaaaaaaaaaa startPolIndex $start_spd_index

	#puts "\n\n**********Configuring QoS Classifier for all intf - begin \n"
	#configure-ip-qos-classifier
	#puts "\n\n**********Configuring QoS Classifier for all intf - end \n"
	puts "In While ADK config for count = $count"
	incr count
}
#Plain text support
set ip_src $ip_src_base
set ip_dst $ip_dst_base
add-ipsec-sp-in src-addr-begin $ip_dst.1.2.0 src-addr-end $ip_dst.1.2.255 \
		dst-addr-begin $ip_src.1.1.1 dst-addr-end $ip_src.1.1.1 \
		action 3 ip-version 4 protocol 17 src-port-begin 0 src-port-end 65535 dst-port-begin 0 dst-port-end 65535
add-ipsec-sp src-addr-begin $ip_src.1.1.1 src-addr-end $ip_src.1.1.1 dst-addr-begin $ip_dst.1.2.0 dst-addr-end $ip_dst.1.2.255 \
		src-port-begin 0 src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 17 dscp-val 255 \
		action 3 tunnel-mode 1 pre-frag 1 config-df 0 esp-proto 1 mtu 1500 ip-version 4 single-sa-in-pre-frag 1

set count 1
while {$count < 11 } {
	set ip_src [expr $count + $ip_src_base]
	set ip_dst [expr $count + $ip_dst_base]

	add-ipsec-sp-in src-addr-begin $ip_dst.1.2.0 src-addr-end $ip_dst.1.2.255 \
		dst-addr-begin $ip_src.1.1.1 dst-addr-end $ip_src.1.1.1 \
		action 3 ip-version 4 protocol 17 src-port-begin 0 src-port-end 65535 dst-port-begin 0 dst-port-end 65535
	
	add-ipsec-sp src-addr-begin $ip_src.1.1.1 src-addr-end $ip_src.1.1.1 dst-addr-begin $ip_dst.1.2.0 dst-addr-end $ip_dst.1.2.255 src-port-begin 0 \
	src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 17 dscp-val 255 action 3 tunnel-mode 1 \
	pre-frag 1 config-df 0 esp-proto 1 mtu 1500 ip-version 4 single-sa-in-pre-frag 1
	incr count
}

add-ip-ingress-classifier-rule src-addr 9.1.1.20 prefix-width 32 action 2 em-recv-q-id 3276801 rule-mask 4
add-ip-ingress-classifier-build
add-ipsec-sp-in src-addr-begin 9.1.1.20 src-addr-end 9.1.1.20 \
dst-addr-begin 9.1.1.1 dst-addr-end 9.1.1.1 \
action 3 ip-version 4 protocol 0x0 src-port-begin 0 src-port-end 65535 dst-port-begin 0 dst-port-end 65535

add-ipsec-sp src-addr-begin 9.1.1.1 src-addr-end 9.1.1.1 dst-addr-begin 9.1.1.20 dst-addr-end 9.1.1.20 src-port-begin 0 \
        src-port-end 65535 dst-port-begin 0 dst-port-end 65535 protocol 0x0 dscp-val 255 action 3 tunnel-mode 1 \
        pre-frag 0 config-df 0 esp-proto 0 mtu 9000 ip-version 4 single-sa-in-pre-frag 0
add-eth-arp-entry next-hop 9.1.1.20 mac-address 00:00:01:00:05:01
#puts "\n\n**********Configuring QoS Classifier for all intface - begin \n"
#configure-ip-qos-classifier
#puts "\n\n**********Configuring QoS Classifier for all intface - end \n"
#adk-ip-pbr-commit
#add-ip-ingress-classifier-build
