#if 0
###/* **************************************************************************
###**                                                                          *
###** INTEL CONFIDENTIAL                                                       *
###** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
###**                                                                          *
###** The source code contained or described herein and all documents related  *
###** to the source code ("Material") are owned by Intel Corporation or its    *
###** suppliers or licensors. Title to the Material remains with Intel         *
###** Corporation or its suppliers and licensors. The Material contains trade  *
###** secrets and proprietary and confidential information of Intel or its     *
###** suppliers and licensors. The Material is protected by worldwide          *
###** copyright and trade secret laws and treaty provisions. No part of the    *
###** Material may be used, copied, reproduced, modified, published, uploaded, *
###** posted, transmitted, distributed, or disclosed in any way without        *
###** Intel's prior express written permission.                                *
###**                                                                          *
###** No license under any patent, copyright, trade secret or other            *
###** intellectual property right is granted to or conferred upon you by       *
###** disclosure or delivery of the Materials, either expressly, by            *
###** implication, inducement, estoppel or otherwise. Any license under such   *
###** intellectual property rights must be express and approved by Intel       *
###** in writing.                                                              *
###**                                                                          *
###** **************************************************************************
###**/
###/*!
### * @file  adk_sample_alarm.h
### *
### *      $HeadURL$
### *      $Revision$
### *      $Date$
### * @addtogroup _adkSamples ADK Sample Applications
### * @{
### *
### * @brief ADK alarm related.
### *
### * This file contains all OS specific APIs that are not abstracted by
### * RTE. The APIs in this file should only be used in the sample
### * application, these must not be used in the ADK core code.
### *
### ***********************************************************************/
###
####ifndef __ADK_SAMPLE_ALARM_H__
####define __ADK_SAMPLE_ALARM_H__
###
####include <stdio.h>
####include <adk_sys.h>
###
####define ADK_ALARM_NCP_REG_MPIC_MSK_BIT 0x80000000
####define ADK_ALARM_NCP_REG_MPIC_ACT_BIT 0x40000000
###
###void *adk_alarm_linux_thread_entry(void *data);
###void adk_alarm_xose_thread_entry(void);
###void adk_alarm_event_report(void);
###
###extern ncp_hdl_t __alarmConfig;
###
###typedef pthread_t adk_alarm_thread_id_t;
###/* Macro to create the thread, it needs the PH process config
### * data.
### */
####define ADK_SAMPLE_ALARM_THREAD_CREATE(__alarmConfigData, __threadId) \
###    { \
###        { \
###            __alarmConfig = __alarmConfigData; \
###            if (pthread_create (&(__threadId), \
###                                NULL, \
###                                adk_alarm_linux_thread_entry, \
###                                __alarmConfigData) != 0) \
###            { \
###                printf ("Failed to create the thread, FAILED\n"); \
###            } \
###        } \
###    }
###
###/* Macro to join the thread. */
####define ADK_SAMPLE_ALARM_THREAD_JOIN(__threadId) \
###    { \
###        if (pthread_join ((__threadId), \
###                          NULL) != 0) \
###        { \
###            printf ("Failed to wait for the thread, FAILED\n"); \
###        } \
###    }
###
###/* Macro to exit the thread. */
####define ADK_SAMPLE_ALARM_THREAD_EXIT() \
###    { \
###        pthread_exit (NULL); \
###    }
###
###
####endif /* __ADK_SAMPLE_ALARM_H__ */
###
###/*! end addtogroup _adkSamples
### * @}
### */
###
###
#endif
