#if 0
###/* **************************************************************************
###**                                                                          *
###** INTEL CONFIDENTIAL                                                       *
###** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
###**                                                                          *
###** The source code contained or described herein and all documents related  *
###** to the source code ("Material") are owned by Intel Corporation or its    *
###** suppliers or licensors. Title to the Material remains with Intel         *
###** Corporation or its suppliers and licensors. The Material contains trade  *
###** secrets and proprietary and confidential information of Intel or its     *
###** suppliers and licensors. The Material is protected by worldwide          *
###** copyright and trade secret laws and treaty provisions. No part of the    *
###** Material may be used, copied, reproduced, modified, published, uploaded, *
###** posted, transmitted, distributed, or disclosed in any way without        *
###** Intel's prior express written permission.                                *
###**                                                                          *
###** No license under any patent, copyright, trade secret or other            *
###** intellectual property right is granted to or conferred upon you by       *
###** disclosure or delivery of the Materials, either expressly, by            *
###** implication, inducement, estoppel or otherwise. Any license under such   *
###** intellectual property rights must be express and approved by Intel       *
###** in writing.                                                              *
###**                                                                          *
###** **************************************************************************
###**/
###/*!
### * @file  adk_sample_sim.c
### *
### *      $HeadURL:
### *      $Revision:
### *      $Date:
### * @addtogroup _adkSamples ADK Sample Applications
### * @{
### *
### * @brief APIs used by the sample applications
### *
### * This file contains the APIs which should only be used in the sample
### * application, these must not be used in the ADK core code.
### *
### ***********************************************************************/
###
####include "adk_include.h"
####include "adk_sample_sim.h"
###
###/*!
### * =============================================================
### * adk_sample_sim_start
### * @param[in] sysHandle The system handle.
### *
### * @retval 1 Failed
### * @retval 0 Passed
### *
### * @brief  Starts the simulation and traffic.
### *
### * This function starts the simulation and traffic.
### *
### * =============================================================
### */
###int adk_sample_sim_start(adk_sys_handle_t sysHandle)
###{
###    ncp_st_t st;
###    ncp_dev_hdl_t devHdl;
###    ncp_hdl_t ncpHandle;
###
###    st = adk_sys_hw_handle_get(sysHandle, &ncpHandle);
###    if (st != NCP_ST_SUCCESS)
###    {
###        printf("Failed to get the hardware handle, Error: %s",
###               ncp_status_get(st));
###        return 1;
###    }
###
###    /* get device handle for this ncpHdl */
###    st = ncp_config_dev_hdl_get(ncpHandle, &devHdl);
###    if (st == NCP_ST_SUCCESS)
###    {
###        /* start the simulator */
###        st = ncp_dev_write32(devHdl, NCP_REGION_SIMULATOR_IF, 0x4, 1);
###        if (st != NCP_ST_SUCCESS)
###        {
###            printf("Failed to write to register to start simulation, Error: %s",
###                   ncp_status_get(st));
###            return 1;
###        }
###    }
###    else
###    {
###        printf("Failed to get the device handle, Error: %s",
###               ncp_status_get(st));
###        return 1;
###    }
###    
###    return 0;
###}
###
###/*!
### * =============================================================
### * adk_sample_sim_shutdown
### * @param[in] sysHandle The system handle.
### *
### * @retval 1 Failed
### * @retval 0 Passed
### *
### * @brief  Stops the simulation and traffic.
### *
### * This function stops the simulation/traffic and detaches from
### * the simulator.
### *
### * =============================================================
### */
###int adk_sample_sim_shutdown(adk_sys_handle_t sysHandle)
###{
###    ncp_st_t st;
###    ncp_hdl_t ncpHandle;
###
###    st = adk_sys_hw_handle_get(sysHandle, &ncpHandle);
###    if (st != NCP_ST_SUCCESS)
###    {
###        printf("Failed to get the hardware handle, Error: %s",
###               ncp_status_get(st));
###        return 1;
###    }
###
###    st = ncp_config_detach(ncpHandle);
###    if (st != NCP_ST_SUCCESS)
###    {
###        printf("Failed to detach from simulation, Error: %s",
###               ncp_status_get(st));
###        return(1);
###    }
###    
###    return (0);
###}
###
###/*! end addtogroup _adkSamples
### * @}
### */
#endif
