/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __ADK_IP_CP_EXPORT_H__
#define __ADK_IP_CP_EXPORT_H__

/*!
 * =============================================================
 * @enum adk_ip_table_group_t
 *
 * @brief
 *
 * This enumeration defines different group of tables that can be
 * dumped in user readable csv format.
 *
 * =============================================================
 */
typedef enum adk_ip_table_group_s {
    /*! Non inclusive lower bound on table group type */
    ADK_IP_TABLES_NONE = 0,
    /*! Interface related tables */
    ADK_IP_TABLES_INTF_ATTR = (1 << 0),
    /*! Routing related table */
    ADK_IP_TABLES_ROUTING = (1 << 1),
    /*! IP routing domain related tables */
    ADK_IP_TABLES_VRD = (1 << 6),
    /*! IP flow binding related tables */
    ADK_IP_TABLES_BIND = (1 << 7),
    /*! IP QoS related tables */
    ADK_IP_TABLES_QOS = (1 << 8),
    /*! IP exceptions related tables */
    ADK_IP_TABLES_EXCEPTIONS = (1 << 9),
    /*! IP Reassembly related tables */
    ADK_IP_TABLES_REASM = (1 << 11),
    /*! IP DP flow cache related tables */
    ADK_IP_TABLES_FLOWCACHE = (1 << 12),
    /* Inclusive upper bound on table group type for all tables */
    ADK_IP_TABLES_ALL = ((1 << 13) - 1)
} adk_ip_table_group_t;

adk_status_t adk_ip_tables_dump(
    adk_module_handle_t ipHandle,
    adk_ip_table_group_t table_group);

#endif /* __ADK_IP_CP_EXPORT_H__ */
