/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#include "adk_include.h"
#include <adk_ipv6_acl.h>
#include <adk_ipv6.h>
#include <adk_ipv6_dp_pvt.h>
#include "adk_ipv6_internal.h"
#include "adk_dpdk.h"

adk_status_t adk_ipv6_acl_lookup(adk_ipv6_dp_acl_tree_t *acl_tree,
		      adk_ipv6_dp_acl_ptn_t  *acl_ptn,
		      adk_ipv6_acl_val_t  *acl_val)
{
    int ret;
    const uint8_t * data[] = {(uint8_t *)acl_ptn};

    ret = rte_acl_classify_alg((struct rte_acl_ctx *)acl_tree, data, acl_val, 1, 1, RTE_ACL_CLASSIFY_SSE);
    if (ret != 0)
    {
        ADK_IPV6_DP_LOG_INFO_1D(
                "\nError in ACL classify for ipv6 7tuples. Returns %d\n", ret);
        return ADK_E_INTERNAL_ERROR;
    }
    return ADK_SUCCESS; 
}

