/* ***************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef _ADK_IPV6_DP_EXCEPTION_H_
#define _ADK_IPV6_DP_EXCEPTION_H_
adk_dp_status_t 
adk_dp_send_ipv6_exception(adk_pktio_task_t *task, uint8_t vrd_id, uint8_t port, uint16_t if_id,
                    uint16_t ipv6_offset, uint16_t  flow_id, uint16_t parse_err_offset,
                    uint8_t domain, uint8_t exception_type, int coreIndex, uint16_t mtu);

adk_dp_status_t
adk_ipv6_dp_handle_sip_excep(adk_ipv6_dp_ingress_flow_sip_entry_t *ingress_flow_sip_entry,
        adk_pktio_task_t *task, uint8_t vrd_id, adk_ipv6_dp_if_stats_entry_t *if_in_stat);

adk_dp_status_t
adk_ipv6_dp_handle_in_acl_excep(adk_ipv6_dp_acl_action_entry_t acl_action_tbl, 
        adk_pktio_task_t *task, uint8_t vrd_id, adk_ipv6_dp_if_stats_entry_t *if_stats);

adk_dp_status_t
adk_ipv6_dp_handle_out_acl_excep(adk_ipv6_dp_acl_action_entry_t acl_action_tbl,
        adk_pktio_task_t *task, uint8_t vrd_id, uint8_t  port, uint16_t  if_id, 
        uint16_t ipv6_offset, uint8_t  domain, adk_ipv6_dp_if_stats_entry_t *if_stats);

adk_dp_status_t
adk_ipv6_dp_send_clone_exception(struct rte_mbuf *task, uint8_t vrd_id,
        uint8_t domain, uint8_t exception_type, int core_index, uint16_t mtu);

#endif //_ADK_IPV6_DP_EXCEPTION_H_
