/* ***************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/

#ifndef _ADK_IPV6_DP_FLOW_CACHE_LLI_H_
#define _ADK_IPV6_DP_FLOW_CACHE_LLI_H_


#ifdef ADK_IPV6_FLOW_CACHE
adk_dp_status_t 
adk_ipv6_dp_lli_flow_cache_entry_alloc(
        adk_ipv6_dp_flow_cache_hash_entry_t **lli_flow_cache_hash_entry,
        adk_ipv6_dp_lli_flow_cache_entry_t **flow_cache_entry,
        uint32_t hash_value);

adk_status_t 
adk_ipv6_dp_lli_flow_cache_entry_release(adk_ipv6_dp_lli_flow_cache_entry_t *lli_fc_entry);

adk_dp_status_t 
adk_ipv6_dp_lli_flow_cache_3tuple_proc(adk_ipv6_dp_interface_entry_t *ipv6_if_entry, 
        adk_ipv6_hdr_t *ipv6_hdr, uint8_t hlimit, uint8_t next_hdr, adk_ipv6_frag_t frag_flag, uint8_t excep,
        uint16_t l4_offset, uint16_t offset_to_frag, uint32_t frag_id, uint16_t src_port,
        uint16_t dst_port, adk_pktio_task_t *task,
        uint8_t coreIndex, void **ringHdl, uint8_t *dst_mod_id, adk_pal_dp_stage_info_t *stageInfo, uint32_t *hash_value);

adk_dp_status_t 
adk_ipv6_dp_lli_flow_cache_5tuple_proc(adk_ipv6_dp_interface_entry_t *ipv6_if_entry,
                    adk_ipv6_hdr_t *ipv6_hdr, uint8_t hlimit, uint8_t next_hdr, 
                    adk_ipv6_frag_t frag_flag, uint16_t src_port,
                    uint16_t dst_port, uint8_t excep, uint16_t l4_offset, 
                    uint16_t offset_to_frag, uint32_t frag_id, adk_pktio_task_t *task, 
                    uint8_t coreIndex, void **ringHdl, uint8_t *dst_mod_id, 
                    adk_pal_dp_stage_info_t *stageInfo, uint32_t *hash_value);
#endif

#endif //_ADK_IPV6_DP_FLOW_CACHE_LLI_H_
