/* ***************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef _ADK_IPV6_DP_FRAG_H_
#define _ADK_IPV6_DP_FRAG_H_


/*!
 * =============================================================
 * @enum adk_ipv6_dp_frag_error_e
 *
 * @brief
 *
 * This enum defines ipv4 fragmentation error types.
 *
 * =============================================================
 */
typedef enum adk_ipv6_dp_frag_error_e
{
    ADK_IPV6_DP_FRAG_OK = 0,
    ADK_IPV6_DP_FRAG_DFSET,
    ADK_IPV6_DP_FRAG_LIMIT_EXCEED,
    ADK_IPV6_DP_FRAG_MEM_ALLOC_FAILED,
    ADK_IPV6_DP_FRAG_NON_FIRST_HOPBYHOP,
    ADK_IPV6_DP_FRAG_NOT_REQ
} adk_ipv6_dp_frag_error_t;

adk_ipv6_dp_frag_error_t 
adk_ipv6_dp_fragment(adk_pktio_task_t **task_out_p, int coreIndex, uint32_t mtu, 
        uint8_t *num_frags, uint32_t *fragOctets, adk_ipv6_interface_type_t if_type);

#endif //_ADK_IPV6_DP_FRAG_H_

