/* ***************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/

#ifndef _ADK_IPV6_DP_LLI_H_
#define _ADK_IPV6_DP_LLI_H_

#include "adk_ipv6_dp_export.h"
#include <adk_ethernet_export.h>
#ifdef ADK_MODULE_BFD_ENABLED
#include <adk_bfd_dp_export.h>
#endif
#ifdef ADK_MODULE_TWAMP_ENABLED
#include <adk_twamp_dp_export.h>
#endif
#ifdef ADK_MODULE_IPSEC_ENABLED
#include <adk_ipsec_export.h>
#endif



adk_status_t 
adk_ipv6_dp_terminate(adk_pktio_task_t *task, uint8_t rulemask, 
        adk_ipv6_dp_interface_entry_t *ipv6_if_entry,  adk_ipv6_dp_if_stats_entry_t *if_stats,
        adk_ipv6_hdr_t *ipv6_hdr, adk_ipv6_frag_t frag_flag, uint8_t next_hdr, uint16_t l4_offset, 
        uint16_t src_port, uint16_t dst_port);

adk_status_t 
adk_ipv6_dp_pkt_proc_police(void  **task_p,
                            uint8_t __attribute__((unused)) task_count,
                            uint32_t __attribute__((unused)) task_mask,
                            void __attribute__((unused)) *ring,
                            adk_sif_cfg_pipeline_info_t __attribute__((unused)) *next_stage_entry, 
                            __attribute__((unused)) int coreIndex);

adk_status_t
adk_ipv6_dp_validate_multicast_mac( uint32_t *dst_ip, void *pduData);

void adk_ipv6_compute_multicast_dest_mac(uint32_t dst_address, uint8_t *calc_dmac);
uint32_t adk_ipv6_compare_multicast_mac(uint8_t *calc_dmac, uint8_t *dst_mac);

#endif //_ADK_IPV6_DP_LLI_H_
