/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @file  adk_meta_defs.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @brief  Metadata definitons
 *
 * This file has the meta data related definitions. This file is included
 * by the data plane so this file should not contain anything that cannot
 * be compiled in the fast path.
 *
 *  **********************************************************************/

#ifndef __ADK_META_DEFS_H__
#define __ADK_META_DEFS_H__


/* Meta header specific constants */
#define ADK_META_HEADER_SIZE_BYTES          0
#define ADK_META_HEADER_SIZE_BITS           0

#define META_TIMESTAMP_PRESENT  0x01
#define META_PTP_INFO_PRESENT   0x02
#define META_TSINDEXT_PRESENT   0x04
#define META_SEDSCRIPT_PRESENT  0x08

#define ADK_META_HEADER_TIMESTAMP_OFFSET    0
#define ADK_META_TIMESTAMP_LEN_BYTES     8
#define ADK_META_TIMESTAMP_LEN_BITS      64

/* PTP PROTOCOL SPECIFIC METADATA */
#define ADK_META_PTP_HDR_OFFSET           8
#define ADK_META_PTP_HDR_LEN_BYTES        1
#define ADK_META_PTP_HDR_LEN_BITS         8

#define ADK_META_PTP_TSUPDT_OFFSET        9
#define ADK_META_PTP_TSUPDT_LEN_BYTES     1
#define ADK_META_PTP_TSUPDT_LEN_BITS      8

#define ADK_META_PTP_TS_LOW_OFFSET        10
#define ADK_META_PTP_TS_LOW_LEN_BYTES     4
#define ADK_META_PTP_TS_LOW_LEN_BITS      32 

#define ADK_META_PTP_FLAGS_OFFSET        14
#define ADK_META_PTP_FLAGS_LEN_BYTES     1
#define ADK_META_PTP_FLAGS_LEN_BITS      8


/* Other PTP related metadata used by Ethernet */
#define ADK_META_EIOA_TSINDEX_OFFSET     15
#define ADK_META_EIOA_TSINDEX_LEN_BYTES  1
#define ADK_META_EIOA_TSINDEX_LEN_BITS   8

#define ADK_META_SED_SCRIPT_ID_OFFSET    16
#define ADK_META_SED_SCRIPT_ID_LEN_BYTES 1
#define ADK_META_SED_SCRIPT_ID_LEN_BITS  8

#endif /* __ADK_META_DEFS_H__ */
