/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __NCP_EIOA_H__
#define __NCP_EIOA_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "ncp.h"

typedef enum {
/* NCP_GMAC to DPDK port mapping */
/* TODO: Customer specific mapping that must match pipeline definitions in the config file. */
/* Current mapping assumes XGMAC16 as DPDK port 0 for TN usage and XGMAC32 as DPDK port 1 for Baseband IC usage.
 * When ODP is used then the ports are instead 2 and 3 respectively.
 */ 
    NCP_XGMAC0 = 10,
    NCP_GMAC0 = 10,
    NCP_XGMAC1 = 11,
    NCP_GMAC1 = 11,
    NCP_GMAC2 = 2,
    NCP_GMAC3 = 3,
    NCP_GMAC4 = 4,
    NCP_XGMAC8 = 5,
    NCP_XGMAC9 = 6,
    NCP_GMAC9 = 6,
    NCP_GMAC10 = 7,
    NCP_GMAC11 = 8,
    NCP_GMAC12 = 9,
    NCP_XGMAC16 = 0,
    NCP_GMAC16= 0,
    NCP_XGMAC17= 17,
    NCP_GMAC17= 17,
    NCP_GMAC18= 18,
    NCP_GMAC19= 19,
    NCP_GMAC20= 20,
    NCP_XGMAC32 = 1,
    NCP_GMAC32 = 1,
    NCP_XGMAC33 = 33,
    NCP_GMAC33 = 33,
    NCP_XGMAC48 = 48,
    NCP_GMAC48 = 48,
    NCP_XGMAC49 = 49,
    NCP_GMAC49 = 49,
    NCP_XGMAC64 = 64,
    NCP_GMAC64 = 64,
    NCP_XGMAC65 = 65,
    NCP_GMAC65 = 65,
    NCP_XGMAC80 = 80,
    NCP_GMAC80 = 80,
    NCP_XGMAC81 = 81,
    NCP_GMAC81 = 81,
    NCP_XGMAC96 = 96,
    NCP_GMAC96 = 96,
    NCP_XGMAC97 = 97,
    NCP_GMAC97 = 97,
    NCP_XGMAC112 = 112,
    NCP_GMAC112 = 112,
    NCP_XGMAC113 = 113,
    NCP_GMAC113 = 113,
} ncp_macChan_t; 

typedef enum {
    NCP_MAC_PHY_SPEED10 = 1,
    NCP_MAC_PHY_SPEED100,
    NCP_MAC_PHY_SPEED1000,
    NCP_MAC_PHY_SPEED2_5G,
    NCP_MAC_PHY_SPEED10G
} ncp_mac_speed_t;

ncp_st_t
ncp_eioa_port_enable_set(
             ncp_hdl_t      hdl,
             ncp_macChan_t  macChan,
             bool     rx_enable,
             bool     tx_enable);


#ifdef __cplusplus
}
#endif

#endif /* __NCP_EIOA_H__ */
