/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __NCP_TYPES_H__
#define __NCP_TYPES_H__

#include <stdio.h>
#include <sys/types.h>
#include <pthread.h>

#include <rte_config.h>
#include <rte_malloc.h>

typedef void * ncp_hdl_t;
typedef void * ncp_vp_hdl_t;

#if 0
typedef struct
{
    char *buf;
    uint32_t len;
} ncp_byte_string_t;
#endif

typedef struct {
    long        tv_sec;
    long        tv_nsec;
} ncp_timespec_t;

#define NCP_RETURN_LABEL \
goto ncp_return; \
ncp_return:

#define NCP_CALL(ncpFunc)                \
    do {                                 \
        ncpStatus = (ncpFunc);           \
        if (ncpStatus != NCP_ST_SUCCESS) \
        {                                \
            printf("%s(%d)-%s: %s\n",__FILE__,__LINE__,__func__, ncp_status_get(ncpStatus)); \
            fflush(stdout); \
            goto ncp_return;             \
        }                                \
    } while(0)

#define NCP_MSG_ERROR               (0x00000002)
#define NCP_MSG(type, ...) \
    do { \
            printf(__VA_ARGS__); \
    } while (0)

#define NCP_PRINT_LINE_FILE NCP_MSG(NCP_MSG_INFO, "%s : %s, line = %d\n", ncp_status_get(ncpStatus), __FILE__,__LINE__)
#define NCP_PRINT_LINE_FILE_MSG(...)                                       \
    {                                                                           \
        NCP_MSG(NCP_MSG_INFO, __VA_ARGS__);                                    \
        NCP_MSG(NCP_MSG_INFO, " (%s : %s, line = %d)\n", ncp_status_get(ncpStatus), \
            __FILE__,__LINE__);                                                 \
    }

#endif /* _NCP_TYPES_H_ */

