/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#include <string.h>

#include "ncp_internal.h"

/***************************************************************************
* Some misc. exported APIs not worth separate files                        *
***************************************************************************/

/* From ncp_task_axm55xx.c */
ncp_st_t
ncp_task_v2_get_taskHdl(ncp_task_hdl_t *pTaskHdl)
{
    *pTaskHdl = (ncp_task_hdl_t)0x100;
    return NCP_ST_SUCCESS;
}

/* From ncp_nvm.c */
ncp_st_t
ncp_vp_engine_seq_id_get(
            ncp_vp_hdl_t    __attribute__((unused)) vpHdl,
            const char      __attribute__((unused)) *engineSeqName,
            uint8_t                             *engineSeqId)
{
    *engineSeqId = 0;
    return NCP_ST_SUCCESS;
}

/* From ncp_utils.c */
ncp_st_t
ncp_validate_handle(
    ncp_t *ncp)
{
    if (ncp == NULL)
    {
        return NCP_ST_INVALID_HANDLE;
    }
    if (ncp->cookie != NCP_HANDLE_COOKIE)
    {
        return NCP_ST_INVALID_HANDLE;
    }
    return NCP_ST_SUCCESS;
}

