/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __NCP_API_TRACE_H__
#define __NCP_API_TRACE_H__

#if defined ( NCP_API_TRACE )

#define NCP_API_TRACE_SIZE 1024

typedef struct {
    uint32_t    ts;
    uint16_t    pid;
    uint16_t    tag;
    uint32_t    val[2];
} ncp_api_trace_entry_t;

typedef struct {
    ncp_sem_t       lock;
    uint32_t    idx;
    uint32_t    active;
    ncp_api_trace_entry_t *traceBuf;
} ncp_api_trace_info_t;

NCP_API ncp_st_t 
ncp_api_trace_init(void);

NCP_API ncp_st_t
ncp_api_trace_event(
        uint32_t tag, 
        uint32_t val0, 
        uint32_t val1 );
#else

#define ncp_api_trace_init()
#define ncp_api_trace_event(a, b, c)

#endif   /* defined NCP_API_TRACE */


#endif
