/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __NCP_BITMAP_H__
#define __NCP_BITMAP_H__

#include "ncp.h"

#ifdef __cplusplus
extern "C" { 
#endif

typedef void *ncp_bitmap_t;

ncp_bitmap_t *
ncp_bitmap_create(
    uint32_t size);

int32_t
ncp_bitmap_delete(
    ncp_bitmap_t *map);

int32_t
ncp_bitmap_reserve(
    ncp_bitmap_t *map,
    uint32_t  size,
    uint32_t *base);

int32_t ncp_bitmap_unreserve(
    ncp_bitmap_t *map,
    uint32_t size,
    uint32_t base_id);

bool ncp_bitmap_isset(
    ncp_bitmap_t *map,
    uint32_t id);

#ifdef __cplusplus
}
#endif /* #ifdef __cplusplus */

#endif /* __NCP_BITMAP_H__ */

