/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __NCP_PVT_H__
#define __NCP_PVT_H__

#include "ncp_internal.h"

#ifdef __cplusplus
extern "C" { 
#endif

#define NCP_HANDLE_COOKIE 0x244e4350

typedef struct ncp_s
{
    uint32_t        cookie;
    uint32_t        id;
    ncp_sem_t           lock;
    ncp_hdl_t           rsrc;
} ncp_t;


int ncp_usleep(
    unsigned long usecs);

ncp_st_t ncp_validate_handle(
    ncp_t *ncp);


#ifdef __cplusplus
}
#endif

#endif /* __NCP_PVT_H__ */
