/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
#ifndef __ADK_SIF_CFG_H__
#define __ADK_SIF_CFG_H__

typedef struct adk_sif_cfg_info_s{
    /* Configuration table handles */
    void        *cfg_params_tbl;        /* Handle to configuration parameters table */

    /* Internal tables */
    void        *eal_info_tbl;          /* Handle to eal config info table */
    void        *mempool_info_tbl;      /* Handle to mempool config info table */
    void        *port_info_tbl;         /* Handle to port config info table */
    void        *ring_info_tbl;         /* Handle to ring config info table */
    void        *pipeline_info_tbl;     /* Handle to pipeline config info table */
    void        *pkt_buffs_info_tbl;    /* Handle to packet buffers info table */

    /* Occupancy of internal tables */
    uint32_t    num_cores;
}adk_sif_cfg_info_t;

/* Function prototypes */
adk_status_t
adk_sif_cfg_init(adk_sif_cfg_info_t **cfg_info);

adk_status_t
adk_sif_cfg_shutdown(adk_sif_cfg_info_t *cfg_info);

adk_status_t
adk_sif_cfg_load(int argc, char **argv, adk_sif_cfg_info_t *cfg_info_hdl);

adk_status_t
adk_sif_cfg_configure(adk_sif_cfg_info_t *cfg_info_hdl);

adk_status_t
adk_sif_cfg_parse(int argc, char **argv, adk_sif_cfg_info_t *cfg_info);
#endif
