/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
#ifndef __ADK_SIF_CFG_COMMON_H__
#define __ADK_SIF_CFG_COMMON_H__

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <getopt.h>
#include <rte_cfgfile.h>

#define ADK_SIF_CFG_MAX_WORKER_LCORES       16
#define ADK_SIF_CFG_MAX_EAL                 1
#define ADK_SIF_CFG_MAX_MEMPOOLS            20
#define ADK_SIF_CFG_MAX_PORT                12
#define ADK_SIF_CFG_MAX_QUEUES_PER_PORT     16
#define ADK_SIF_CFG_MAX_RING_QUEUES         50
/* Max Number Of Buffers Supported. */
#define ADK_SIF_CFG_MAX_PKT_BUFFS           16
/* Number Of Packets In Each Buffer. The number of packets
 * generated for replay can vary from 1 - 100000 */
#define RTE_MAX_MBUFS_IN_BUFFER             100000
#define ADK_SIF_CFG_MAX_PIPELINES           25
#define ADK_SIF_CFG_MAX_SECTIONS            (ADK_SIF_CFG_MAX_EAL + ADK_SIF_CFG_MAX_MEMPOOLS +\
                                             ADK_SIF_CFG_MAX_PORT + ADK_SIF_CFG_MAX_RING_QUEUES +\
                                             ADK_SIF_CFG_MAX_PIPELINES)
                                         
#define ADK_SIF_CFG_MAX_NAME_LEN            128
#define ADK_SIF_CFG_MAX_SYS_PORTS           (ADK_SIF_CFG_MAX_PORT * ADK_SIF_CFG_MAX_WORKER_LCORES);
#define ADK_SIF_CFG_MAX_PIPELINE_STAGES     ADK_MAX_NUM_CORES

#define ADK_SIF_CFG_ARRAY_SIZE(arr)         (sizeof (arr) / sizeof ((arr)[0]))

typedef enum adk_sif_cfg_flags_e{
    _INIT = 0,
    _CONFIG,
    _VALID,
} adk_sif_cfg_flags_t;

typedef enum adk_sif_cfg_dest_func_e{
    _DEST_FUNC_DEFAULT = 0,
    _DEST_FUNC_RING,
    _DEST_FUNC_MAX
} adk_sif_cfg_dest_func_t;

typedef struct adk_sif_cfg_portq_s{
    uint8_t port_id;
    uint16_t queue_id;
    uint16_t weight;
    uint16_t entry_func;
    void *entry_mod_hdl;
} adk_sif_cfg_portq_t;

typedef struct adk_sif_cfg_ringq_s{
    struct rte_ring *ring_hdl;
    uint16_t entry_func;
} adk_sif_cfg_ringq_t;

typedef struct adk_sif_cfg_pkt_buffs_s{
    uint8_t buff_id;
    uint16_t entry_func;
    uint16_t transmit;
    uint16_t weight;
} adk_sif_cfg_pkt_buffs_t;

#endif
