/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
#ifndef __ADK_SIF_CFG_PKT_BUFFS_H__
#define __ADK_SIF_CFG_PKT_BUFFS_H__

/* Data structures */
typedef enum adk_sif_cfg_pkt_buffs_type_e{
    ADK_SIF_CFG_PKT_BUFFS_TYPE_MIN = 0,
    ADK_SIF_CFG_PKT_BUFFS_TYPE_LOOP,
    ADK_SIF_CFG_PKT_BUFFS_TYPE_FINISH,
    ADK_SIF_CFG_PKT_BUFFS_TYPE_MAX
} adk_sif_cfg_pkt_buffs_type_t;

/* Data structures */
typedef struct adk_sif_cfg_pkt_buffs_info_t {
    uint8_t     valid;
    uint8_t     pkt_buffs_id;
    uint16_t    pkt_buffs_mempool;
    uint16_t    pkt_buffs_transmit;
    uint16_t    pkt_buffs_weight;
} adk_sif_cfg_pkt_buffs_info_t;

typedef struct adk_sif_cfg_pkt_buffs_params_tbl_s {
    adk_sif_cfg_pkt_buffs_info_t pkt_buffs_info[ADK_SIF_CFG_MAX_PKT_BUFFS];
    uint32_t               size;
    uint32_t               cur;
} adk_sif_cfg_pkt_buffs_info_tbl_t;

/* Function prototypes */
adk_status_t
adk_sif_cfg_pkt_buffs_init(
        adk_sif_cfg_info_t *cfg_info);

adk_status_t
adk_sif_cfg_pkt_buffs_configure(
        adk_sif_cfg_info_t *cfg_info_hdl);

adk_status_t
adk_sif_cfg_pkt_buffs_create(
        adk_sif_cfg_info_t *cfg_info_hdl,
        adk_cfg_pkt_buffs_params_t *params,
        adk_sif_cfg_pkt_buffs_info_t **pkt_buffs_info);

adk_status_t
adk_sif_cfg_pkt_buffs_info_alloc(
        adk_sif_cfg_pkt_buffs_info_tbl_t *pkt_buffs_info_hdl,
        adk_sif_cfg_pkt_buffs_info_t **info);

adk_status_t
adk_sif_cfg_pkt_buffs_info_free(
        adk_sif_cfg_pkt_buffs_info_tbl_t *pkt_buffs_info_hdl,
        adk_sif_cfg_pkt_buffs_info_t *info);

adk_status_t
adk_sif_cfg_pkt_buffs_info_rewind(
        adk_sif_cfg_pkt_buffs_info_tbl_t *pkt_buffs_info_hdl);

adk_status_t
adk_sif_cfg_pkt_buffs_info_set(
        adk_sif_cfg_pkt_buffs_info_tbl_t __attribute__ ((unused))*pkt_buffs_info_hdl,
        adk_cfg_pkt_buffs_params_t *params,
        adk_sif_cfg_pkt_buffs_info_t **info);

adk_status_t
adk_sif_cfg_pkt_buffs_info_get_next(
        adk_sif_cfg_pkt_buffs_info_tbl_t *pkt_buffs_info_hdl,
        adk_sif_cfg_pkt_buffs_info_t **info);

adk_status_t
adk_sif_cfg_pkt_buffs_info_get(
        adk_sif_cfg_pkt_buffs_info_tbl_t *pkt_buffs_info_hdl,
        uint8_t pkt_buffs_id,
        adk_sif_cfg_pkt_buffs_info_t **buff_info);
#endif
