/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
#ifndef __ADK_SIF_CFG_PORT_H__
#define __ADK_SIF_CFG_PORT_H__

typedef struct adk_sif_cfg_port_info_s{
    uint8_t     valid;
    uint8_t     portid;
    uint16_t    speed;
    uint32_t    duplex;
    uint8_t     promisc;
    uint16_t    rx_queues[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    uint16_t    rx_queue_mempool[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    uint16_t    rx_queue_size[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    uint16_t    rx_queue_weight[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    uint16_t    rx_queue_burst[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    uint16_t    tx_queues[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    int32_t     tx_queue_socket[ADK_SIF_CFG_MAX_QUEUES_PER_PORT]; 
    uint16_t    tx_queue_size[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    uint16_t    tx_queue_burst[ADK_SIF_CFG_MAX_QUEUES_PER_PORT];
    uint16_t    num_rx_queues;
    uint16_t    num_tx_queues;
}adk_sif_cfg_port_info_t;

typedef struct adk_sif_cfg_port_info_tbl_s{
    adk_sif_cfg_port_info_t  port_info[ADK_SIF_CFG_MAX_PORT];
    uint32_t                 size;
    uint32_t                 cur;
}adk_sif_cfg_port_info_tbl_t;

/* Function prototypes */
adk_status_t
adk_sif_cfg_port_init(adk_sif_cfg_info_t *cfg_info);

adk_status_t
adk_sif_cfg_port_configure(adk_sif_cfg_info_t *cfg_info_hdl);

adk_status_t
adk_sif_cfg_port_create(adk_sif_cfg_info_t *cfg_info_hdl,
                           adk_cfg_port_params_t *params,
                           adk_sif_cfg_port_info_t **port_info);
adk_status_t
adk_sif_cfg_port_info_alloc(adk_sif_cfg_port_info_tbl_t *port_info_hdl,
                               adk_sif_cfg_port_info_t **info);
adk_status_t
adk_sif_cfg_port_info_free(adk_sif_cfg_port_info_tbl_t *port_info_hdl,
                              adk_sif_cfg_port_info_t *info);
adk_status_t
adk_sif_cfg_port_info_rewind(adk_sif_cfg_port_info_tbl_t *port_info_hdl);

adk_status_t
adk_sif_cfg_port_info_set(adk_sif_cfg_port_info_tbl_t *port_info_hdl __attribute__ ((unused)),
                          adk_cfg_port_params_t *params,
                          adk_sif_cfg_port_info_t **info);
adk_status_t
adk_sif_cfg_port_info_get_next(adk_sif_cfg_port_info_tbl_t *port_info_hdl,
                             adk_sif_cfg_port_info_t **info);
adk_status_t
adk_sif_cfg_port_check(adk_sif_cfg_port_info_tbl_t *port_info_hdl,
                       uint8_t port_id);
adk_status_t
adk_sif_cfg_port_rx_queue_check(adk_sif_cfg_port_info_tbl_t *port_info_hdl,
                                uint8_t port_id, uint16_t queue_id);
adk_status_t
adk_sif_cfg_port_tx_queue_check(adk_sif_cfg_port_info_tbl_t *port_info_hdl,
                                uint8_t port_id, uint16_t queue_id);
#endif
