/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
#ifndef __ADK_SIF_CFG_RING_H__
#define __ADK_SIF_CFG_RING_H__

typedef struct adk_sif_cfg_ring_info_s{
    uint8_t     valid;
    uint32_t    ring_id;
    void        *ring;
    uint32_t    ring_size;
    uint32_t    ring_enqueue_burst;
    uint32_t    ring_dequeue_burst;
    int32_t     socket;
}adk_sif_cfg_ring_info_t;

typedef struct adk_sif_cfg_ring_info_tbl_s{
    adk_sif_cfg_ring_info_t  ring_info[ADK_SIF_CFG_MAX_RING_QUEUES];
    uint32_t                 size;
    uint32_t                 cur;
}adk_sif_cfg_ring_info_tbl_t;

/* Function prototypes */
adk_status_t
adk_sif_cfg_ring_init(adk_sif_cfg_info_t *cfg_info);

adk_status_t
adk_sif_cfg_ring_configure(adk_sif_cfg_info_t *cfg_info_hdl);

adk_status_t
adk_sif_cfg_ring_create(adk_sif_cfg_info_t *cfg_info_hdl,
                           adk_cfg_ring_params_t *params,
                           adk_sif_cfg_ring_info_t **ring_info);

adk_status_t
adk_sif_cfg_ring_info_alloc(adk_sif_cfg_ring_info_tbl_t *ring_info_hdl,
                               adk_sif_cfg_ring_info_t **info);

adk_status_t
adk_sif_cfg_ring_info_free(adk_sif_cfg_ring_info_tbl_t *ring_info_hdl,
                              adk_sif_cfg_ring_info_t *info);
adk_status_t
adk_sif_cfg_ring_info_rewind(adk_sif_cfg_ring_info_tbl_t *ring_info_hdl);

adk_status_t
adk_sif_cfg_ring_info_set(adk_sif_cfg_ring_info_tbl_t *ring_info_hdl __attribute__ ((unused)),
                          adk_cfg_ring_params_t *params,
                          void *ring,
                          adk_sif_cfg_ring_info_t **info);
adk_status_t
adk_sif_cfg_ring_info_get_next(adk_sif_cfg_ring_info_tbl_t *ring_info_hdl,
                             adk_sif_cfg_ring_info_t **info);

adk_status_t
adk_sif_cfg_ring_info_get(adk_sif_cfg_ring_info_tbl_t *ring_info_hdl,
                       uint32_t ring_id,
                       void **ring);
#endif
