/* ***************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_hos_constants.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @addtogroup _hos  SIF HOS Component
 * @{
 *
 * This file contains constants defined by HOS and shared with other ADK
 * components.
 *
 *  **********************************************************************/

#ifndef __ADK_HOS_CONSTANTS_INCLUDE_H__
#define __ADK_HOS_CONSTANTS_INCLUDE_H__

/* System wide settings */
#define ADK_HLP_SWITCH_ID                   0
#define ADK_HOS_DOM_SCENARIO_MASK           0xF
#define ADK_HOS_TRIGGER_GROUP_ID            1000
#define ADK_HOS_DOM_PRI_MAP_PROFILE_ID      1
#define ADK_HOS_DEFAULT_PORT_MASK           0x1FFFFF
#define ADK_HOS_MAX_PREC_STATE_UPDATE       1024 /* HOS supports the max HLP possible */
#define ADK_HOS_MAX_MIRROR_IDS              32

#ifndef ADK_HOS_IES_SHM_KEY
#define ADK_HOS_IES_SHM_KEY 1234
#endif

#define ADK_HOS_CPK_PORT    20
#define ADK_HOS_CPM_ENCRYPT_PORT 21
#define ADK_HOS_CPM_DECRYPT_PORT 22
#define ADK_HOS_ANY_PORT    21
#define ADK_HOS_ANY_VLAN    0x1000

#define ADK_HOS_MAC_ADDR_AGE_OUT_TIME   (100)   /* msecs TODO: Change to 5 min */

#define ADK_HOS_DEFAULT_INGRESS_PRI     0

#define ADK_HOS_DEFAULT_ASSIGNED_VLAN_ID        1
#define ADK_HOS_DEFAULT_L2_DOMAIN               0x1FF
#define ADK_HOS_DEFAULT_L3_DOMAIN               0x3F
#define ADK_HOS_DEFAULT_L2_INTERFACE            0x1FF
#define ADK_HOS_DEFAULT_L2_INGRESS_FLOW         0x3FF
#define ADK_HOS_DEFAULT_IP_CLASSIFIER           0x3FF
#define ADK_HOS_DEFAULT_ACL_SET_ID              0xFF
#define ADK_HOS_DEFAULT_ACL_RULE_ID             0xFFF
#define ADK_HOS_DEFAULT_SPD_SET_ID              0xFF
#define ADK_HOS_DEFAULT_SPD_RULE_ID             0x3FF
#define ADK_HOS_DEFAULT_OUTER_IP_ID             0xFFFF
#define ADK_HOS_DEFAULT_INNER_IP_ID             0x1FF
#define ADK_HOS_DEFAULT_PROTO                   0xFF
#define ADK_HOS_DEFAULT_L4_PORT                 0xFFFF
#define ADK_HOS_DEFAULT_DSCP                    0x3F
#define ADK_HOS_DEFAULT_IP_STATS_ID             0x3F

#define ADK_HOS_OUTER_IP_ID_WIDTH   12
#define ADK_HOS_OUTER_IP_ID_MASK    0xfff

#define ADK_HOS_DEFAULT_TABLE_SIZE 512
#define ADK_HOS_MAX_TABLE_SIZE 1024

#endif /* __ADK_HOS_CONSTANTS_INCLUDE_H__ */

/*!
 * @} end addtogroup _hos
 */
