/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
/*!
 * file  adk_lttng_dp_tp.c
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * brief
 *
 * This file contains inclusions of all header files needed for Lttng 
 * implementation.
 *
 ***********************************************************************/

#include "adk_modules_enabled.h"
#include "adk_os.h"

/* Disable LTTng compilation due to many Coverity issues with sizeof */
#ifndef __COVERITY__

#define TRACEPOINT_CREATE_PROBES

#include "adk_dp_tp_sif.h"
#include "adk_dp_tp_sif_debug.h"
#include "adk_dp_tp_sif_qos.h"
#include "adk_dp_tp_sif_qos_debug.h"
#include "adk_dp_tp_sif_fps.h"
#include "adk_dp_tp_sif_fps_debug.h"
#include "adk_dp_tp_ph.h"
#include "adk_dp_tp_ph_debug.h"

#if defined(ADK_MODULE_ETHERNET_ENABLED)
#include "adk_dp_tp_ethernet.h"
#include "adk_dp_tp_ethernet_debug.h"
#endif

#if defined(ADK_MODULE_ETH_OAM_ENABLED)
#include "adk_dp_tp_eth_oam.h"
#include "adk_dp_tp_eth_oam_debug.h"
#endif

#if defined(ADK_MODULE_GTPU_ENABLED)
#include "adk_dp_tp_gtpu.h"
#include "adk_dp_tp_gtpu_debug.h"
#endif

#if defined(ADK_MODULE_IP_ENABLED)
#include "adk_dp_tp_ip.h"
#include "adk_dp_tp_ip_debug.h"
#endif

#if defined(ADK_MODULE_IPV6_ENABLED)
#include "adk_dp_tp_ipv6.h"
#include "adk_dp_tp_ipv6_debug.h"
#endif

#if defined(ADK_MODULE_IPSEC_ENABLED)
#include "adk_dp_tp_ipsec.h"
#include "adk_dp_tp_ipsec_debug.h"
#endif

#if defined(ADK_MODULE_BFD_ENABLED)
#include "adk_dp_tp_bfd.h"
#include "adk_dp_tp_bfd_debug.h"
#endif


#if defined( ADK_MODULE_L2TPV3_ENABLED)
#include "adk_dp_tp_l2tpv3.h"
#include "adk_dp_tp_l2tpv3_debug.h"
#endif

#if defined( ADK_MODULE_EHSFP_IWF_ENABLED)
#include "adk_dp_tp_ehsfp_iwf.h"
#include "adk_dp_tp_ehsfp_iwf_debug.h"
#endif

#if defined(ADK_MODULE_TWAMP_ENABLED)
#include "adk_dp_tp_twamp.h"
#include "adk_dp_tp_twamp_debug.h"
#endif

#endif /* ifndef __COVERITY__ */
