/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
/*!
 * @internal
 * file  adk_dp_tp_macros.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * brief
 *
 * Base set of macros for building the standard DP LTTng files
 *
 ***********************************************************************/


#ifndef  _ADK_DP_TP_MACROS_H_
#define  _ADK_DP_TP_MACROS_H_

#include "adk_dp_tp_class_macros.h"

#define ADK_DP_TP_INFO_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_info, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_info, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1D_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1d, \
                              intel_adk_dp_info_1d, \
                              ADK_DP_TP_CLASS_1S_1D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_info_1d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1P_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1p, \
                              intel_adk_dp_info_1p, \
                              ADK_DP_TP_CLASS_1S_1P_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_info_1p, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1X_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1x, \
                              intel_adk_dp_info_1x, \
                              ADK_DP_TP_CLASS_1S_1X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_info_1x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_2D_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_2d, \
                              intel_adk_dp_info_2d, \
                              ADK_DP_TP_CLASS_1S_2D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_info_2d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_ERRNO_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1s_1x, \
                              intel_adk_dp_info_errno, \
                              ADK_DP_TP_CLASS_1S_1S_1X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_info_errno, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1S_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1s, \
                              intel_adk_dp_info_1s, \
                              ADK_DP_TP_CLASS_1S_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_info_1s, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_FORCE_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_force_info, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_force_info, \
                    TRACE_DEBUG)

#define ADK_DP_TP_ERROR_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_error, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_error, \
                    TRACE_ERR)

#define ADK_DP_TP_ERROR_1D_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1d, \
                              intel_adk_dp_error_1d, \
                              ADK_DP_TP_CLASS_1S_1D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_error_1d, \
                    TRACE_ERR)

#define ADK_DP_TP_ERROR_2D_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_2d, \
                              intel_adk_dp_error_2d, \
                              ADK_DP_TP_CLASS_1S_2D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_error_2d, \
                    TRACE_ERR)

#define ADK_DP_TP_ERROR_1P_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1p, \
                              intel_adk_dp_error_1p, \
                              ADK_DP_TP_CLASS_1S_1P_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_error_1p, \
                    TRACE_ERR)

#define ADK_DP_TP_ERROR_ERRNO_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1s_1x, \
                              intel_adk_dp_error_errno, \
                              ADK_DP_TP_CLASS_1S_1S_1X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_error_errno, \
                    TRACE_ERR)

#define ADK_DP_TP_ERROR_1S_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s_1s, \
                              intel_adk_dp_error_1s, \
                              ADK_DP_TP_CLASS_1S_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_error_1s, \
                    TRACE_ERR)

#define ADK_DP_TP_ERROR_FORCE_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_force_error, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_force_error, \
                    TRACE_CRIT)

#define ADK_DP_TP_FATAL_ERROR_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_fatal_error, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_fatal_error, \
                    TRACE_CRIT)

#define ADK_DP_TP_FATAL_FORCE_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_force_fatal, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_force_fatal, \
                    TRACE_CRIT)

#define ADK_DP_TP_WARNING_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_warning, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_warning, \
                    TRACE_WARNING)

#define ADK_DP_TP_WARNING_FORCE_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_force_warning, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_force_warning, \
                    TRACE_WARNING)

#define ADK_DP_TP_FUNC_ENTRY_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_func_entry, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_func_entry, \
                    TRACE_DEBUG_FUNCTION)

#define ADK_DP_TP_FUNC_EXIT_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_func_exit, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_dp, \
                    intel_adk_dp_func_exit, \
                    TRACE_DEBUG_FUNCTION)


#define ADK_DP_TP_ALL_MACROS(__module__) \
    ADK_DP_TP_CLASS_ALL_MACROS(__module__, _) \
    ADK_DP_TP_ERROR_FORCE_MACRO(__module__) \
    ADK_DP_TP_ERROR_MACRO(__module__) \
    ADK_DP_TP_ERROR_1D_MACRO(__module__) \
    ADK_DP_TP_ERROR_2D_MACRO(__module__) \
    ADK_DP_TP_ERROR_1P_MACRO(__module__) \
    ADK_DP_TP_ERROR_ERRNO_MACRO(__module__) \
    ADK_DP_TP_ERROR_1S_MACRO(__module__) \
    ADK_DP_TP_FATAL_ERROR_MACRO(__module__) \
    ADK_DP_TP_FATAL_FORCE_MACRO(__module__) \
    ADK_DP_TP_FUNC_ENTRY_MACRO(__module__) \
    ADK_DP_TP_FUNC_EXIT_MACRO(__module__) \
    ADK_DP_TP_INFO_FORCE_MACRO(__module__) \
    ADK_DP_TP_INFO_MACRO(__module__) \
    ADK_DP_TP_INFO_1D_MACRO(__module__) \
    ADK_DP_TP_INFO_1P_MACRO(__module__) \
    ADK_DP_TP_INFO_1X_MACRO(__module__) \
    ADK_DP_TP_INFO_2D_MACRO(__module__) \
    ADK_DP_TP_INFO_ERRNO_MACRO(__module__) \
    ADK_DP_TP_INFO_1S_MACRO(__module__) \
    ADK_DP_TP_WARNING_FORCE_MACRO(__module__) \
    ADK_DP_TP_WARNING_MACRO(__module__)


#endif     /* -----  _ADK_DP_TP_MACROS_H_  ----- */
