/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
/*!
 * @internal
 * file  adk_dp_tp_macros_debug.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * brief
 *
 * Base set of macros for building the standard DP debug LTTng files
 *
 ***********************************************************************/

#ifndef  _ADK_DP_TP_MACROS_DEBUG_H_
#define  _ADK_DP_TP_MACROS_DEBUG_H_

#ifdef ADK_DEBUG

#include "adk_dp_tp_class_macros.h"

#define ADK_DP_TP_LOG_HW_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_log_hw, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_log_hw, \
                    TRACE_DEBUG)

#define ADK_DP_TP_FUNC_ENTRY_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_func_entry, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_func_entry, \
                    TRACE_DEBUG_FUNCTION)

#define ADK_DP_TP_FUNC_EXIT_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_func_exit, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_func_exit, \
                    TRACE_DEBUG_FUNCTION)

#define ADK_DP_TP_INFO_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s, \
                              intel_adk_dp_info, \
                              ADK_DP_TP_CLASS_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1d, \
                              intel_adk_dp_info_1d, \
                              ADK_DP_TP_CLASS_1S_1D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_2D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_2d, \
                              intel_adk_dp_info_2d, \
                              ADK_DP_TP_CLASS_1S_2D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_2d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_3D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_3d, \
                              intel_adk_dp_info_3d, \
                              ADK_DP_TP_CLASS_1S_3D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_3d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_4D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_4d, \
                              intel_adk_dp_info_4d, \
                              ADK_DP_TP_CLASS_1S_4D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_4d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_5D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_5d, \
                              intel_adk_dp_info_5d, \
                              ADK_DP_TP_CLASS_1S_5D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_5d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1x, \
                              intel_adk_dp_info_1x, \
                              ADK_DP_TP_CLASS_1S_1X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_2X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_2x, \
                              intel_adk_dp_info_2x, \
                              ADK_DP_TP_CLASS_1S_2X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_2x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_3X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_3x, \
                              intel_adk_dp_info_3x, \
                              ADK_DP_TP_CLASS_1S_3X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_3x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_4X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_4x, \
                              intel_adk_dp_info_4x, \
                              ADK_DP_TP_CLASS_1S_4X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_4x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_5X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_5x, \
                              intel_adk_dp_info_5x, \
                              ADK_DP_TP_CLASS_1S_5X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_5x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_6X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_6x, \
                              intel_adk_dp_info_6x, \
                              ADK_DP_TP_CLASS_1S_6X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_6x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1P_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1p, \
                              intel_adk_dp_info_1p, \
                              ADK_DP_TP_CLASS_1S_1P_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1p, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_2P_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_2p, \
                              intel_adk_dp_info_2p, \
                              ADK_DP_TP_CLASS_1S_2P_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_2p, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_ERRNO_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1s_1x, \
                              intel_adk_dp_info_errno, \
                              ADK_DP_TP_CLASS_1S_1S_1X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_errno, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1S_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1s, \
                              intel_adk_dp_info_1s, \
                              ADK_DP_TP_CLASS_1S_1S_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1s, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1D_1X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1d_1x, \
                              intel_adk_dp_info_1d_1x, \
                              ADK_DP_TP_CLASS_1S_1D_1X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1d_1x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1P_4D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1p_4d, \
                              intel_adk_dp_info_1p_4d, \
                              ADK_DP_TP_CLASS_1S_1P_4D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1p_4d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1P_1X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1p_1x, \
                              intel_adk_dp_info_1p_1x, \
                              ADK_DP_TP_CLASS_1S_1P_1X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1p_1x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_1P_2X_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_1p_2x, \
                              intel_adk_dp_info_1p_2x, \
                              ADK_DP_TP_CLASS_1S_1P_2X_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_1p_2x, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_2P_1D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_2p_1d, \
                              intel_adk_dp_info_2p_1d, \
                              ADK_DP_TP_CLASS_1S_2P_1D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_2p_1d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_INFO_2P_2D_DEBUG_MACRO(__module) \
    TRACEPOINT_EVENT_INSTANCE(com_intel_adk_##__module##_debug_dp, \
                              adk_lttng_##__module##_class_1s_2p_2d, \
                              intel_adk_dp_info_2p_2d, \
                              ADK_DP_TP_CLASS_1S_2P_2D_TP_ARGS \
                             ) \
TRACEPOINT_LOGLEVEL(com_intel_adk_##__module##_debug_dp, \
                    intel_adk_dp_info_2p_2d, \
                    TRACE_DEBUG)

#define ADK_DP_TP_DEBUG_ALL_MACROS(__module__) \
    ADK_DP_TP_CLASS_ALL_MACROS(__module__, _debug_) \
    ADK_DP_TP_LOG_HW_DEBUG_MACRO(__module__) \
    ADK_DP_TP_FUNC_ENTRY_DEBUG_MACRO(__module__) \
    ADK_DP_TP_FUNC_EXIT_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1D_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_2D_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_3D_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_4D_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_5D_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_2X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_3X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_4X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_5X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_6X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1P_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_2P_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_ERRNO_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1S_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1D_1X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1P_4D_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1P_1X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_1P_2X_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_2P_1D_DEBUG_MACRO(__module__) \
    ADK_DP_TP_INFO_2P_2D_DEBUG_MACRO(__module__)

#else   /* ----- #ifdef ADK_DEBUG  ----- */
#define ADK_DP_TP_DEBUG_ALL_MACROS(__module__)
#endif   /* ----- #ifdef ADK_DEBUG  ----- */

#endif   /* ----- #ifndef _ADK_DP_TP_MACROS_DEBUG_H_  ----- */
