/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
/*!
 * file  adk_tp_sif_fps.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * brief
 *
 * This file contains definitions of tracepoint providers and events.
 *
 ***********************************************************************/

#undef TRACEPOINT_PROVIDER
#define TRACEPOINT_PROVIDER com_intel_adk_sif_fps

/*
 *  * include file (this files's name)
 *   */
#undef TRACEPOINT_INCLUDE
#define TRACEPOINT_INCLUDE "./adk_tp_sif_fps.h"


#if !defined(_TRACEPOINT_COM_INTEL_ADK_SIF_FPS_H) || defined(TRACEPOINT_HEADER_MULTI_READ)
#define _TRACEPOINT_COM_INTEL_ADK_SIF_FPS_H

#ifdef __cplusplus
extern "C" {
#endif


#include <lttng/tracepoint.h>

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_info,
                TP_ARGS(const char*, module_name, int, line_no, const char*,
                            file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(Module_Name, module_name)
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_info, TRACE_DEBUG)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_force_info,
                TP_ARGS(int, line_no, const char*, file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                          )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_force_info, TRACE_DEBUG)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_error,
                TP_ARGS(const char*, module_name, int, line_no, const char*,
                            file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(Module_Name, module_name)
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_error, TRACE_ERR)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_force_error,
                TP_ARGS(int, line_no, const char*, file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_force_error, TRACE_CRIT)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_fatal_error,
                TP_ARGS(const char*, module_name, int, line_no, const char*,
                            file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(Module_Name, module_name)
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_fatal_error, TRACE_CRIT)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_force_fatal,
                TP_ARGS(int, line_no, const char*, file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_force_fatal, TRACE_CRIT)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_warning,
                TP_ARGS(const char*, module_name, int, line_no, const char*,
                            file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(Module_Name, module_name)
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_warning, TRACE_WARNING)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_force_warning,
                TP_ARGS(int, line_no, const char*, file_name, char*, debug_info),
                TP_FIELDS(
                            ctf_string(File_Name, file_name)
                            ctf_integer(int, Line_no, line_no)
                            ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_force_warning, TRACE_WARNING)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_func_entry,
                TP_ARGS(const char *, module_name, int, line_no, const char*,
                            file_name, const char*, function_name),
                TP_FIELDS(
                              ctf_string(Module_Name, module_name)
                              ctf_string(File_Name, file_name)
                              ctf_integer(int, Line_no, line_no)
                              ctf_string(Function_Name, function_name)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_func_entry, TRACE_DEBUG_FUNCTION)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_func_exit,
                TP_ARGS(const char *, module_name, int, line_no, const char*,
                            file_name, const char*, function_name),
                TP_FIELDS(
                              ctf_string(Module_Name, module_name)
                              ctf_string(File_Name, file_name)
                              ctf_integer(int, Line_no, line_no)
                              ctf_string(Function_Name, function_name)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_func_exit, TRACE_DEBUG_FUNCTION)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_lock_acquire,
                TP_ARGS(const char *, module_name, int, line_no, const char*,
                            file_name, const char *, debug_info),
                TP_FIELDS(
                              ctf_string(Module_Name, module_name)
                              ctf_string(File_Name, file_name)
                              ctf_integer(int, Line_no, line_no)
                              ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_lock_acquire, TRACE_DEBUG_FUNCTION)

TRACEPOINT_EVENT(com_intel_adk_sif_fps, intel_adk_lock_release,
                TP_ARGS(const char *, module_name, int, line_no, const char*,
                            file_name, const char *, debug_info),
                TP_FIELDS(
                              ctf_string(Module_Name, module_name)
                              ctf_string(File_Name, file_name)
                              ctf_integer(int, Line_no, line_no)
                              ctf_string(Debug_Info, debug_info)
                         )
                )
TRACEPOINT_LOGLEVEL(com_intel_adk_sif_fps, intel_adk_lock_release, TRACE_DEBUG_FUNCTION)

#endif /* _TRACEPOINT_COM_INTEL_ADK_SIF_FPS_H */

        /* This part must be outside ifdef protection */
#include <lttng/tracepoint-event.h>

#ifdef __cplusplus
}
#endif




