/* ***************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @file  adk_qos_include.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @addtogroup _qos  QoS Module
 * @{
 *
 * This file contains ADK QoS data structures, macros and API signatures
 *
 *
 *  **********************************************************************/

#ifndef __ADK_QOS_INCLUDE_INTERNAL_H__
#define __ADK_QOS_INCLUDE_INTERNAL_H__

#include "adk_sys.h"
#include <acp_gen_interface.h>

#include <adk_ph_dev.h>

#if 0
typedef adk_handle_t    adk_qos_policer_handle_t;
#endif

#define ADK_QOS_DEV_NET_MAX_POLICERS    1024
#define ADK_QOS_INVALID_POLICER_FLOW_ID UINT_MAX 
#define ADK_QOS_DEV_NET_CMSG_QUEUE_ID       (0)

typedef struct adk_qos_queue_id_info_s {
    /* Parent device id  */
    uint16_t        devId;
    /* Queue id */
    uint16_t        queueId;
    /* Policer id  (applicable only for ADK slowpath devices  */
    uint32_t        policerId;
    /* Queue Egress Stats  ID */
    uint32_t        queueStatsId;
} adk_qos_queue_id_info_t;


adk_status_t
adk_qos_instance_init(adk_sys_handle_t  sysHandle,
                        uint32_t ethDevId);
adk_status_t
adk_qos_instance_shutdown(adk_sys_handle_t  sysHandle,
                        uint32_t ethDevId);
adk_status_t
adk_qos_queue_info_get(
    adk_sys_handle_t        sysHandle,
    adk_handle_t       queueHandle,
    adk_qos_queue_id_info_t *qId_p);

adk_status_t
adk_qos_policing_flow_id_get(
        adk_sys_handle_t  sysHandle,
        adk_handle_t policeHandle,
        uint32_t  *flow_id);

#endif /* __ADK_QOS_INCLUDE_INTERNAL_H__ */

/*!
 *   @} end addtogroup _qosFunctions
 *
 * @} end addtogroup _qos
 */
