/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_qos_dp.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 * @addtogroup _qos QoS Module
 * @{
 *
 * @brief  This file contains ADK QoS handles
 *
 *
 *  **********************************************************************/

#ifndef __ADK_QOS_DP_H__
#define __ADK_QOS_DP_H__

/*!
 * PDU has been colored RED by the policer.
 */
#define RED    0x03
/*!
 * PDU has been colored YELLOW by the policer.
 */
#define YELLOW 0x01
/*!
 * PDU has been colored GREEN by the policer.
 */
#define GREEN  0x00

typedef struct adk_qos_ts_param_s
{
    uint32_t pbs_ticks;
    uint32_t cbs_ticks;
    uint16_t pir_ticks;
    uint16_t cir_ticks;
    uint32_t pir_bucket_token;
    uint32_t cir_bucket_token;
    uint32_t prev_time;
#ifdef DEBUG
    uint32_t green_pkts;
    uint32_t yellow_pkts;
    uint32_t red_pkts;
#endif
} adk_qos_ts_param_t; 

typedef struct adk_qos_dp_policing_param_s
{
    uint32_t pbs_ticks;
    uint32_t cbs_ticks;
    uint16_t pir_ticks;
    uint16_t cir_ticks;
    uint32_t pir_bucket_token;
    uint32_t cir_bucket_token;
    uint32_t prev_time;
#ifdef ADK_DEBUG
    uint32_t green_pkts;
    uint32_t yellow_pkts;
    uint32_t red_pkts;
#endif
} adk_qos_dp_policing_param_t;

adk_status_t 
adk_qos_dp_trtcm_rate_shaper(
                adk_qos_ts_param_t *tsParams,
                uint32_t packetSize,
                bool *isReady);

#endif /* __ADK_QOS_DP_H__ */

/*!
 * @} end addtogroup _qos
 */
