/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_qos_policing_private.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 * @addtogroup _qos QoS Module
 * @{
 *
 * @brief  This file contains ADK QoS Policing profiler private
 *         data structures, macros and API signatures
 *
 *
 *  **********************************************************************/

#ifndef __ADK_QOS_POLICING_PRIVATE_H__
#define __ADK_QOS_POLICING_PRIVATE_H__

#include "adk_include.h"
#include "adk_qos_include.h"

adk_status_t
adk_qos_policing_init( 
        adk_sys_handle_t            sysHandle);

adk_status_t
adk_qos_policing_shutdown( 
        adk_sys_handle_t            sysHandle);

#endif    /* __ADK_QOS_POLICING_PRIVATE_H__ */

/*!
 * @} end addtogroup _qos
 */
