/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_qos_se_ds_paramgen.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 * @addtogroup _qos QoS Module
 * @{
 *
 * @brief  This file contains paramgen function's macros and API signatures
 *
 *
 *  **********************************************************************/

#ifndef __ADK_QOS_SE_DS_PARAMGEN_H__
#define __ADK_QOS_SE_DS_PARAMGEN_H__

#define ADK_QUEUE_PARAM_SIZE  16

/*!
 * =============================================================
 * @brief  Diffserv policing script IDs (Double check with the xml file
 * =============================================================
 */
#define ADK_QOS_DS_SRTCM_COLOR_BLIND_SCRIPT     0
#define ADK_QOS_DS_SRTCM_COLOR_AWARE_SCRIPT     1
#define ADK_QOS_DS_TRTCM_COLOR_BLIND_SCRIPT     2
#define ADK_QOS_DS_TRTCM_COLOR_AWARE_SCRIPT     3


/*!
 * =============================================================
 * @brief  Paramgen API signatures
 *
 *   @addtogroup _qosFunctions QoS Functions
 *   @{
 *
 * =============================================================
 */

adk_status_t
adk_qos_ds_srtcm_params_gen(
    adk_sys_handle_t     sysHandle,
    uint32_t         cir,
    uint32_t         cbs,
    uint32_t         ebs,
    uint32_t         clockSpeed,
    uint32_t         *policingParams_p);

adk_status_t
adk_qos_ds_trtcm_params_gen(
    adk_sys_handle_t     sysHandle,
    uint32_t         cir,
    uint32_t         pir,
    uint32_t         cbs,
    uint32_t         pbs,
    uint32_t         clockSpeed,
    uint32_t         *policingParams_p);

#endif /* __ADK_QOS_SE_DS_PARAMGEN_H__ */

/*!
 *   @} end addtogroup _qosFunctions
 * @} end addtogroup _qos
 */
