/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_qos_se_gcra_policing_paramgen.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 * @addtogroup _qos  QoS Module
 * @{
 *
 * @brief  This file contains paramgen function's macros and API signatures
 *
 *
 *  **********************************************************************/

#ifndef _ADK_PARAMGEN_H_
#define _ADK_PARAMGEN_H_


#define ADK_QOS_ATM_CBR         0x10   /* CBR.1 */
#define ADK_QOS_ATM_VBR_NRT     0x20   /* VBR.1 */
#define ADK_QOS_ATM_UBR         0x50   /* UBR.1 */
#define ADK_QOS_ATM_UBR_PLUS    0x60   /* UBR.2 */


#define ATM_GCRA_PARM_SIZE  64

#define ATM_CELL_SIZE       52
#define NUEVOCLOCK          256000000
#define ACP_CLOCKTICK       (1.0/NUEVOCLOCK)

/* Copy an integer variable to a char array */
#define ADK_INT_TO_CHAR(dataBuf, loc, x)               \
        dataBuf[(loc)]   = ( (x) & 0xff000000 ) >> 24; \
        dataBuf[(loc)+1] = ( (x) & 0x00ff0000 ) >> 16; \
        dataBuf[(loc)+2] = ( (x) & 0x0000ff00 ) >> 8;  \
        dataBuf[(loc)+3] = ( (x) & 0x000000ff )


/*!
 * =============================================================
 * @brief  Paramgen API signatures
 *
 *   @addtogroup _qosFunctions  QoS Functions
 *   @{
 *
 * =============================================================
 */

#if 0
adk_status_t
adk_qos_gcra_policing_params_gen(
    float PCRcell,
    float SCRcell,
    float mbs,
    float CDVT,
    /* float Tc, */
    unsigned char trafficClass,
    unsigned char *polScriptParams);
#endif

adk_status_t 
 adk_qos_se_gcra_policing_params_gen(
    adk_sys_handle_t      sysHandle,
    uint32_t    PCRcell,
    uint32_t    SCRcell,
    uint32_t    MBS,
    uint32_t    CDVT,
    unsigned char   trafficClass,
    uint32_t    ClockSpeed,
    uint32_t    *policingParams_p);

#endif /* _ADK_PARAMGEN_H_ */


/*!
 *   @} end addtogroup _qosFunctions
 * @} end addtogroup _qos
 */

