/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_domain.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @addtogroup _sif  SIF Module
 *
 * @{
 *
 * @brief Definition of exception domain values that can be included in C code
 *
 *
 *
 ***********************************************************************/

#ifndef __ADK_DOMAIN_H__
#define __ADK_DOMAIN_H__

/* This is C code */
#  ifdef __cplusplus
extern "C" {
#  endif /* __cplusplus */

#define ADK_DEF_TN_PORT_DOMAIN      0
#define ADK_DEF_FP_ORIGIN_DOMAIN    2
#define ADK_DEF_OS_ORIGIN_DOMAIN    3

/* This is C code */
/*!
 * =============================================================
 * @internal
 * @enum adk_sif_domain_t
 *
 * =============================================================
 */
typedef enum __attribute__ ((__packed__)) adk_sif_domain_e {
    ADK_TN_PORT_DOMAIN = ADK_DEF_TN_PORT_DOMAIN, /*!<  */
    ADK_FP_ORIGIN_DOMAIN = ADK_DEF_FP_ORIGIN_DOMAIN, /*!<  */
    ADK_OS_ORIGIN_DOMAIN = ADK_DEF_OS_ORIGIN_DOMAIN, /*!<  */
} adk_sif_domain_t;   /* ------  end of enum adk_sif_domain_t  ------ */

#  ifdef __cplusplus
}
#  endif /* __cplusplus */

#endif /* __ADK_DOMAIN_H__ */
 
/*! end addtogroup _sif
 * @}
 */
