/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_include
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @addtogroup _sif  SIF Module
 * @{
 *
 * @brief
 *
 *  Header files to be included by ADK module to be able to access SIF's
 *  internal data structures and functions.
 *
 ***********************************************************************/
#ifndef __ADK_INCLUDE_H__
#define __ADK_INCLUDE_H__

#include "adk_dpdk.h"
#include <ncp_internal.h>

#include <adk_sys.h>

#include <adk_sif_constants.h>
#include <adk_sif.h>
#include <adk_platform.h>
#include <adk_sys_services.h>
#include <adk_os.h>
#include <adk_log_lib.h>
#include <adk_sif_dp_log_lib.h>
#include <adk_sif_cfg_include.h>
#include <adk_module_mgr.h>
#include <adk_bind_interface.h>
#include <adk_ph_dev.h>

#include <adk_list.h>
#include <adk_qos_include.h>
#include <adk_qos_policing_include.h>
#include <adk_domain.h>
#include <adk_metadata.h>

#include <adk_pal.h>
#include <adk_pal_internal.h>
#include <adk_pal_dp_export.h>

#endif

/*! end addtogroup _sif
 * @}
 */
