/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @file  adk_module_id.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @addtogroup _sif  SIF Module
 *
 * @{
 *
 * @brief  
 *
 * This file contains the name and ID of the modules in ADK. This
 * file is included by both CP and DP C code. Also
 * note that this file should not be directly included in the C file.
 * Instead adk_sys.h header file should be included which includes this header
 * file.
 *
 ***********************************************************************/

#ifndef __ADK_MODULE_ID_H__
#define __ADK_MODULE_ID_H__

#define ADK_SYS_MODULE_NAME        "adk_sys"
#define ADK_SYS_QOS_MODULE_NAME    "adk_sys_qos"
#define ADK_FPS_MODULE_NAME         "adk_fps"
#define ADK_PH_MODULE_NAME         "adk_ph"
#define ADK_SYS_MODULE_ID          0

#define ADK_IP_MODULE_NAME         "adk_ip"
#define ADK_IP_MODULE_ID           1

#define ADK_ETHERNET_MODULE_NAME   "adk_ethernet"
#define ADK_ETHERNET_MODULE_ID     2

#define ADK_IPSEC_MODULE_NAME      "adk_ipsec"
#define ADK_IPSEC_MODULE_ID        3

#define ADK_IPV6_MODULE_NAME       "adk_ipv6"
#define ADK_IPV6_MODULE_ID         4

#define ADK_PTP_MODULE_NAME        "adk_ptp"
#define ADK_PTP_MODULE_ID          5

#define ADK_UDP_MODULE_NAME        "adk_udp"
#define ADK_UDP_MODULE_ID          6

#define ADK_LCPS_MODULE_NAME       "adk_lcps"
#define ADK_LCPS_MODULE_ID         7

#define ADK_ATM_MODULE_NAME        "adk_atm"
#define ADK_ATM_MODULE_ID          8

#define ADK_AAL5_MODULE_NAME       "adk_aal5"
#define ADK_AAL5_MODULE_ID         9

#define ADK_AAL2_MODULE_NAME       "adk_aal2"
#define ADK_AAL2_MODULE_ID         10

#define ADK_GTPU_MODULE_NAME       "adk_gtpu"
#define ADK_GTPU_MODULE_ID         11


#define ADK_ETH_OAM_MODULE_NAME    "adk_eth_oam"
#define ADK_ETH_OAM_MODULE_ID      12

#define ADK_LTE_PDCP_MODULE_NAME   "adk_lte_pdcp"
#define ADK_LTE_PDCP_MODULE_ID     13

#define ADK_AR_MODULE_NAME         "adk_ar"
#define ADK_AR_MODULE_ID           14

#define ADK_BP_MODULE_NAME         "adk_bp"
#define ADK_BP_MODULE_ID           15

#define ADK_LAPD_MODULE_NAME       "adk_lapd"
#define ADK_LAPD_MODULE_ID         16

#define ADK_CUSTRAWETH_MODULE_NAME "adk_custraweth"
#define ADK_CUSTRAWETH_MODULE_ID   17

#define ADK_RTP_MUX_MODULE_NAME    "adk_rtp_mux"
#define ADK_RTP_MUX_MODULE_ID      18

#define ADK_IPHC_MODULE_NAME       "adk_iphc"
#define ADK_IPHC_MODULE_ID         19

#define ADK_CUSTBP_MODULE_NAME     "adk_custbp"
#define ADK_CUSTBP_MODULE_ID       20

#define ADK_BFD_MODULE_NAME        "adk_bfd"
#define ADK_BFD_MODULE_ID          21

#define ADK_NODEB_FP_MODULE_NAME   "adk_nodeb_fp"
#define ADK_NODEB_FP_MODULE_ID     22

#define ADK_UDP_IWF_MODULE_NAME    "adk_udp_iwf"
#define ADK_UDP_IWF_MODULE_ID      23

#define ADK_TWAMP_MODULE_NAME      "adk_twamp"
#define ADK_TWAMP_MODULE_ID        24

#define ADK_HSFP_IWF_MODULE_NAME   "adk_hsfp_iwf"
#define ADK_HSFP_IWF_MODULE_ID     25

#define ADK_BP_IWF_MODULE_NAME     "adk_bp_iwf"
#define ADK_BP_IWF_MODULE_ID       26

#define ADK_MBA_MODULE_NAME        "adk_mba"
#define ADK_MBA_MODULE_ID          27


#define ADK_L2TPV3_MODULE_NAME     "adk_l2tpv3"
#define ADK_L2TPV3_MODULE_ID       29

#define ADK_EHSFP_IWF_MODULE_NAME  "adk_ehsfp_iwf"
#define ADK_EHSFP_IWF_MODULE_ID    30

/* TIMER/LPM Dump/QOS/PH_DEV/SIF (for dynamic mem 
 * computation) */
#define	ADK_MISC_MODULE_ID         31

#define ADK_PAL_MODULE_ID          32
#define	ADK_SLOW_PATH_ID           33

#define ADK_MODULE_ID_WIDTH        8

#endif /* __ADK_MODULE_ID_H__ */
 
/*! end addtogroup _sif
 * @}
 */

