/* **************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
/*!
 * @file  adk_sys_lcore.h
 *
 *      $HeadURL: $
 *      $Revision: $
 *      $Date: $
 *
 * @addtogroup _sif  SIF Module
 * @{
 *
 * @brief  Used when working with LCOREs in the system.
 *
 *  **********************************************************************/

#ifndef  _ADK_SYS_LCORE_H_
#define  _ADK_SYS_LCORE_H_

#include "rte_lcore.h"

/*!
 * =============================================================
 * @def ADK_LCORE_ID
 *
 * @brief Returns the index for the current core
 *
 * This macro returns an index to for the current core. This could be used to
 * increment statistics for the current lcore so we don't need locking in the
 * DP.
 *
 * =============================================================
 */
#define ADK_LCORE_ID (rte_lcore_id())

/*!
 * =============================================================
 * @def ADK_LCORE_INDEX
 *
 * @brief Returns the index for the current core
 *
 * This macro returns an index to for the current core. This could be used to
 * increment statistics for the current lcore so we don't need locking in the
 * DP.
 *
 * =============================================================
 */
#define ADK_LCORE_INDEX (rte_lcore_index(-1))

/*!
 * =============================================================
 * @def ADK_LCORE_INDEX_LOOKUP(_coreId)
 *
 * @brief Returns the index for the passed core ID
 *
 *
 * =============================================================
 */
#define ADK_LCORE_INDEX_LOOKUP(_coreId) (rte_lcore_index((_coreId)))

#endif   /* ----- #ifndef _ADK_SYS_LCORE_H_  ----- */

/*! end addtogroup }}}1
 * @}
 *
 * vim: set foldmethod=marker foldlevel=1 foldcolumn=3 columns=83:
 */
