/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @file  adk_sys_services.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @addtogroup _sif  SIF Module
 *
 * @{
 *
 * @brief
 *
 * This file contains definitions and declarations of ADK system services  
 * interface definition (APIs and data structure definitions). 
 * ADK modules should include this file to use system services.
 *
 ***********************************************************************/

#ifndef __ADK_SYS_SERVICES_H__
#define __ADK_SYS_SERVICES_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "adk_sif.h"
#include "adk_sys_config.h"

/* Move the exiting *config_get funcitons to this header file */


/*Exiting Funciton moved here for reference */
adk_status_t 
adk_sys_config_worker_lcore_info_get (
        adk_sys_config_worker_lcore_info_t **workerInfo_p);

adk_status_t 
adk_sys_config_mode_get (
        adk_sys_config_mode_t *adk_mode);

/* New service functions and related data-strucrure definitions*/
adk_status_t 
adk_sys_config_evdev_info_get (
        adk_sys_resource_info_t **evdev_rsrc_list_p, 
        uint8_t *num_evdevs);

adk_status_t 
adk_sys_config_crypto_dev_info_get (
        adk_sys_resource_info_t **cdev_rsrc_list_p, 
        uint8_t *num_crypto_devs);

adk_status_t 
adk_sys_config_eth_dev_info_get (
        adk_sys_resource_info_t **ethdev_rsrc_list_p, 
        uint8_t *num_eth_devs);

adk_status_t 
adk_sys_config_timer_dev_info_get (
        adk_sys_resource_info_t  **tmrdev_rsrc_list_p, 
        uint8_t *num_tmrdevs);

#ifdef __cplusplus
}
#endif

#endif /* __ADK_SYS_SERVICES_H__ */

/*! end addtogroup _sif
 * @}
 */
