/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_utils_tree_update.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 *
 * @addtogroup _sif  SIF Module
 *
 * @{
 *
 * @brief  
 *
 * This file contains all declarations specific to tree update 
 * utility functions.
 *
 ***********************************************************************/
#ifndef __ADK_UTILS_TREE_UPDATE_H__
#define __ADK_UTILS_TREE_UPDATE_H__

adk_status_t
adk_utils_list_create ( 
        adk_list_t **list_p );

adk_status_t
adk_utils_list_append ( 
        adk_list_t *list_p,
        uint32_t key,
        void *data );

adk_status_t
adk_utils_list_find ( 
        adk_list_t *list_p,
        uint32_t key,
        void **data_p );

adk_status_t
adk_utils_list_remove ( 
        adk_list_t __attribute__((unused)) *list_p, 
        uint32_t __attribute__((unused)) key );


#endif  /* __ADK_UTILS_TREE_UPDATE_H__ */
 
/*! end addtogroup _sif
 * @}
 */

