/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @file  adk_netd_ts_index_init.c
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 * @addtogroup _devNet  ADK Device Net
 * @{
 *     @addtogroup _devNetFunctions  ADK Device Net Functions
 *     @{
 *
 * @brief
 *
 * This file contains the adk software initialization functions
 * for TN port timestamping index management.
 *
 *
 *  **********************************************************************/

#include "adk_include.h"
#include "ncp.h"

#include "adk_sys.h"
#include "adk_sys_private.h"

#include "adk_release_id.h"

#include <adk_rm.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


#include "adk_config_overrides.h"

#include <adk_sys_dpdk.h>
#include "adk_shm.h"
#include <sys/time.h>

#include "adk_dev_net.h"
#include "adk_dev_net_internal.h"
#include <adk_nd_common.h>
#include <adk_netd_ts_index.h>
#include <adk_netd_fp_ts_index.h>

#ifdef ADK_DEVICE_SNR
int
adk_netd_fp_ts_init(uint8_t port_grp)
{
    int ret = 0;
    RTE_SET_USED(port_grp);
    /*port grp parameter may not be required*/
    adk_netd_ts_index_init();

    return ret;
}
#endif

