/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_bind_tree_cfg.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 * @addtogroup _sif  SIF Module
 *
 * @{
 *
 * @brief  
 *
 * This file contains all the tree specific definitions used
 * by the ADK bind software. The definitions here are shared by
 * control plane software.
 *
 ***********************************************************************/

#ifndef __ADK_BIND_TREE_CFG_H__
#define __ADK_BIND_TREE_CFG_H__

/*!
 * =============================================================
 * 
 * @struct adk_bind_master_handle_t adk_bind_interface.h "adk_bind_interface.h"
 *
 *
 * This data structure holds all the bind specific state information.
 *
 * =============================================================
 */
typedef struct adk_bind_master_handle_s
{
    adk_bind_pipeline_dmux_table_t bindDmuxInfo[ADK_MAX_PIPELINES];
    adk_handle_t *cpuBindTable_p;
} adk_bind_master_handle_t;

#endif

 
/*! end addtogroup _sif
 * @}
 */
