/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
/*!
 * @internal
 * @file  adk_sys_private.h
 *
 *      $HeadURL$
 *      $Revision$
 *      $Date$
 * @addtogroup _sif  SIF Module
 * @{
 *
 * @brief  
 *
 * This file contains APIs that are used to manage module specific 
 * information. 
 *
 ***********************************************************************/

#ifndef __ADK_SYS_PRIVATE_H__
#define __ADK_SYS_PRIVATE_H__

#include "adk_sys.h"
#include <adk_queue.h>
#include <adk_pktio.h>


#include <pthread.h>



/* used only for cubie-board */
#define NUM_THREADS 1


#define NW_PORT		1
#define DSP_PORT	2

#define EIOA_PORT_A	0
#define EIOA_PORT_B	1

/*! Configuration info table handle */
#define ADK_SYS_CFG_HANDLE_GET(sys) \
    ((adk_cfg_info_t *)(((adk_sys_info_t *)(sys))->cfgHandle))


typedef struct {
    adk_sys_handle_t sysHandle;
    uint32_t recvQId;
    /* used only for cubie-board */
    int flow_type;
    int num_iteration;
} adk_sys_thread_info_t;

extern adk_sys_thread_info_t adkT_Info_g;

extern pthread_t adkPktRcvThreadId_g[4], adkMasterThreadId_g;

void
adk_sys_create_dp_threads(adk_sys_handle_t sysHandle, char *configFile_p);

void *
adk_dp_process_pdu_fn (void __attribute__((unused)) *data);

#ifdef ADK_MODULE_IPSEC_ENABLED
extern adk_dp_status_t adk_ipsec_dp_recv_from_spp_after_encryption(void *task, int coreIndex, adk_flow_handle_t destFlow);
extern adk_dp_status_t adk_ipsec_dp_recv_from_spp_after_decryption(void *task, int coreIndex, adk_flow_handle_t destFlow);
#endif /*  ADK_MODULE_IPSEC_ENABLED */

#endif /* __ADK_SYS_PRIVATE_H__ */

/*! end addtogroup _sif
 * @}
 */
