/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
#ifndef __ADK_CFG_H__
#define __ADK_CFG_H__

typedef enum adk_cfg_section_type_e{
    ADK_CFG_SECTION_TYPE_MIN = 0,
    ADK_CFG_SECTION_EAL,
    ADK_CFG_SECTION_MEMPOOL,
    ADK_CFG_SECTION_PORT,
    ADK_CFG_SECTION_RING,
    ADK_CFG_SECTION_PIPELINE,
    ADK_CFG_SECTION_TYPE_MAX
}adk_cfg_section_type_t;

typedef struct adk_cfg_params_s{
    /* Configuration parameters tbls */
    void        *cfg_handle;                     /* Handle to configuration file */
    void        *eal_params_tbl;                 /* Handle to EAL configuration parameters */
    void        *mempool_params_tbl;             /* Handle to mempool configuration parameters */
    void        *port_params_tbl;                /* Handle to port,queue configuration parameters */
    void        *ring_params_tbl;                /* Handle to ring configuration parameters */
    void        *pipeline_params_tbl;            /* Handle to pipeline configuration parameters */
    void        *pkt_buffs_params_tbl;           /* Handle to pkt buffs configuration parameters */
}adk_cfg_params_t;

/* Function prototypes */
adk_status_t
adk_cfg_init(adk_cfg_params_t **cfg_params);

adk_status_t
adk_cfg_shutdown(adk_cfg_params_t *cfg_params);

adk_status_t
adk_cfg_parse(int argc, char **argv, adk_cfg_params_t *cfg_params);

#if 0
adk_status_t
adk_cfg_set_core_list(adk_cfg_params_t *cfg_params, uint32_t lcoreid);

adk_status_t
adk_cfg_set_core_list_port_ring(adk_cfg_params_t *cfg_params, adk_sif_cfg_pipeline_params_t *sec_info);

adk_status_t
adk_cfg_set_port_q(adk_cfg_port_q_t *sec_pq, uint32_t num_sec_pq, 
                   adk_cfg_port_q_t *tbl_pq, uint32_t *num_tbl_pq);

adk_status_t
adk_cfg_set_ring_q(adk_cfg_ring_q_t *sec_rq, uint32_t num_sec_rq, 
                   adk_cfg_ring_q_t *tbl_rq, uint32_t *num_tbl_rq);
#endif

#endif
