/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
#ifndef __ADK_CFG_PVT_H__
#define __ADK_CFG_PVT_H__

typedef adk_status_t (*adk_cfg_config_section_load_f)(adk_cfg_params_t *cfg_params,
                                                    const char *section_name);

typedef struct adk_cfg_config_section_s{
    const char                      prefix[CFG_NAME_LEN];
    int                             numbers;
    adk_cfg_config_section_load_f   load;
}adk_cfg_config_section_t;

adk_status_t
adk_cfg_get_filename(int argc, char **argv, char **config_filename);

adk_status_t
adk_cfg_validate_name(const char *name, const char *prefix, int num);

static size_t
adk_cfg_skip_digits(const char *src);


#endif
