/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __ADK_UTIL_LIST_H__
#define __ADK_UTIL_LIST_H__


typedef struct newutil_list_node_s
{
    void *data;
} adk_newutil_list_node_t;

typedef struct newutil_list_s
{
    uint32_t size;
    uint32_t num_elements; /* number of slots used */
    uint32_t curr_node; /* next node to add */
    uint32_t iter; /* next node to fetch */
    adk_newutil_list_node_t *node_list;
} adk_newutil_list_t;

typedef adk_handle_t adk_list_hdl_t;

adk_list_hdl_t adk_list_create(uint32_t size, adk_sys_handle_t  sysHandle);

int adk_list_node_add(adk_list_hdl_t hdl,
		      void *data);

static inline int adk_list_next_node_get(adk_list_hdl_t listHdl,
			   void **data)
{
    adk_newutil_list_t *list = (adk_newutil_list_t *)listHdl;
    adk_newutil_list_node_t *newNode = NULL;

    newNode = &(list->node_list[list->iter++]);
    *data = newNode->data;

    if(list->iter == list->num_elements)
	return 0;
    return 1;
}

int adk_list_next_node_get_rollover(adk_list_hdl_t hdl,
			   void **data);

static inline int adk_list_restart_node_get(adk_list_hdl_t listHdl,
			      void **data)
{
    adk_newutil_list_t *list = (adk_newutil_list_t *)listHdl;
    adk_newutil_list_node_t *newNode = NULL;

    /* restart the list iteration */
    list->iter = 0;

    newNode = &(list->node_list[list->iter++]);
    *data = newNode->data;
    
    if(list->iter == list->num_elements)
	list->iter = 0; /* restart */

    return 1;
}

#endif
