/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/

/* queue handle */
typedef adk_handle_t adk_queue_handle_t;

/* APIs for normal queues */
adk_queue_handle_t adk_queue_create(uint32_t size);
int adk_queue_delete(adk_queue_handle_t qHdl);
int adk_queue_dequeue(adk_queue_handle_t qHdl, void **data);
int adk_queue_enqueue(adk_queue_handle_t qHdl, void *data);
uint32_t adk_queue_get_size(adk_queue_handle_t qHdl);
uint32_t adk_queue_get_depth(adk_queue_handle_t qHdl);
int adk_queue_get_data(adk_queue_handle_t qHdl, void **data);

/* APIs for lock-free single producer, single consumer queues */
adk_queue_handle_t adk_sp_sc_queue_create(uint32_t size);
int adk_sp_sc_queue_delete(adk_queue_handle_t qHdl);
int adk_sp_sc_queue_dequeue(adk_queue_handle_t qHdl, void **data);
int adk_sp_sc_queue_enqueue(adk_queue_handle_t qHdl, void *data);
uint32_t adk_sp_sc_queue_get_size(adk_queue_handle_t qHdl);

/* APIs for lock-free single producer, multiple consumer queues */
adk_queue_handle_t adk_sp_mc_queue_create(uint32_t size);
int adk_sp_mc_queue_delete(adk_queue_handle_t qHdl);
int adk_sp_mc_queue_dequeue(adk_queue_handle_t qHdl, void **data);
int adk_sp_mc_queue_enqueue(adk_queue_handle_t qHdl, void *data);
uint32_t adk_sp_mc_queue_get_size(adk_queue_handle_t qHdl);
