/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/

#ifndef __ADK_RM_H__
#define __ADK_RM_H__

#define ADK_MAX_RM_RSRC_WIDTH   20
#define ADK_MAX_RM_RSRC_SIZE    (1 << ADK_MAX_RM_RSRC_WIDTH)
    /* Valid ID can range from 0 to (ADK_MAX_RM_RSRC_SIZE - 1) */
#define ADK_RM_RSRC_INVALID     ADK_MAX_RM_RSRC_SIZE

typedef struct {
    char *resource;
    size_t size;
} adk_rm_rsrc_t;

typedef adk_handle_t adk_rm_hdl_t;

adk_rm_hdl_t
adk_rm_resource_init(size_t mod_id, size_t obj_id, size_t size);

size_t 
adk_rm_resource_reserve(adk_rm_hdl_t hdl);

bool
adk_rm_resource_reserve_fixed(adk_rm_hdl_t hdl, 
		                      size_t id);

bool
adk_rm_resource_free(adk_rm_hdl_t hdl, 
		     size_t index);

void adk_rm_resource_destroy(adk_rm_hdl_t hdl);

bool
adk_rm_resource_isset(adk_rm_hdl_t hdl, size_t id);

#endif
