/* **************************************************************************
**                                                                          *
** INTEL CONFIDENTIAL                                                       *
** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
**                                                                          *
** The source code contained or described herein and all documents related  *
** to the source code ("Material") are owned by Intel Corporation or its    *
** suppliers or licensors. Title to the Material remains with Intel         *
** Corporation or its suppliers and licensors. The Material contains trade  *
** secrets and proprietary and confidential information of Intel or its     *
** suppliers and licensors. The Material is protected by worldwide          *
** copyright and trade secret laws and treaty provisions. No part of the    *
** Material may be used, copied, reproduced, modified, published, uploaded, *
** posted, transmitted, distributed, or disclosed in any way without        *
** Intel's prior express written permission.                                *
**                                                                          *
** No license under any patent, copyright, trade secret or other            *
** intellectual property right is granted to or conferred upon you by       *
** disclosure or delivery of the Materials, either expressly, by            *
** implication, inducement, estoppel or otherwise. Any license under such   *
** intellectual property rights must be express and approved by Intel       *
** in writing.                                                              *
**                                                                          *
** **************************************************************************
**/
#ifndef __ADK_SHM_H__
#define __ADK_SHM_H__

#define ADK_SHM_LOOKUP_LCORE                0xff
#define ADK_SHM_FIRST_WORKER_IN_USE_LCORE   0xffff

typedef struct adk_shm_handle_type_s adk_shm_handle_t;

adk_status_t
adk_shm_create(
        const char *name,
        const size_t mem_size,
        const uint32_t lookupMethod,
        adk_shm_handle_t **shm_hdl);

adk_status_t
adk_shm_lookup(
        const char *name,
        adk_shm_handle_t **shm_hdl);

adk_status_t
adk_shm_destroy(
        const char *name);

#endif /* __ADK_SHM_H__ */
