#
# Makefile for Unix targets
#
# $Revision: 3a0e9a9f379004e404ee36177d516461a78e601f $
#

INCLUDE+=      -I. -I../include -I../../include $(ADK_INCDIRS)

SRCS=$(SRCS_DP) $(SRCS_CP_DP)

LIBTOOL_OBJSDIR = .
ifeq ($(ADK_USE_LIBTOOL),TRUE)
LIBTOOL_OBJS = $(SRCS:.c=.$(AXXIA_RTE_TARGET).lo)
LIBTOOL_OBJSDIR = .libs
endif

OBJS_SHARED = $(addprefix $(LIBTOOL_OBJSDIR)/, $(SRCS_CP_DP:.c=.$(AXXIA_RTE_TARGET).o))

OBJS_STATIC = $(addprefix $(LIBTOOL_OBJSDIR)/, $(SRCS_CP_DP:.c=.$(AXXIA_RTE_TARGET)_static.o))
OBJS_STATIC += $(addprefix $(LIBTOOL_OBJSDIR)/, $(SRCS_DP:.c=.$(AXXIA_RTE_TARGET)_static.o))

OBJS = $(OBJS_SHARED) $(OBJS_STATIC)

MODULE_DEPS = $(addprefix $(LIBTOOL_OBJSDIR)/, $(SRCS:.c=.$(AXXIA_RTE_TARGET).d))
MODULE_DEPS += $(addprefix $(LIBTOOL_OBJSDIR)/, $(SRCS:.c=.$(AXXIA_RTE_TARGET)_static.d))
LINT_OBJS = $(addprefix $(LIBTOOL_OBJSDIR)/, $(SRCS:.c=.lint))


all: debug

clobber:
	-$(ADK_Q)$(RM) -f *.o *.d *-objs*txt
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	-$(ADK_Q)$(RM) -rf .libs *.lo
endif
	-$(ADK_Q)$(RM) -rf ../include/adkDpTpEventList.txt adkDpTpEventList*

clean clean-c:
	-$(ADK_Q)$(RM) -f $(OBJS) $(MODULE_DEPS) *.$(AXXIA_RTE_TARGET)_static.o *-objs*.$(AXXIA_RTE_TARGET).txt
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	-$(ADK_Q)$(RM) -rf $(LIBTOOL_OBJSDIR)/*.$(AXXIA_RTE_TARGET).[od] *.$(AXXIA_RTE_TARGET).lo
endif
	-$(ADK_Q)$(RM) -rf ../include/adkDpTpEventList.txt adkDpTpEventList*

release debug code: objslist  ../include/adkDpTpEventList.txt $(OBJS) $(MODULE_DEPS)

lint: $(LINT_OBJS)

install install_hdrs:

objslist:
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	$(call get-libtool-objects-list)
else
	$(call get-lttng-objects-cp-list)
	$(call get-lttng-objects-dp-list)
endif

%.lint: %.c
	$(LINT) $(LINT_FLAGS) $(ADK_STRICT_CFLAGS) $(OS_FLAGS) $(CFLAGS) $(INCLUDE) $<

../include/adkDpTpEventList.txt: $(SRC)
	$(ADK_Q)$(CC) $(CFLAGS_COMMON) $(FLAGS) -E $(CFLAGS) $(CFLAGS_COMMON_SHARED) $(INCLUDE) -c adk_lttng_dp_tp.c -o adkDpTpEventList.E
	$(ADK_Q)$(SED) -e 's/;/;\
/g' adkDpTpEventList.E | \
	$(GREP) " _loglevel_value___com_intel_adk" | \
	$(SED) -e 's/^.* _loglevel_value___\(.*\)___\(.*\) = \(.*\);/\1 \2 \3/' | \
		$(SORT) > ../include/adkDpTpEventList.txt

$(LIBTOOL_OBJSDIR)/%.$(AXXIA_RTE_TARGET).d $(LIBTOOL_OBJSDIR)/%.$(AXXIA_RTE_TARGET).o: %.c
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	$(LIBTOOL_COMPILE_COMMAND) $(CC) $(CFLAGS_COMMON) $(FLAGS) $(LIBTOOL_COMPILE_FLAGS) -fPIC $(CFLAGS) $(INCLUDE) -c $< -o $*.$(AXXIA_RTE_TARGET).o
else
  ifeq ($(LIB_EXT),.so)
	$(ADK_Q)$(CC) $(CFLAGS_COMMON) $(FLAGS) $(CFLAGS) $(CFLAGS_COMMON_SHARED) $(INCLUDE) -c $< -o $*.$(AXXIA_RTE_TARGET).o
  else
	$(ADK_Q)$(CC) $(CFLAGS_COMMON) $(FLAGS) $(CFLAGS) $(CFLAGS_COMMON_STATIC) $(INCLUDE) -c $< -o $*.$(AXXIA_RTE_TARGET).o
  endif
endif

$(LIBTOOL_OBJSDIR)/%.$(AXXIA_RTE_TARGET)_static.d $(LIBTOOL_OBJSDIR)/%.$(AXXIA_RTE_TARGET)_static.o: %.c
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	$(LIBTOOL_COMPILE_COMMAND) $(CC) $(CFLAGS_COMMON) $(FLAGS) $(LIBTOOL_COMPILE_FLAGS) $(CFLAGS) $(INCLUDE) -c $< -o $*.$(AXXIA_RTE_TARGET)_static.o
else
	$(ADK_Q)$(CC) $(CFLAGS_COMMON) $(FLAGS) $(CFLAGS) $(CFLAGS_COMMON_STATIC) $(INCLUDE) -c $< -o $*.$(AXXIA_RTE_TARGET)_static.o
endif


depend: $(MODULE_DEPS)

ifeq "$(MAKECMDGOALS)" "debug"
-include $(MODULE_DEPS)
endif
ifeq "$(MAKECMDGOALS)" "release"
-include $(MODULE_DEPS)
endif
ifeq "$(MAKECMDGOALS)" "code"
-include $(MODULE_DEPS)
endif
ifeq "$(MAKECMDGOALS)" "lint"
-include $(MODULE_DEPS)
endif
