#
# Makefile for Unix targets
#
# $Revision: 3a0e9a9f379004e404ee36177d516461a78e601f $
#


LIBTOOL_OBJSDIR=.
VERSION_MAK=
ifeq ($(ADK_USE_LIBTOOL),TRUE)
    include ./version.mak
VERSION_MAK=version.mak
LIBTOOL_OBJSDIR=.libs
endif

SYMBOL_VERSION_MAP=
ifeq ($(ADK_USE_SYMBOL_VERSION),TRUE)
  ifneq (x$(wildcard symbol.map),x)
    SYMBOL_VERSION_MAP=symbol.map
  endif
endif

ifeq (x$(SUBDIRS),x)
SUBDIRS= \
		 include \
		 src
endif

MODULE_LIBRARY_OBJ=$(MODULE_LIBRARY).$(AXXIA_RTE_TARGET)

OBJS?= $(call find-objects-list)
MODULE_LIB_DEPS=$(OBJS)


OBJS_SHARED?= $(call find-objects-shared-list)
MODULE_LIB_SHARED_DEPS=$(OBJS_SHARED)

OBJS_STATIC?= $(call find-objects-static-list)
MODULE_LIB_STATIC_DEPS=$(OBJS_STATIC)

export FLAGS

all: debug

release: FLAGS=$(RELFLAGS)
release: install_hdrs
	+@BUILD_RULE=$@; $(SUBDIRS_BUILD)
	$(ADK_Q)$(MAKE) $% install

code: FLAGS=$(RELFLAGS)
code: install_hdrs
	+@BUILD_RULE=$@; $(SUBDIRS_BUILD)
	$(ADK_Q)$(MAKE) $% install

debug: FLAGS=$(DBGFLAGS)
debug: install_hdrs
	+@BUILD_RULE=$@; $(SUBDIRS_BUILD)
	$(ADK_Q)$(MAKE) $% install


install: $(MODULE_LIBRARY_OBJ)$(LIB_EXT) $(MODULE_LIBRARY_OBJ)_dp.a
	$(ADK_Q)mkdir -p $(ADK_LIBDIR)
	$(ADK_Q)$(RM) $(ADK_LIBDIR)/$(MODULE_LIBRARY).*
ifneq (x$(MODULE_LIBRARY_OLD), x)
	$(ADK_Q)$(RM) $(ADK_LIBDIR)/$(MODULE_LIBRARY_OLD).*
endif
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	$(ADK_Q)$(RM) -f $(ADK_LIBDIR)/$(MODULE_LIBRARY_OBJ).*
	$(ADK_Q)$(CP) -pP $(LIBTOOL_OBJSDIR)/$(MODULE_LIBRARY_OBJ)$(LIB_EXT).$(ADK_FILE_VERSION) \
		$(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LIB_EXT).$(ADK_FILE_VERSION)
	$(ADK_Q)$(LN) -s $(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LIB_EXT).$(ADK_FILE_VERSION) \
		$(ADK_LIBDIR)/$(MODULE_LIBRARY_OBJ)$(LIB_EXT).$(ADK_CURRENT_M_AGE)
	$(ADK_Q)$(LN) -s $(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LIB_EXT).$(ADK_FILE_VERSION) \
		$(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LIB_EXT).$(ADK_CURRENT_M_AGE)
	$(ADK_Q)$(LN) -s $(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LIB_EXT).$(ADK_FILE_VERSION) \
		$(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LIB_EXT)
	$(ADK_Q)$(CP) -pP $(MODULE_LIBRARY_OBJ)$(LA_EXT) \
		$(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LA_EXT)
	$(ADK_Q)$(CP) -pP $(LIBTOOL_OBJSDIR)/$(MODULE_LIBRARY_OBJ)$(LA_EXT)i \
		$(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LA_EXT)i
else
  ifneq (x$(MODULE_LIB_SHARED_DEPS), x)
	$(ADK_Q)$(CP) -f $(MODULE_LIBRARY_OBJ)$(LIB_EXT) $(ADK_LIBDIR)/$(MODULE_LIBRARY)$(LIB_EXT)
    ifneq (x$(MODULE_LIBRARY_OLD), x)
	    $(ADK_Q)$(CP) -f $(MODULE_LIBRARY_OBJ)$(LIB_EXT) $(ADK_LIBDIR)/$(MODULE_LIBRARY_OLD)$(LIB_EXT)
    endif
  endif
  ifneq (x$(MODULE_LIB_STATIC_DEPS), x)
	$(ADK_Q)$(CP) -f $(MODULE_LIBRARY_OBJ)_dp.a $(ADK_LIBDIR)/$(MODULE_LIBRARY)_dp.a
    ifneq (x$(MODULE_LIBRARY_OLD), x)
	  $(ADK_Q)$(CP) -f $(MODULE_LIBRARY_OBJ)_dp.a $(ADK_LIBDIR)/$(MODULE_LIBRARY_OLD)_dp.a
    endif
  endif
endif

ifeq ($(ADK_USE_LIBTOOL),TRUE)
$(MODULE_LIBRARY_OBJ)$(LIB_EXT): $(MODULE_LIB_DEPS) $(VERSION_MAK) $(SYMBOL_VERSION_MAP)
  ifneq (x$(MODULE_LIB_SHARED_DEPS), x)
	$(ADK_Q)$(RM) -f $(MODULE_LIBRARY_OBJ)$(LA_EXT)
	$(ADK_Q)$(LIBTOOL_LINK_COMMAND) $(CC) $(CFLAGS_COMMON) $(FLAGS) $(CFLAGS) -shared \
		-o $(MODULE_LIBRARY_OBJ)$(LA_EXT) \
		$(LIBTOOL_LINK_FLAGS) $(MODULE_LIB_DEPS)
	$(ADK_Q)$(LN) -s $(LIBTOOL_OBJSDIR)/$(MODULE_LIBRARY_OBJ)$(LIB_EXT) .
  endif

else
$(MODULE_LIBRARY_OBJ)$(LIB_EXT): $(MODULE_LIB_SHARED_DEPS) $(VERSION_MAK) $(SYMBOL_VERSION_MAP)
  ifneq (x$(MODULE_LIB_SHARED_DEPS), x)
	$(ADK_Q)$(RM) -f $(MODULE_LIBRARY_OBJ)$(LIB_EXT)
    ifeq ($(LIB_EXT),.so)
	$(ADK_Q)$(CC) $(ADK_LDFLAGS) $(CFLAGS_COMMON) $(FLAGS) $(CFLAGS) $(CFLAGS_COMMON_SHARED) $(LDFLAGS) -o $@ $(MODULE_LIB_SHARED_DEPS) -lrt
    else
	$(ADK_Q)$(AR) $(ARFLAGS) $@ $(MODULE_LIB_SHARED_DEPS)
    endif
  endif

endif

$(MODULE_LIBRARY_OBJ)_dp.a: $(MODULE_LIB_STATIC_DEPS) $(VERSION_MAK) $(SYMBOL_VERSION_MAP)
ifneq (x$(MODULE_LIB_STATIC_DEPS), x)
	$(ADK_Q)$(RM) -f $(MODULE_LIBRARY_OBJ)_dp.a
	$(ADK_Q)$(AR) $(ARFLAGS) $@ $(MODULE_LIB_STATIC_DEPS)
endif


install_hdrs  mklinks  rmlinks:
	+$(ADK_Q)BUILD_RULE=$@; $(SUBDIRS_BUILD)

clobber:
	-$(ADK_Q)$(RM) -f $(MODULE_LIBRARY).*
ifneq (x$(MODULE_LIBRARY_OLD), x)
	-$(ADK_Q)$(RM) -f $(MODULE_LIBRARY_OLD).*
endif
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	-$(ADK_Q)$(RM) -rf $(LIBTOOL_OBJSDIR)/
endif
	+@BUILD_RULE=$@; $(SUBDIRS_BUILD)

clean clean-c:
	-$(ADK_Q)$(RM) -f $(MODULE_LIBRARY_OBJ)$(LIB_EXT) $(MODULE_LIBRARY_OBJ)_dp.a
ifneq (x$(MODULE_LIBRARY_OLD), x)
	-$(ADK_Q)$(RM) -f $(MODULE_LIBRARY_OLD).$(AXXIA_RTE_TARGET).*
endif
ifeq ($(ADK_USE_LIBTOOL),TRUE)
	-$(ADK_Q)$(RM) -rf $(LIBTOOL_OBJSDIR)/*.$(AXXIA_RTE_TARGET)*
endif
	+@BUILD_RULE=$@; $(SUBDIRS_BUILD)
