/* ***************************************************************************
 **                                                                          *
 ** INTEL CONFIDENTIAL                                                       *
 ** Copyright 2011 - 2018 Intel Corporation All Rights Reserved.             *
 **                                                                          *
 ** The source code contained or described herein and all documents related  *
 ** to the source code ("Material") are owned by Intel Corporation or its    *
 ** suppliers or licensors. Title to the Material remains with Intel         *
 ** Corporation or its suppliers and licensors. The Material contains trade  *
 ** secrets and proprietary and confidential information of Intel or its     *
 ** suppliers and licensors. The Material is protected by worldwide          *
 ** copyright and trade secret laws and treaty provisions. No part of the    *
 ** Material may be used, copied, reproduced, modified, published, uploaded, *
 ** posted, transmitted, distributed, or disclosed in any way without        *
 ** Intel's prior express written permission.                                *
 **                                                                          *
 ** No license under any patent, copyright, trade secret or other            *
 ** intellectual property right is granted to or conferred upon you by       *
 ** disclosure or delivery of the Materials, either expressly, by            *
 ** implication, inducement, estoppel or otherwise. Any license under such   *
 ** intellectual property rights must be express and approved by Intel       *
 ** in writing.                                                              *
 **                                                                          *
 ** **************************************************************************
 **/
/*!
 **
 **     $HeadURL$
 **     $Revision$
 **     $Date$
 **
 **  This file contains the source code for adkSifStats utility
 **
 ***********************************************************************/

#include <stdio.h>
#include "adk_sys.h"

int main(int argc, char *argv[])
{
    adk_status_t ret;
    adk_sys_version_info_t adk_version;

    if (((argc > 2)) ||
        ((argc == 2) && (strncmp(argv[1], "--debug", 7)) != 0))
    {
        printf("Usage: %s [-h|--help] [--debug]\n", argv[0]);
        return 1;
    }

    if (argc == 1)
    {
        ret = adk_sys_adk_version_info_get(NULL, &adk_version);
        if (ret != ADK_SUCCESS)
        {
            printf("Error: Failed to get ADK version info!\n");
            return 1;
        }

        printf("ADK Release Version:                         %s\n",
               adk_version.adk_version);
        printf("ADK Release Date:                            %s\n",
               adk_version.adk_release_date);
        printf("ADK Build Date:                              %s\n",
               adk_version.adk_build_date);
        printf("ADK SCM Tag:                                 %s\n",
               adk_version.adk_scm_tag);
        printf("RTE API Library Version used to build ADK:   %s\n",
               adk_version.adk_rte_version);
        printf("ADK / NetD FP Intf Version:                  %s\n",
               adk_version.adk_netd_fp_intf);

    } else if (argc == 2)
    {
        ret = adk_sys_adk_version_info_get(NULL, &adk_version);
        if (ret != ADK_SUCCESS)
        {
            printf("Error: Failed to get ADK version info!\n");
            return 1;
        }

        printf("ADK Release Version:                         %s\n",
               adk_version.adk_version);
        printf("ADK Release Date:                            %s\n",
               adk_version.adk_release_date);
        printf("ADK Build Date:                              %s\n",
               adk_version.adk_build_date);
        printf("ADK SCM Tag:                                 %s\n",
               adk_version.adk_scm_tag);
        printf("RTE API Library Version used to build ADK:   %s\n",
               adk_version.adk_rte_version);
        printf("ADK / NetD FP Intf Version:                  %s\n",
               adk_version.adk_netd_fp_intf);
    }

    return 0;
}
